/**
 * UFRGS - II - PPGC - MESTRADO EM CIENCIA DA COMPUTACAO
 * AUTORA MANUELE KIRSCH PINHEIRO
 * INTERFACE UI_GUIElement
 * PACOTE INTERFACE
 * DATA DE CRIACAO 15 / 11 / 2000
 */

package BW.Interface;

import BW.kernel.*;

import java.awt.*;
import java.awt.event.*;


/**
 * A interface UI_GUIElement e o elemento basico para
 * a construcao da interface com o usuario. Ela deve manter
 * a lista dos UI_GUIEvents correspondente a cada tipo de evento.
 * @see UI_GUIEvent
 * @author Manuele Kirsch Pinheiro
 * @version 1.0
 */
public interface UI_GUIElement extends ItemListener {
	
	/** Mensagem alertando o elemento de interface sobre a
	 * disponibilidade de mais informacoes de awareness
	 */
	public void Notify ();
	
	/** Mensagem para integracao do elemento ao groupware.
	 * Heranca da interface ItemListener
	 */
        public void itemStateChanged(ItemEvent e);

        /** Seta o gerente de interface, responsavel pela
         * ligacao entre o elemento de interface e o framework BW
         * @see UI_Interface
         */
        public void setUI_Interface(UI_Interface ui);

        /** Retorna o gerente de interface em uso atualmente */
        public UI_Interface getUI_Interface ();

        /** Adiciona uma nova GUI responsavel pela apresentacao
         * de um certo tipo de evento.
         * @see UI_GUIEvent
         */
        public void addUI_GUIEvent (UI_GUIEvent guievt, BW_Event prototype);

        /** Mensagem indicando a necessidade de apresentacao
         * grafica do elemento de interface
         */
        public void Show();

       /** Mensagem indicando a necessidade do elemento de interface
        * se ocultar temporariamente.
        */
        public void Hide();

        /** Verifica se o elemento esta visivel */
        public boolean IsVisible();

        /** seta o item de menu integrado a interface do groupware,
         * relacionado a este elemento de interface
         */
        public void setMenuItem (MenuItem menuItem);
}