/**
 * UFRGS - II - PPGC - MESTRADO EM CIENCIA DA COMPUTACAO
 * AUTORA MANUELE KIRSCH PINHEIRO
 * CLASSE UI_Interface
 * PACOTE INTERFACE
 * DATA DE CRIACAO 15 / 11 / 2000
 */

package BW.Interface;

import BW.*;
import BW.kernel.*;
import java.util.*;
import BW.UML.*;


/**
 * A classe UI_Interface age como controladora da apresentacao
 * das informacoes de awareness para o usuario. Ela mantem as
 * referencias para os elementos de interface que realmente
 * implementam a interface, e faz as chamadas as demais camadas
 * do framework BW, em busca das informacoes de awareness.
 * @see UI_GUIElement
 * @author Manuele Kirsch Pinheiro
 * @version 1.0
 */
public class testeGUI extends UI_Interface {

	
	BW_Member memb;
	//////////////////////////// CONSTRUTOR //////////////////////
	
      public testeGUI () {
         UI_elements = new Hashtable();
	   act_member = null;
	   control = null;
	   initMember();
      } 


	public static void main (String args[]) {
		testeGUI tgui = new testeGUI();
            AwarenessMainWindow AMW = new AwarenessMainWindow (tgui);
		
		AMW.Notify();
		AMW.Show();
		
	}
	
	
	////////////////////////////  METODOS /////////////////////////
	
	
		
	/** Retorna as informacoes do membro ativo no momento
	 * @return BW_Member	informacoes do membro ativo
	 */
	public BW_Member getMember () {
		return act_member;
	}

	public void initMember() {
		
        memb = new BW_Member ("teste1",501);
   	memb.setName ("Usuario de teste 1");
   	memb.setMail ("teste1@localhost");
   	memb.setHomePage ("http://localhost/~teste1/");
   	memb.setMachine ("localhost");   	
   	
   	Calendar c1teste1 = Calendar.getInstance ();
   	Calendar c2teste1 = Calendar.getInstance ();
   	c1teste1.set ( 2001, 0, 10, 9, 0, 0 );
   	c2teste1.set ( 2001, 0, 15, 15, 0, 0);
   	BW_TimeInterval titeste1 =  new BW_TimeInterval (0,0,c1teste1,c2teste1);
   	memb.setLastLogin (titeste1);
   	
   	BW_AwarenessProfile apteste1 = memb.getAwarenessProfile();
   	apteste1.setTypeId (typeIdDefault.BW_AWARENESSPROFILE);
   	apteste1.setObjId (3000);
   	BW_Profile PPteste1 = new BW_Profile (typeIdDefault.BW_PERSONALPROFILE,3001);
        BW_Event e101 = new BW_Event (101,typeIdDefault.UNSET);
        PPteste1.insertEvent (e101);
        apteste1.insertPersonalProfile (PPteste1);
        memb.setAwarenessProfile(apteste1);

        BW_Paper max = new BW_Paper (typeIdDefault.BW_PAPER,3004);
        max.setLevel (BW_Paper.MAXIMUM);
        max.setName ("MAX");
        max.setDescription ("Max paper");
        BW_Profile PPmax = new BW_Profile (typeIdDefault.BW_PAPERPROFILE,3006);
        BW_Event e104 = new BW_Event (104,typeIdDefault.UNSET);
        PPmax.insertEvent (e104);
        max.setProfile (PPmax);

        BW_Profile PPmaxteste1 = new BW_Profile (typeIdDefault.BW_PERSONALPAPERPROFILE, 3002);
        BW_Event e102 = new BW_Event (102,typeIdDefault.UNSET);
        PPmaxteste1.insertEvent (e102);

        memb.insertPaper (max,PPmaxteste1);

        BW_Paper min = new BW_Paper (typeIdDefault.BW_PAPER,3005);
        min.setLevel (BW_Paper.MINIMUM);
        min.setName ("MIN");
        min.setDescription ("Min paper");
        BW_Profile PPmin = new BW_Profile (typeIdDefault.BW_PAPERPROFILE,3007);
        min.setProfile (PPmin);

        BW_Profile PPminteste1 = new BW_Profile (typeIdDefault.BW_PERSONALPAPERPROFILE, 3003);
        BW_Event e103 = new BW_Event (103,typeIdDefault.UNSET);
        PPminteste1.insertEvent (e103);

        memb.insertPaper (min,PPminteste1);
        memb.insertPersonalProfile(PPmin);

        memb.setActivePaper (min);       
	act_member = memb;
              
	}

		
	/** Retorna as informacoes completas de um membro em especifico
	 * @param BW_Member memb	membro que se deseja buscar. Precisa
	 *				estar, no minimo, com o uid setado.
	 * @see BW.kernel.BW_Member
	 * @return BW_Member	informacoes completas sobre um membro
	 *			null se o membro nao existir
	 */	
	public BW_Member getMemberInfo (BW_Member memb) {
		return memb;
	}
	
	/** Altera as informacoes de um membro especifico.
	 * @param BW_Member	membro a ser alterado
	 */
	public void setMemberInfo (BW_Member member) {
		this.memb = (BW_Member)member.clone();
		act_member = memb;
	}

		
	/** Retorna o grupo ativo no sistema
	 * @return BW_Group	grupo do sistema
	 */
	public BW_Group getGroup () {
		BW_Group grp = new BW_Group("teste",typeIdDefault.BW_GROUP);
        	grp.setDescription ("grupo de teste");
        	
		//criar profile exemplo
        	BW_Event evt = evtTest(1);
        	evt.setTypeId (1001);	evt.setObjId (1001);
		evt.setName ("exemplo");		
        	BW_Profile prof = new BW_Profile ();
        	prof.insertEvent (evt);
		

        	//incluir papel 
         	BW_Paper papel = new BW_Paper (BW_Paper.MAXIMUM, "autor");
         	papel.setDescription ("participante do grupo");
        	papel.setProfile (prof);

		grp.insertPaper (papel);
        	        	
        	//incluir membro
		
		BW_Member teste1 = new BW_Member ("teste2",502);
        	teste1.setName ("Usuario de teste 2");
       		teste1.setMail ("teste1@localhost");
        	teste1.setHomePage ("http://localhost/~teste1/");
        	teste1.setMachine ("localhost");

	        Calendar c1teste1 = Calendar.getInstance ();
        	Calendar c2teste1 = Calendar.getInstance ();
	        c1teste1.set ( 2001, 0, 10, 9, 0, 0 );
        	c2teste1.set ( 2001, 0, 15, 15, 0, 0);
	        BW_TimeInterval titeste1 =  new BW_TimeInterval
(0,0,c1teste1,c2teste1);
	        teste1.setLastLogin (titeste1);
	
		BW_AwarenessProfile apteste1 = teste1.getAwarenessProfile();
        	apteste1.setTypeId (typeIdDefault.BW_AWARENESSPROFILE);
        	apteste1.setObjId (3000);
        	BW_Profile PPteste1 = new BW_Profile
(typeIdDefault.BW_PERSONALPROFILE,3001);
	         BW_Event e101 = new BW_Event
(101,typeIdDefault.UNSET);
	         PPteste1.insertEvent (e101);
        	apteste1.insertPersonalProfile (PPteste1);
        	teste1.setAwarenessProfile(apteste1);

        	BW_Paper max = new BW_Paper (typeIdDefault.BW_PAPER,3004);
        	max.setLevel (BW_Paper.MAXIMUM);
        	max.setName ("MAX");
        	max.setDescription ("Max paper");
        	BW_Profile PPmax = new BW_Profile
(typeIdDefault.BW_PAPERPROFILE,3006);
	         BW_Event e104 = new BW_Event
(104,typeIdDefault.UNSET); 
	        PPmax.insertEvent (e104);
        	max.setProfile (PPmax);

        	BW_Profile PPmaxteste1 = new BW_Profile
(typeIdDefault.BW_PERSONALPAPERPROFILE, 3002); 
	        BW_Event e102 = new
BW_Event (102,typeIdDefault.UNSET);
	 	PPmaxteste1.insertEvent (e102);

        	teste1.insertPaper (max,PPmaxteste1);

        	BW_Paper min = new BW_Paper (typeIdDefault.BW_PAPER,3005);
        	min.setLevel (BW_Paper.MINIMUM);
        	min.setName ("MIN");
        	min.setDescription ("Min paper");
        	BW_Profile PPmin = new BW_Profile
(typeIdDefault.BW_PAPERPROFILE,3007);
	         min.setProfile (PPmin);

        	BW_Profile PPminteste1 = new BW_Profile
(typeIdDefault.BW_PERSONALPAPERPROFILE, 3003); 
	        BW_Event e103 = new
BW_Event (103,typeIdDefault.UNSET); 
	        PPminteste1.insertEvent (e103);

        	teste1.insertPaper (min,PPminteste1);

        	teste1.setActivePaper (max);

        	//v.addElement (teste1);

///////////////////////////////////////////////////////////////////////////

        BW_Member teste2 = new BW_Member ("teste3",510);
        teste2.setName ("Usuario de teste 3");

        BW_AwarenessProfile apteste2 = teste2.getAwarenessProfile();
        apteste2.setTypeId (typeIdDefault.BW_AWARENESSPROFILE);
        apteste2.setObjId (3010);
        teste2.setAwarenessProfile(apteste2);

        BW_Profile PPminteste2 = new BW_Profile (typeIdDefault.BW_PERSONALPAPERPROFILE, 3011);
        //BW_Event e103 = new BW_Event (103,typeIdDefault.UNSET);
        PPminteste2.insertEvent (e103);

        teste2.insertPaper (min,PPminteste2);

        //v.addElement (teste2);

	


		//grp.insertMember (mb);
		grp.insertMember (memb);
		grp.insertMember (teste1);
		grp.insertMember (teste2);
        
		return grp;
	}
	

      public BW_Event evtTest (int evento) {
	      BW_Event evt = null;
        	String login = System.getProperty ("user.name");
		int uid = 150;
        	BW_Member mb = new BW_Member (login, uid);
	        BW_TimeInterval tmi = new BW_TimeInterval(typeIdDefault.BW_TIMEINTERVAL,typeIdDefault.BW_TIMEINTERVAL*10+3);
	        Calendar c = tmi.getBegin();
	        c.roll (Calendar.DATE,false);
                tmi.setBegin (c);

        	mb.setName ((mb.getLogin()).toUpperCase()+" ETC");
			mb.setMail ((login+"@localhost"));
			mb.setHomePage (("http://localhost/~"+login));
			mb.setMachine ("localhost");
			mb.setLastLogin (tmi);

	        tmi = new BW_TimeInterval(typeIdDefault.BW_TIMEINTERVAL,typeIdDefault.BW_TIMEINTERVAL*10+4);
	        c = tmi.getBegin();
	        c.roll (Calendar.HOUR,false);
                tmi.setBegin (c);
		switch (evento) {
			case 1:
			{
				evt = new BW_Event (UML_BW_Mediator.NEWRELATION,UML_BW_Mediator.NEWRELATION,mb);
				evt.setName ("NEWRELATION");
	        	evt.setDescription ("NEWRELATION");
				evt.setDetails ("A new relation has been created");
				evt.setInterval (tmi);
      		break;
			}
			case 2:
			{
				evt = new BW_Event (UML_BW_Mediator.RELATIONEDITED,UML_BW_Mediator.RELATIONEDITED,mb);
				evt.setName ("RELATIONEDITED");
	        	evt.setDescription ("RELATIONEDITED");
				evt.setDetails ("A relation was edited");
				evt.setInterval (tmi);
      		break;
			}
			case 3:
			{
				evt = new BW_Event (UML_BW_Mediator.CLASSEDITED,UML_BW_Mediator.CLASSEDITED,mb);
				evt.setName ("CLASSEDITED");
	        	evt.setDescription ("CLASSEDITED");
				evt.setDetails ("A class was edited");
				evt.setInterval (tmi);
      		break;
			}
			case 4:
			{
				evt = new BW_Event (UML_BW_Mediator.NEWCLASS,UML_BW_Mediator.NEWCLASS,mb);
				evt.setName ("NEWCLASS");
	        	evt.setDescription ("NEWCLASS");
				evt.setDetails ("A new class has been created");
				evt.setInterval (tmi);
      		break;
			}
		}
		return evt;		
	}

	
	/** Busca os eventos de interesse do usuario ativo no momento.
	 * @param UI_GUIElement gui	elemento de interface que esta
	 *				fazendo a chamada
	 * @return Vector	vetor de BW_Events com todos os eventos
	 *			de acordo com os profiles do usuario
	 * @see BW.kernel.BW_Event
	 * @see BW.kernel.BW_Member#profiles
	 */		 				
	public Vector getEvents (UI_GUIElement gui) {
	     Vector res = new Vector();
           res.addElement((BW_Event)evtTest(1).clone());
           res.addElement((BW_Event)evtTest(2).clone());
		res.addElement((BW_Event)evtTest(3).clone());
		res.addElement((BW_Event)evtTest(4).clone());
		res.addElement((BW_Event)evtTest(3).clone());
		res.addElement((BW_Event)evtTest(2).clone());
		res.addElement((BW_Event)evtTest(3).clone());
		res.addElement((BW_Event)evtTest(4).clone());
		res.addElement((BW_Event)evtTest(4).clone());
		res.addElement((BW_Event)evtTest(4).clone());
	
	     return res;	
	}
	
	
	public String mountKey (BW_Event obj) {
		   Class classe = obj.getClass();
		   StringBuffer key = new StringBuffer();
		   key.append ((obj.getClass().getName()).toUpperCase());
		   key.append("-");
		   key.append(obj.getTypeId());	         	
		   return key.toString();
	}
		
}