/**
* UFRGS - II - PPGC - MESTRADO EM CIENCIA DA COMPUTACAO
* AUTOR LUIZ ANGELO BARCHET ESTEFANEL
* CLASSE AwarenessGroupInfoWindow
* PACOTE BW.UML
* DATA DE CRIACAO 16 / 01 / 2001
*/

package BW.UML;

import java.awt.*;
import java.awt.event.*;
import BW.kernel.*;
import java.util.*;

/**
* A classe AwarenessGroupInfoWindow exibe informacoes sobre os usuarios do grupo.
* @author Luiz Angelo Barchet Estefanel
* @version 1.0
*/
public class AwarenessGroupInfoWindow extends Frame implements WindowListener, ItemListener {

   ////////////////////////// ATRIBUTOS
   
   /** variavel que contem os dados do grupo
   */
   private BW_Group group;

   /** vetor que contem os membros do grupo
   */
   private Vector members;
   
   /** Variaveis da Interface grafica
   */
      private Frame memberInfo;
      private Panel background;
      private Panel North;
      private Panel Center;
      private Label Title;
      private List userList;
      private TextArea userInfo;      

   ////////////////////////// CONSTRUTOR  
   
   /**
	 * Construtor
	 * @param BW_Group group	grupo de onde serao obtidas as informacoes
	 */

   public AwarenessGroupInfoWindow (BW_Group group) {
      super("Search Info - " + group.getName() + "'s Members");
      this.group = group;

      this.setSize(300, 250);
      addWindowListener (this);
      
	userList = new List (12);
	members = mountList();
	for (int i=0; i<members.size(); ++i)
	   userList.add(((BW_Member)members.elementAt(i)).getName());
      add(userList);
	userList.addItemListener(this);
      setVisible(true);
   }


   ////////////////////////  METODOS

   /** metodo mountList: gera a lista de usuarios do grupo
    * @return Vector lista de usuarios do grupo
    */
   public Vector mountList () {
      Vector list = new Vector();
      BW_Member target;
      Hashtable memberList = group.getMembers();
      Enumeration e1 = memberList.elements();
	   while (e1.hasMoreElements()) {
		    target = (BW_Member) e1.nextElement();
		    list.addElement(target);
		 }
      
      return (Vector)list.clone();
   }

	/**
	 * metodo showMemberInfo: exibe informacoes especificas sobre um membro selecionado
	 * @param int index	indice do usuario, na lista de exibicao
	 */
   public void showMemberInfo (int index) {
      int selected = index;
      Hashtable info = getMemberInfo(selected);
      memberInfo = new Frame ("Member Info");
      memberInfo.addWindowListener(this);
      memberInfo.setSize(300,200);
      userInfo = new TextArea();
      userInfo.setEditable(false);
      memberInfo.add(userInfo);
      String temp = (String)info.get("login");
      userInfo.append("Login: " + temp + "\n");
      temp = (String)info.get("UID");
      userInfo.append("UID: " + temp + "\n");
      temp = (String)info.get("name");
      userInfo.append("Name: " + temp + "\n"); 
      temp = (String)info.get("mail");
      userInfo.append("Mail: " + temp + "\n");
      temp = (String)info.get("homepage");
      userInfo.append("Homepage: " + temp + "\n");
      temp = (String)info.get("machine");
      userInfo.append("Machine: " + temp + "\n");
      try {
      	userInfo.append("LastLogin: " + (BW_TimeInterval)info.get("lastlogin") + "\n");
      } catch (NullPointerException ex) {
      	userInfo.append("LastLogin: \n");
      }
      try {
      	Hashtable paperList = (Hashtable)info.get("papers");
      	Enumeration en = paperList.keys();
      	BW_Paper pap;
      	temp = new String ("Paper(s): ");
			while (en.hasMoreElements()) {
				pap = (BW_Paper) en.nextElement();
				if (en.hasMoreElements())
					temp = temp.concat(pap.getName() + ", ");
				else
					temp = temp.concat(pap.getName() + ".");
			}
			userInfo.append(temp + "\n");
      } catch (NullPointerException ex) {
      	userInfo.append("Paper(s): \n");
      }
      memberInfo.setVisible(true);
   }


	/**
	 * obtem as informacoes de um usuario selecionado
	 * @param int i indice do usuario, na lista de exibicao
	 * @see TimeInterval
	 */

   public Hashtable getMemberInfo (int i) {
        Hashtable hash = new Hashtable();
	BW_Member displayed = (BW_Member)members.elementAt(i);
	hash.put("login",displayed.getLogin());
	hash.put("UID",String.valueOf(displayed.getObjId()));
	hash.put("name",displayed.getName());
	hash.put("mail",displayed.getMail());
	hash.put("homepage",displayed.getHomePage());
	hash.put("machine",displayed.getMachine());
	try {
	   hash.put("lastlogin",displayed.getLastLogin());
	} catch (NullPointerException ex) {}
	try {
	   hash.put("papers",displayed.getPapers());
	} catch (NullPointerException ex) {}
	
      return hash;
   }


	////////// metodo do ItemListener

   public void itemStateChanged (ItemEvent e) {
      int selected = ((Integer)e.getItem()).intValue();
      showMemberInfo(selected); 
   }


	/////////// metodos do WindowListener

   public void windowClosing (WindowEvent evt){
	Frame closedObject = (Frame)evt.getWindow();
        if (closedObject==this)
        {
           if (memberInfo!=null)
           {
              memberInfo.setVisible(false);
              memberInfo.dispose();
           }
        }
        closedObject.setVisible(false);
	closedObject.dispose();
   }



   public void windowClosed (WindowEvent evt) {
   }

   public void windowOpened (WindowEvent evt) {
   }

   public void windowIconified (WindowEvent evt) {
   }

   public void windowActivated (WindowEvent evt) {
   }

   public void windowDeactivated (WindowEvent evt) {
   }

   public void windowDeiconified (WindowEvent evt) {
   }

   public void actionPerformed (WindowEvent evt) {
   }

}