/**
 * UFRGS - II - PPGC - MESTRADO EM CIENCIA DA COMPUTACAO
 * AUTOR LUIZ ANGELO BARCHET ESTEFANEL
 * CLASSE ClickBar
 * PACOTE BW.UML.ClickBar
 * DATA DE CRIACAO 16 / 01 / 2001
 */

package BW.UML.ClickBar;

import java.awt.*;
import java.awt.event.*;
import java.util.*;

/**
 * classe Chart2 grafico de barras clicavel
 * @author Luiz Angelo Barchet Estefanel
 * @version 1.0
 */
public class Chart2 extends java.awt.Component {

    static final int	VERTICAL = 0;
    static final int 	HORIZONTAL = 1;
    static final int	SOLID = 0;
    static final int	STRIPED = 1;
    int			orientation;
    String		title = "";
    String 		Orientation = "HORIZONTAL";
    String 		Title;
    Vector		objs;
     Font		titleFont;
    FontMetrics		titleFontMetrics;
    int			titleHeight = 15;
    int			columns;
    int			values[];
    Object		colors[];
    Object		labels[];
    int			styles[];
    int 		posx[][];
    int			posy[][];
    int			scale = 10;
    int			maxLabelWidth = 0;
    int			barWidth;
    int			barSpacing = 10;
    int			max = 0;
    int 		graphicX = 300;
    int 		graphicY = 200;

    
   /** Construtor
	 *  @param Vector objs Lista de eventos (objetos) que serao exibidos no grafico
    *  @param String Title titulo do grafico
    *  @param String Orientation orientacao do grafico (vertical ou horizontal)
    *  @param int x tamanho da janela no eixo x
    *  @param int y tamanho da janela no eixo y
    */

    public Chart2 (Vector objs, String Title, String Orientation, int x,int y)
    {
	this.objs = (Vector)objs.clone();
	//this.setVisible(false);
	this.Title = Title;
 	this.Orientation = Orientation;
	graphicX = x;
	graphicY = y;
	getParameters();
      
	MouseListener clickPuck = new MouseClick();
        ((MouseClick)clickPuck).setNotifiable(this);
	addMouseListener(clickPuck);

	repaint();
    }


	/** Construtor
	 *  @param Vector objs Lista de eventos (objetos) que serao exibidos no grafico
    *  @param String Title titulo do grafico
    *  @param String Orientation orientacao do grafico (vertical ou horizontal)
    */

    public Chart2 (Vector objs, String Title, String Orientation)
    {
	this.objs = (Vector)objs.clone();
	this.Title = Title;
 	this.Orientation = Orientation;
        getParameters();
	
	MouseListener clickPuck = new MouseClick();
        ((MouseClick)clickPuck).setNotifiable(this);
	addMouseListener(clickPuck);
	repaint();
	this.setVisible(true);
    }

    
    /** atualiza o grafico de barras, com novos valores
	 *  @param Vector objs Lista de eventos (objetos) que serao exibidos no grafico
    */
    public void setObjects(Vector objs)
    {
       this.objs = (Vector)objs.clone();
       getParameters();
       repaint();
    }


   /** retorna o tamanho atual do grafico de barras
	 *  @return Dimension 
    */
	public Dimension getPreferredSize() {
        return new Dimension(graphicX, graphicY);
    }



	/** getParameters: extrai os dados de cada elemento do grafico de barras
    */	
    public void getParameters () {

       String rs = null;
	
	titleFont = new java.awt.Font("Courier", Font.BOLD, 12);
	titleFontMetrics = getFontMetrics(titleFont);
	//title = getParameter("title");
        title = Title; 
	if (title == null) {
	    title = "Chart";
	}


        columns = objs.size();


        rs = Orientation;
	if (rs == null) {
	    orientation = VERTICAL;
	} else if (rs.toLowerCase().equals("vertical")) {
	    orientation = VERTICAL;
	} else if (rs.toLowerCase().equals("horizontal")) {
	    orientation = HORIZONTAL;
	} else {
	    orientation = VERTICAL;
	}
	values = new int[columns];
	colors = new Color[columns];
	labels = new String[columns];
	styles = new int[columns];
	posx = new int[columns][2];
	posy = new int[columns][2];
	for (int i=0; i < columns; i++) {
	    // parse the value for this column
	    //rs = getParameter("C" + (i+1));
	    rs = ((ClickableBar)objs.elementAt(i)).getValue();
	    if (rs != null) {
		try {
		    values[i] = Integer.parseInt(rs);
		} catch (NumberFormatException e) {
		    values[i] = 0;
		}
	    }
	    if (values[i] > max) {
		max = values[i];
	    }

	    // parse the label for this column
	    rs = ((ClickableBar)objs.elementAt(i)).getLabel();
	    labels[i] = (rs == null) ? "" : rs;
	    maxLabelWidth = Math.max(titleFontMetrics.stringWidth((String)(labels[i])),
				     maxLabelWidth);

	    // parse the bar style
	    rs = ((ClickableBar)objs.elementAt(i)).getStyle();
	    if (rs == null || rs.toLowerCase().equals("solid")) {
		styles[i] = SOLID;
	    } else if (rs.toLowerCase().equals("striped")) {
		styles[i] = STRIPED;
	    } else {
		styles[i] = SOLID;
	    }

	    // parse the color attribute for this column
	    colors[i] = ((ClickableBar)objs.elementAt(i)).getColor();
	    if (colors[i]==null)
		colors[i] = Color.gray;
	}
	switch (orientation) {
	  case VERTICAL:
	  default:
	    barWidth = 2*maxLabelWidth;
          graphicX = Math.max(columns * (barWidth + barSpacing),
			    titleFontMetrics.stringWidth(title)) +
		  	    titleFont.getSize() + 5;
	    //graphicY = (max * scale) + (2 * titleFont.getSize()) + 5 + titleFont.getSize();
	    setSize(graphicX,graphicY);
            scale = (graphicY - ((2 * titleFont.getSize()) + 5 + titleFont.getSize()))/max;
	    break;
	  case HORIZONTAL:
	    barWidth = 2*titleFont.getSize();
	    //graphicX = Math.max((max * scale) + titleFontMetrics.stringWidth("" + max),
	    //	    titleFontMetrics.stringWidth(title)) + maxLabelWidth + 5;
	    graphicY = (columns * (barWidth + barSpacing)) + barWidth + titleFont.getSize() + 10;	    
	    setSize(graphicX,graphicY);
	    scale = (graphicX - (titleFontMetrics.stringWidth("" + max) + maxLabelWidth)-25)/max;
	    break;
	}
	
    }


   /** paint - constroi o grafico
     * @param Graphic g
    */
   public synchronized void paint(Graphics g) {
	int i, j;
	int cx, cy;
	char l[] = new char[1];
	// draw the title centered at the bottom of the bar graph
	g.setColor(Color.black);
	i = titleFontMetrics.stringWidth(title);
	g.setFont(titleFont);
	/*g.drawString(title, Math.max((getSize().width - i)/2, 0),
		     getSize().height - titleFontMetrics.getDescent())i;*/
	g.drawString(title, Math.max((getSize().width - i)/2, 0),((barWidth + barSpacing) * columns) + barWidth);
	for (i=0; i < columns; i++) {
	    switch (orientation) {
	      case VERTICAL:
	      default:
		// set the next X coordinate to account for the label
		// being wider than the bar size().width.
		cx = (Math.max((barWidth + barSpacing),maxLabelWidth) * i) +
		    barSpacing;

		// center the bar chart
		cx += Math.max((getSize().width - (columns *
					 (barWidth + (2 * barSpacing))))/2,0);
		
		// set the next Y coordinate to account for the size().height
		// of the bar as well as the title and labels painted
		// at the bottom of the chart.
		cy = getSize().height - (values[i] * scale) - 1 - (2 * titleFont.getSize());

		// draw the label
		g.setColor(Color.black);		
		g.drawString((String)labels[i], cx,
			     getSize().height - titleFont.getSize() - titleFontMetrics.getDescent());

		// draw the shadow bar
		if (colors[i] == Color.black) {
		    g.setColor(Color.gray);
		}
		g.fillRect(cx + 5, cy - 3, barWidth,  (values[i] * scale));
		// draw the bar with the specified color
		g.setColor((Color)(colors[i]));
                posx[i][0] = cx;
                posx[i][1] = cx+barWidth+5;
                posy[i][0] = cy - 3;
                posy[i][1] = cy+(values[i] * scale);
		switch (styles[i]) {
		  case SOLID:
		  default:
		    g.fillRect(cx, cy, barWidth, (values[i] * scale));
		    break;
		  case STRIPED:
		    {
			int steps = (values[i] * scale) / 2;
			int ys;

			for (j=0; j < steps; j++) {
			    ys = cy + (2 * j);
			    g.drawLine(cx, ys, cx + barWidth, ys);
			}
		    }
		    break;
		}
		g.drawString("" + values[i],
			     cx,
			     cy - titleFontMetrics.getDescent());
		break;
	      case HORIZONTAL:
		// set the Y coordinate
		cy = ((barWidth + barSpacing) * i) + barSpacing;
			       
		// set the X coordinate to be the size().width of the widest
		// label 
		cx = maxLabelWidth + 1;

		cx += Math.max((getSize().width - (maxLabelWidth + 1 +
					 titleFontMetrics.stringWidth("" +
							       max) +
					 (max * scale))) / 2, 0);
		// draw the labels and the shadow
		g.setColor(Color.black);		
		g.drawString((String)labels[i], cx - maxLabelWidth - 1,
			     cy + titleFontMetrics.getAscent());
		if (colors[i] == Color.black) {
		    g.setColor(Color.gray);
		}
		g.fillRect(cx + 3,
			   cy + 5,
			   (values[i] * scale),
			   barWidth);

		// draw the bar in the current color
		g.setColor((Color)(colors[i]));
		posx[i][0] = cx;
                posx[i][1] = cx+(values[i] * scale) + 5;
                posy[i][0] = cy;
                posy[i][1] = cy+barWidth+3;
		switch (styles[i]) {
		  case SOLID:
		  default:
		    g.fillRect(cx,
			       cy,
			       (values[i] * scale),
			       barWidth);
		    break;
		  case STRIPED:
		    {
			int steps = (values[i] * scale) / 2;
			int ys;

			for (j=0; j < steps; j++) {
			    ys = cx + (2 * j);
			    g.drawLine(ys, cy, ys, cy + barWidth);
			}
		    }
		    break;
		}
		g.drawString("" + values[i],
			     cx + (values[i] * scale) + 3,
			     cy + titleFontMetrics.getAscent());
			     
		break;
	    }
	}
    }


	/** process - a partir do click do mouse, identifica qual barra foi clicada
	 *  @param int x coordenada do eixo X
	 *  @param int y coordenada do eixo y
	 */ 
   public void process (int x, int y)
   {
	for (int i=0; i<columns; ++i)
        {
           if ((x >= posx[i][0]) && (x <= posx[i][1]))
           {
              if ((y >= posy[i][0]) && (y <= posy[i][1]))
                 ((ClickableBar)objs.elementAt(i)).clickAction();
           }
        }
    }
}