/**
 * UFRGS - II - PPGC - MESTRADO EM CIENCIA DA COMPUTACAO
 * AUTORA MANUELE KIRSCH PINHEIRO
 * CLASSE CL_STARTUP
 * PACOTE BW.CONTROL
 * DATA DE CRIACAO 11 / 01 / 2001
 */

package BW.control;

import java.util.Vector;

import BW.typeIdDefault;
import BW.kernel.*;
import BW.control.*;
import BW.storage.*;


/**
 * classe CL_StartUp e responsavel pela inicializacao
 * da camada de controle, representada pelo pacote
 * control do framework BW.
 * @autor Manuele K P
 * @version 1.0
 */
public class CL_StartUp {


	//////////////////////////////// ATRIBUTOS /////////////////
	
	/** Fachada para as funcoes de monitoramento */
	static FC_CL_Monitor mon;
	
	/** Fachada para as funcoes de contextualizacao */
	static FC_CL_Context cont;
	
	
	//////////////////////////////// METODOS ///////////////////
	
	/** Faz a inicializacao do pacote control
	 *  @param Vector facades	fachadas para o pacote storage
	 *  @see BW.storage.FC_ST_Monitor
	 *  @see BW.storage.FC_ST_Context
	 */
	public static Vector Start (Vector facades) {
	        Vector ret = new Vector();
	
		//inicializa o cl_monitor
		CL_Monitor monitor = new CL_Monitor();
		
		//inicializa o cl_awareness
		CL_Awareness awareness = new CL_Awareness();
		
		//inicializa as fachadas superiores
		mon = new FC_CL_Monitor();
		cont = new FC_CL_Context();
		
		FC_ST_Monitor stmon = null;
		FC_ST_Context stcont = null;
		
		try {
			stmon = (FC_ST_Monitor) facades.firstElement ();
			stcont = (FC_ST_Context) facades.lastElement();
		} catch (ClassCastException cce) {
			stmon = (FC_ST_Monitor) facades.lastElement ();
			stcont = (FC_ST_Context) facades.firstElement();		
		}
		
		//seta as ligacoes entre os objetos
		mon.setCLMonitor (monitor);
		cont.setCLAwareness (awareness);
		stcont.setAwareness (awareness);
		
		monitor.setCLAwareness (awareness);
		//monitor.setFCCLMonitor (mon);		//?
		monitor.setFCSTMonitor (stmon);
		
		awareness.setCLMonitor   (monitor);
		awareness.setFCCLContext (cont);	
		awareness.setFCSTContext (stcont);
		
		
		//le as informacoes da base de dados
                /* BW_Group grp = (BW_Group) stmon.read (new BW_Group(typeIdDefault.BW_GROUP,typeIdDefault.BW_GROUP));
                BW_Register reg = (BW_Register) stmon.read (new BW_Register (typeIdDefault.BW_REGISTER,typeIdDefault.BW_REGISTER));
                monitor.setGroup (grp);
                monitor.setRegister (reg);
                */
                monitor.recall();

                //prepara as informacoes de retorno
                ret.addElement (mon);
                ret.addElement (cont);

                return ret;
	}
	
	
	/** Retorna a fachada para as funcoes de contextualizacao
	 *  @param FC_CL_Context	fachada de contextualizacao
	 */
	public static FC_CL_Context getContextFacade () {
		//retorna fachada de contextualizacao
		return cont;
		//return null;
	
	}

		
	/** Retorna a fachada para as funcoes de monitoramento
	 * @param FC_CL_Monitor		fachada de monitoramento
	 */
	public static FC_CL_Monitor getMonitorFacade () {
		return mon;
		//return null;
	
	}	
}