/**
 * UFRGS - II - PPGC - MESTRADO EM CIENCIA DA COMPUTACAO
 * AUTORA MANUELE KIRSCH PINHEIRO
 * CLASSE BW_Element
 * PACOTE BW.KERNEL
 * DATA DE CRIACAO 11 / 07 / 2000
 */

package BW.kernel;

import java.util.Hashtable;
import BW.typeIdDefault;

/**
 * classe BW_Element e a "classe mae" do pacote kernel
 * definindo funcoes basicas para todos
 * @author Manuele Kirsch Pinheiro
 * @version 1.2
 */
public class BW_Element {

  /** Identificador de tipo - indica o tipo do objeto */
  int typeId;
  /** Identificador do objeto */
  int objId;

  /** metodo construtor: aceita como parametros o
   *  identificador do tipo e do objeto.
   * @param  typeId	id do tipo do objeto
   * @param  objId	id do objeto
   */
  public BW_Element (int typeId, int objId) {
     this.typeId = typeId;
     this.objId = objId;
  }

  //por default, busca o typeId da classe typeIdDefault
  //e o objId eh por default 0
  public BW_Element () {
    typeId = typeIdDefault.BW_ELEMENT;
    objId = typeIdDefault.UNSET;
  }

  /** metodo getTypeId retorna o identificador do
   *  tipo do objeto
   *  @return 	int typeId - id do tipo
   */
  public int getTypeId () {
      return typeId;
  }

  /** metodo getObjId retorna o identificador do objeto
   *  @return int objId - id do objeto
   */
  public int getObjId () {
      return objId;
  }

  /** metodo getFields retorna um Hashtable com os
   * pares (atributo,valor) do objeto
   * @return Hashtable  - atributo,valor
   */
  public Hashtable getFields () {
       	Hashtable ht = new Hashtable();
 	ht.put ("typeId",new Integer(typeId));
 	ht.put ("objId",new Integer(objId));
 	return (ht);
  }

  /** metodo setFields seta os campos do objeto
   * a partir de um Hashtable semelhante ao
   * gerado pelo metodo getFields. Retorna
   * true se tudo correu adequadamente
   * @param Hashtable fields	- novos atributos para o objeto
   * @return	boolean	- true se tudo correu bem, false caso contrario
   * @see #getFields
   */
   public boolean setFields (Hashtable fields) {
         boolean result = false;

         if (fields.containsKey("typeId") && fields.containsKey("objId")) {
               this.typeId = ((Integer)fields.get("typeId")).intValue();
               this.objId = ((Integer)fields.get("objId")).intValue();
               result = true;
         } else result=false;

         return result;

   }

  /**
   * metodo setObjId altera o identificador do objeto
   * @param 	int newId	novo id do objeto
   */
   public void setObjId (int newId) {
       this.objId = newId;
   }

  /**
   * metodo setTypeId altera o identificador do tipo do objeto
   * @param 	int newId	novo id do tipo do objeto
   */
   public void setTypeId (int newId) {
       this.typeId = newId;
   }

  /**
   * metodo clone retorna uma outra instancia de
   * BW_Element com os mesmos atributos desta
   */
   public Object clone() {
      BW_Element ne = new BW_Element (this.getTypeId(),this.getObjId());
      return ((Object)ne);
   }	

  public String toString () {
     	return (this.getFields()).toString();
  }
}

