/**
 * UFRGS - II - PPGC - MESTRADO EM CIENCIA DA COMPUTACAO
 * AUTORA MANUELE KIRSCH PINHEIRO
 * CLASSE ST_IMPLEMENTOR
 * PACOTE BW.STORAGE
 * DATA DE CRIACAO 18 / 07 / 2000
 */

package BW.storage;

import BW.kernel.*;
import BW.storage.*;

import java.util.Vector;

//import BW.typeIdDefault;
//import BW.kernel.*;

///////////////////////////////////////////////////////////
//ATENCAO!!!!! FALTAM AINDA INUMEROS METODOS PARA	//
//ABRANGER OS DIVERSOS TIPOS POSSIVEIS DE IMPLEMENTACAO	//
//////////////////////////////////////////////////////////


/**
 * classe ST_Implementor descreve as implementacoes do
 * armazenamento dos dados em disco no BW
 * @autor Manuele K P
 * @version 1.0
 */
public abstract class ST_Implementor {
 	
        /** faz leitura de dados
	 * @param 	String what	o que deve ser lido
	 * @return	Vector elementos BW_Element lidos
	 */
	public abstract Vector read (String what);
	
	/** faz a leitura do Setup
	 * @param	ST_Setup set	setup desejado
	 * @return	ST_Setup	setup com os dados atualizados
	 */
	public abstract ST_Setup read (ST_Setup set);
	
	
	/** Le um conjunto de elementos de um determinado tipo
	 * (obrigatoriamente deve ser uma subclasse de BW_Element)
	 * em um determinado intervalo.
	 * @param	BW_Element what		tipo de dado a ser lido
	 * @param	BW_TimeInterval when	intervalo a ser lido
	 */
	 public abstract Vector read (BW_Element what, BW_TimeInterval when);
		
	 /** Le todos os elementos de um determinado tipo
	  * @param	BW_Element what		tipo de dado a ser lido
	  * @return	Vector	todos os dados daquele tipo lidos
	  */
	 public abstract Vector read (BW_Element what);
	
	 /** Le uma unica instancia de um tipo de elemento
	  * @param 	BW_Element what	tipo de dado a ser lido
	  * @param	int objId	identificador do objeto a ser resgatado
	  * @return	BW_Element	objeto lido
	  */
	 public abstract BW_Element read (BW_Element what, int objId); 	

        /** escreve os dados em meio permanente
	 * @param 	String what	o que deve ser escrito
	 * @return 	boolean		true  se foi gravado com exito
	 *				false caso contrario
	 */
	public abstract boolean write (String what);
	
	/** escreve um conjunto de dados em meio permanente.
	 * Estes dados devem obrigatoriamente ser subclasse de BW_Element
	 * @param 	Vector data	Vetor de BW_Elements com os dados a serem gravados
	 * @return	boolean		true se a operacao teve sucesso,
	 *				false caso contrario
	 */
	public abstract boolean write (Vector data);
	
        /** escreve um unico elemento em meio permanente
         * @param	BW_Element what	elemento a ser gravado
         * @return	boolean		true se tudo ocorreu bem
         *				false caso contrario
         */
       public abstract boolean write (BW_Element what);

       /** atualiza ST_Setup na base de dados
        * @param ST_Setup
        */
       public abstract boolean write (ST_Setup set);
	
        /** faz a abertura da base de armazenamento
	 * @return	boolean		true se abriu a base corretamente
	 *				false caso contrario
	 */
	public abstract boolean open ();

        /** fecha e conclui as operacoes sobre a base de dados
	 * @return 	boolean		true  se foi fechado com exito
	 *				false caso contrario
	 */
	public abstract boolean close ();

 	/** retorna o status da base de dados, se esta aberta ou nao
	 *  operacao feita sobre ela
	 * @return	boolean		true - se a base esta ok
	 *				false caso contrario
	 */
	public abstract boolean getStatus ();


}