/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Package: COPSE.CLIENT
 * Classe:  CClientManager
\******************************************************************************/

package COPSE.CLIENT;

import java.io.*;
import java.util.*;
import java.net.*;


import COPSE.*;
import FILE.*;


public class CClientManager
    extends CClient
{
    public CClientManager( int userId, String host, int port )
        throws IOException
    {
        super(userId, host, port);
    }


    protected boolean InitClientConnection()
    {
        if( !super.InitClientConnection() )
            return false;

        pEventHandler = CreateManagerEventHandler();
        pEventHandler.start();

        return true;
    }

    protected CClientManagerEventHandler CreateManagerEventHandler()
    {
        return new CClientManagerEventHandler( this, pEventHandler );
    }


    // This function should be called by the EventHandler thread, and not by the
    // ManagerEventHandler !!!
    public void _Exit()
    {
        System.err.println( "[DEBUG] CClientManager - _Exit:" );
        //super._Exit();
        mExit = true;
        pServerConnector.Close();

        System.err.println( "[DEBUG] CClientManager - Stopping CClientCollaborationManager..." );
        pCollabManager.Exit();

        System.err.println( "[DEBUG] CClientManager - Stopping CClient thread..." );
        this.stop();

        System.err.println( "[DEBUG] CClientManager - Stopping ManagerEventHandler thread..." );
        pEventHandler.stop();

        // At last, stop the current thread...
        System.err.println( "[DEBUG] CClientManager - Stopping EventHandler thread..." );
        ((CClientManagerEventHandler)pEventHandler).GetEventHandler().stop();
    }

}





/*
        mUserId = userId;
        mExit = false;

        // Init Connection to Server
        Socket pSocket = new Socket( host, new Integer(port).intValue() );
        pServerConnector = CSocketStreamConnector.New( pSocket, false );

        // Start Communication to Process Server
        CEvent event = new CEvent( CEvent.EvUserConnection_Open );
        event.AddArgument( new Integer( mUserId ) );
        event.AddArgument( new Integer( GetToolId() ) );
        pServerConnector.Send( event );
        event = pServerConnector.Receive();

        switch( event.GetType() )
        {
            case CEvent.EvUserConnection_Open:
                Integer conn = (Integer) event.GetArgumentAt(0);
                Integer uId  = (Integer) event.GetArgumentAt(1);
                Integer tId  = (Integer) event.GetArgumentAt(2);
                if( (uId.intValue() == mUserId) && (tId.intValue() == GetToolId()) )
                //{
                    mConnId = conn.intValue();

                if( !InitClientConnection() )
                {
                    throw new IOException( "Error on starting client connection to the server" );
                }
                //}
                //else throw
                break;

            case CEvent.EvUserConnection_Error:
                String msg = (String) event.GetArgumentAt(0);
                throw new IOException( msg );

            default:
                throw new IOException( "Invalid server answer to connection request!" );
        }
    }

/*

    protected boolean InitClientConnection()
    {
        CEvent event;

        try {
            // Init Event Handler
            pEventHandler = new CClientEventHandler( this );

            // Init File and FileController
            event = new CEvent( CEvent.EvServer_FileController_Load );
            pServerConnector.Send( event );
            // Processes an event just not to "overflow" the socket
            event = pServerConnector.Receive();
            pEventHandler.ProcessEvent( event );

            // Load Users in Session
            event = new CEvent( CEvent.EvServer_SessionManager_Load );
            pServerConnector.Send( event );
            // Processes an event just not to "overflow" the socket
            event = pServerConnector.Receive();
            pEventHandler.ProcessEvent( event );

        } catch ( IOException e )
        {
            return false;
        };

        return true;
    }

*/


/*
    public void run()
    {
        System.err.println( "DEBUG: Client running..." );
        while( !mExit )
        {
            try{
                CEvent event = pServerConnector.Receive();
                pEventHandler.ProcessEvent( event );
            } catch(IOException ioe)
            {
                if( mExit )
                {
                    // Ok! Exit requested...
                    break;
                }
                else
                {
                    // TODO: Verify if the connection is still alive
                }
            }
            catch(Exception e) {}
        } // while( !mExit )
    }

    public void Exit()
    {
        CEvent event = new CEvent( CEvent.EvUserConnection_Close );

        try{
            pServerConnector.Send( event );
        } catch( Exception e ) {};

        synchronized( this )
        {
            System.err.println( "DEBUG: closing connection...");
            try{
                wait( 10 );
            } catch (Exception e) {}

            //try {
                pServerConnector.Close();
            //} catch( IOException e ) {};
        }

        mExit = true;
    }

    public CSessionManager      GetSessionManager()     { return pSessionManager; }
    public void                 SetSessionManager(CSessionManager smgr)
    {   pSessionManager = smgr; }

    public CFileController      GetFileController()     { return pFileController; }
    public void                 SetFileController(CFileController ctrl)
    {
        pFileController = ctrl;
        pFile = pFileController.GetFile();
    }


    public int                      GetConnectionId()       { return mConnId; }
    public int                      GetUserId()             { return mUserId; }


    public void DEBUG_write( PrintStream pStr )
    {
        pStr.println( "CClient [toolId=" + GetToolId() + "| userId="+mUserId+"| connId="+mConnId+"]" );

        pStr.println( "SessionManager:");
        pSessionManager.DEBUG_write( pStr );

        pStr.println( "FileController:");
        //pFileController.DEBUG_write( pStr );
    }


/*
    protected void ProcessEvent( CEvent event )
    {
        switch( event.GetType() )
        {
            case CEvent.EvUserConnection_Open:
                // New User Logged In
                OnEvent_UserConnectionOpen( event );
                //NotifyDisplay();
                break;

            case CEvent.EvUserConnection_Close:
                OnEvent_UserConnectionClose( event );
                //NotifyDisplay();
                break;

            default:
                break;
        } // end switch

    }


    protected void OnEvent_UserConnectionOpen( CEvent event )
    {



    }

    protected void OnEvent_UserConnectionClose( CEvent event )
    {


    }


*/


