/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Package: COPSE.CLIENT
 * Classe:  CGUIManager
\******************************************************************************/

package COPSE.CLIENT.GUI;


import  java.awt.*;
//import  java.awt.event.*;
import  java.io.*;

import  COPSE.*;
import  COPSE.CLIENT.*;



public class CGUIManager
{
    // GUI - Interface Objects
    protected   Frame       pMainWindow;

    protected   MenuBar     pMainMenu;


    // temporary message line
    protected   Panel       pMessageLine;


    // GUI Managers
    protected   CGUICollaborationManager    pCollabManager;
    protected   CGUIToolManager             pToolManager;


    // Client Structure
    protected   CClient                 pClient;


    public  CGUIManager ( )
    {

        //* Creating GUI Collaboration Manager
        pCollabManager = CreateGUICollaborationManager();
        System.err.println( "[DEBUG} CGUIManager - Starting GUICollaborationManager..." );
        pCollabManager.start();

        //* Creating GUI Specific Tool Manager
        pToolManager = CreateGUIToolManager();


        //* Main Window
        pMainWindow = new Frame( pToolManager.GetTitle() );
        pMainWindow.setLayout( new BorderLayout(1,1) );
        pMainWindow.setSize( 640, 480 );
        pMainWindow.addWindowListener( pToolManager );


        //* Menu
        pMainMenu = new MenuBar();
        pToolManager.AddMenu( pMainMenu );
        pCollabManager.AddMenu( pMainMenu );

        pMainWindow.setMenuBar( pMainMenu );

        //* Client Area
        pMainWindow.add( "Center", pToolManager.GetClientPanel() );

        // MessageLine ??

        //* Show Main Window...
        pMainWindow.setVisible( true );
    }


    public Frame    GetMainWindow()     { return pMainWindow; }

    // called by ToolManager after creating the Client
    public void SetClient( CClient client )
    {
        pClient = client;
        pCollabManager.SetClient( client );
    }


    protected CGUICollaborationManager CreateGUICollaborationManager()
    {   return new CGUICollaborationManager( this );    }

    protected CGUIToolManager CreateGUIToolManager()
    {   return new CGUIToolManager( this );    }



    //* Send Events to Server
    public void     Send( CEvent event )
        throws IOException
    {
        if( pClient != null )
            pClient.Send( event );
    }


    //* Exit
    public void Exit()
    {
        // Stops GUICollaborationThread...
        pCollabManager.Exit();
    }

}