/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Package: COPSE.CLIENT
 * Classe:  CGUIMessageControl
\******************************************************************************/

package COPSE.CLIENT.GUI;


import  java.awt.*;
import  java.awt.event.*;

import  COPSE.*;
import  COPSE.CLIENT.*;


public class    CGUIMessageControl
    extends     CGUIMenuItemControl
{

    protected   CDlgCommunicationMessage    pCommMessageDlg;

    public CGUIMessageControl ( CGUICollaborationManager collabManager, Menu menu )
    {
        super( collabManager, menu, "Message..." );
        pCommMessageDlg = null;
    }


    public void Update()
    {
        if( pCommMessageDlg != null )
            pCommMessageDlg.UpdateUserList();
    }


    //* Event Handler
    protected void ProcessEvent( CEvent event )
    {
        int type = event.GetType();

        if( type == CEvent.EvCollaboration_Communication_Call_Message )
        {
            Integer from = (Integer) event.GetArgumentAt( 0 );
            Integer to   = (Integer) event.GetArgumentAt( 1 );
            String  message = (String) event.GetArgumentAt( 2 );

            ShowMessage( from.intValue(), to.intValue(), message );
        }
    }


    protected void ShowMessage( int from, int to, String message )
    {
        CClientSessionManager sessionManager = pCollabManager.GetSessionManager();
        CToolSession tool = sessionManager.GetClientToolSession();
        CUserSession user = tool.FindUserSession( from );

        String toName = "ALL";
        if( to != 0 )
            toName = sessionManager.GetClientSession().GetUserName();

        String fromName = "id=" + Integer.toString(from);
        if( user != null )
            fromName = user.GetUserName();

        String title = "Message from '"+ fromName +"' to '"+ toName +"'";

        CDlgMessage dlg = new CDlgMessage( pGUI.GetMainWindow(), title, true );
        dlg.AddMessage( message );
        dlg.show();
    }



    //* Action Listener
    public void actionPerformed( ActionEvent event )
    {
        if( event.getSource() == mnMenuItem )
        {
            if( pCommMessageDlg == null )
            {
                pCommMessageDlg = new CDlgCommunicationMessage( pGUI, false, pCollabManager.GetSessionManager() );
            }

            pCommMessageDlg.setVisible(true);
        }
    }


    public void Exit()
    {
        if( pCommMessageDlg != null )
        {
            pCommMessageDlg.setVisible( false );
            pCommMessageDlg.dispose();
            pCommMessageDlg = null;
        }

        super.Exit();
    }

}