package BW;

import java.util.Calendar;
import java.io.*;


/** classe para a construcoa de logs de atividades 
 *@autor Manuele Kirsch Pinheiro
 */
public class Log {

    public Log ( ) {
	LOGNAME="log";
	status=this.init();
    }

    /** construtor
     *@param String logname	- nome base do arquivo de log 
     */
    public Log (java.lang.String logname) {
	LOGNAME= new String (logname);
	status=this.init();
    }

     /** arquivo de log do servidor */
     FileWriter log;

     /** nome do arquivo de log do servidor */
     String LOGNAME;

     /** variavel de status do log */
     boolean status;

     /** monta string com informacao de dia, hora e minutos */
	public String getDayTime () {
               Calendar c = Calendar.getInstance();
	       StringBuffer dhm = new StringBuffer();

	       dhm.append("D");
               dhm.append(Integer.toString(c.get(Calendar.DAY_OF_YEAR)));
	       dhm.append("H");
               dhm.append(Integer.toString(c.get(Calendar.HOUR_OF_DAY)));
	       dhm.append("M");
               dhm.append(Integer.toString(c.get(Calendar.MINUTE)));

	       return (dhm.toString());
	}


	/** inicializa o log.
	 * @return boolean	true - inicializacao feita com sucesso
	 *			false - falha na inicializacao 
         */
	protected  boolean init () {
      
           //abre o log
           try {
               Calendar c = Calendar.getInstance();
	       LOGNAME+= ".";
               LOGNAME+= this.getDayTime();
               LOGNAME+= ".log";
               System.out.println ("Novo arquivo de log: "+LOGNAME+" [ makeLog.init ]");

              log = new FileWriter(new File(LOGNAME));
              //log = new FileWriter(LOGNAME);

              String inicio=new String ("\n========= BEGIN LOGING ===========\n");
	      log.write (inicio,0,inicio.length());
           } catch (IOException ioe) {
               System.out.println ("impossivel abrir log [ makeLog.init ]");
               return (false);
           }
	   return (true);
	 }


	/** fecha o log 
	 * @return boolean	true - foi possivel abrir novo log
	 *			false - erro ao abrir novo log
	 */
	public boolean close () {
	     try {
		log.close();
		status = true;
	     } catch (IOException e) {
         	System.out.println ("Impossivel escrever no log  : [ makeLog.write ]");
         	status = false;
	     }
	     return (status); 
	}


	/** abre novo log
	 * @param  String logname	nome base para o novo log
	 * @return boolean	true - foi possivel abrir novo log
	 *			false - erro ao abrir novo log
	 */
	public boolean open (String logname) {		
		this.close();
		LOGNAME = new String (logname);
	  	status = this.init();
		return (status);
	}

	/** abre novo log
	 * @return boolean	true - foi possivel abrir novo log
	 *			false - erro ao abrir novo log
	 */
	public boolean open () {
		return (this.open("log"));
	}


	/** escreve mensagem no log
	 *@param String info	- informacao a ser salva no log.
	 *@return boolean	true - informacao salva com sucesso
	 *			false - nao foi possivel salvar informacao
	 */
 	public boolean write (String info) {
       	  try {
         	String ne = new String ("[ " +this.getDayTime()+ " ] " +info+ "\n");
         	log.write (ne,0,ne.length());
         	log.flush();
		status = true;
          } catch (IOException e) {
         	System.out.println ("Impossivel escrever no log  : [ makeLog.write ]");
         	status = false;
	  }
	  return (status);       
	}

	/** retorna o status do log (true - ok, false - houve problemas) */
	public boolean getStatus () {
		return status;
	}

  }
