/**
* UFRGS - II - PPGC - MESTRADO EM CIENCIA DA COMPUTACAO
* AUTOR LUIZ ANGELO BARCHET ESTEFANEL
* CLASSE AwarenesselpMenu
* PACOTE BW.UML
* DATA DE CRIACAO 16 / 01 / 2001
*/

package BW.UML;

import java.awt.*;
import java.awt.event.*;
import java.io.*;

/**
* A classe AwarenessHelpWindow serve para a exibicao de um texto
* explicativo para o usuario.
* O arquivo que contm o texto de ajuda  passado como parametro.
* @author Luiz Angelo Barchet Estefanel
* @version 1.0
*/
public class AwarenessHelpWindow extends Frame implements WindowListener, ActionListener {

   ////////////////////////// ATRIBUTOS
   
   /** arquivo onde se localiza o texto de ajuda
   */
   private String file;
   
 
   ////////////////////////// CONSTRUTOR  
   
   /**
	 * Construtor
	 * @param String file	nome do arquivo de help(incluindo caminho)
	 */

   public AwarenessHelpWindow (String file) {
      super("Help");
      Panel background;
      TextArea textArea;
      Button okButton;

      this.file = file;
      try {
         FileReader fr = new FileReader(file);
	 this.setSize(400, 280);

         addWindowListener (this);

	 background = new Panel();
	 add(background);
	 background.setLayout(new BorderLayout());
	 textArea = new TextArea (7,25);
	 textArea.setEditable(false);
	 background.add("Center", textArea);
	 okButton = new Button ("Ok");
	 okButton.addActionListener(this);
	 background.add("South",okButton);
	 char abc[] = new char[100];
         
	 int eof = 0;
	 while (eof != -1)
	 {
	 	 abc = new char [100];
	    eof = fr.read(abc,0,100);
	    if (eof != -1)
	    {
	       textArea.append(new String(abc));
	    }
	 }

	 fr.close();
	 setVisible(true);

      } catch (Exception ex) {
	      System.out.println("algo saiu errado" + ex);
      }
   
   }


	//////////// metodo do ActionListener

   public void actionPerformed(ActionEvent e) {
      this.setVisible(false);
      dispose();
   }
   
   
   
   //////////// metodos do WindowListener

   public void windowClosing (WindowEvent evt){
      this.setVisible(false);
      dispose();
   }

   public void windowClosed (WindowEvent evt) {
   }

   public void windowOpened (WindowEvent evt) {
   }

   public void windowIconified (WindowEvent evt) {
   }

   public void windowActivated (WindowEvent evt) {
   }

   public void windowDeactivated (WindowEvent evt) {
   }

   public void windowDeiconified (WindowEvent evt) {
   }

   public void actionPerformed (WindowEvent evt) {
   }

}