/**
* UFRGS - II - PPGC - MESTRADO EM CIENCIA DA COMPUTACAO
* AUTOR LUIZ ANGELO BARCHET ESTEFANEL
* CLASSE AwarenessUserInfoWindow
* PACOTE BW.UML
* DATA DE CRIACAO 16 / 01 / 2001
*/

package BW.UML;

import java.awt.*;
import java.awt.event.*;
import BW.kernel.*;
import BW.Interface.*;

/**
* A classe AwarenessUserInfoWindow exibe os dados pessoais do membro, 
* bem como permite a alteracao destes dados.
* @author Luiz Angelo Barchet Estefanel
* @version 1.0
*/
public class AwarenessUserInfoWindow extends Frame implements WindowListener, TextListener, ActionListener {

   ////////////////////////// ATRIBUTOS
   
   /** variavel que contem os dados do membro
   */
   private BW_Member member;

   /** variavel que contem a referencia do nivel superior
   */
   private UI_Interface Interface;
   
   /** flag que indica se algum dos dados do usuario sofreram alteracao
   */
   private boolean isChanged = false;
   
     
   /** Variaveis da Interface grafica
   */

      private Panel background;
      private Panel West;
      private Panel Center;
      private Panel South;
      private Label Login;
      private TextField tLogin;
      private Label UID;
      private Label tUID;
      private Label Name;
      private TextField tName;
      private Label Mail;
      private TextField tMail;
      private Label Homepage;
      private TextField tHomepage;
      private Label Machine;
      private TextField tMachine;
      private Button okButton;
      private Button cancelButton;


   ////////////////////////// CONSTRUTOR  
   /**
	 * Construtor
	 * @param UI_Interface Interface	referencia `a janela principal da exibicao
	 * @param BW_Member member usuario atual
	 */

   public AwarenessUserInfoWindow (UI_Interface Interface, BW_Member member) {
	super("Modify User Info");
      this.Interface = Interface;
      this.member = member;

      this.setSize(500, 250);
      addWindowListener (this);
      background = new Panel();
      add(background);
      background.setLayout(new BorderLayout());
      West = new Panel ();
      West.setLayout(new GridLayout(6,1));
      Center = new Panel();
      Center.setLayout(new GridLayout(6,1));
      South = new Panel();
      background.add("West",West);
      background.add("Center", Center);
      background.add("South",South);
      UID = new Label ("UID: ");
      West.add(UID);
      tUID = new Label ("");
      Center.add(tUID);
      Login = new Label ("Login: ");
      West.add(Login);
      tLogin = new TextField("",20);
      Center.add(tLogin);
      Name = new Label ("Name: ");
      West.add(Name);
      tName = new TextField ("",40);
      Center.add(tName);
      Mail = new Label ("Mail: ");
      West.add(Mail);
      tMail = new TextField ("",40);
      Center.add(tMail);
      Homepage = new Label ("Homepage: ");
      West.add(Homepage);
      tHomepage = new TextField("",40);
      Center.add(tHomepage);
      Machine = new Label ("Machine: ");
      West.add(Machine);
      tMachine = new TextField("",40);
      Center.add(tMachine);
      okButton = new Button ("Ok");
      okButton.addActionListener(this);
      South.add(okButton);
      cancelButton = new Button ("Cancel");
      cancelButton.addActionListener(this);
      South.add(cancelButton);
      try {

      	fillFields();
      	setVisible(true);
      /* nao sei porque, mas um sleep impede que o TextListener "escute"
       * a definicao do ambiente grafico */

	 Thread.sleep(200);
	
      } catch (NullPointerException npe) {
      	System.out.println ("no member");	
      } catch (InterruptedException ex) {
      }
      tLogin.addTextListener(this);
      tName.addTextListener(this);
      tMail.addTextListener(this);
      tHomepage.addTextListener(this);
      tMachine.addTextListener(this);
      isChanged = false;
      
   }


   ////////////////////////  METODOS

   /** metodo fillFields preenche os campos com os dados atuais do usuario
    */
   public void fillFields () {
      tUID.setText(String.valueOf(member.getObjId()));
      tLogin.setText(member.getLogin());
      tName.setText(member.getName());
      tMail.setText(member.getMail());
      tHomepage.setText(member.getHomePage());
      tMachine.setText(member.getMachine());
      isChanged = false;
   }

   /**
	 * modifica o registro do usuario com os dados modificados
	 */

   public void changeMember () {
     
     member.setLogin(tLogin.getText());
     member.setName(tName.getText());
     member.setMail(tMail.getText());
     member.setHomePage(tHomepage.getText());
     member.setMachine(tMachine.getText());
     ///  usar UI_Interface.setMemberInfo()
   }

   private void okButton () {
      if (isChanged==true)
	 changeMember();
      this.setVisible(false);
      dispose();
   }

   private void cancelButton () {
      this.setVisible(false);
      dispose();
   }


   //////////// metodo do TextListener

   public void textValueChanged(TextEvent e) {
      this.isChanged = true;
   }

   /////////// metodo do ActionListener

   public void actionPerformed (ActionEvent e) {
      if ((e.getSource())==okButton)
	 okButton();
      else
	 if ((e.getSource())==cancelButton)
            cancelButton();
   }


	//////////// metodos do WindowListener

   public void windowClosing (WindowEvent evt){
      this.setVisible(false);
      dispose();
   }

   public void windowClosed (WindowEvent evt) {
   }

   public void windowOpened (WindowEvent evt) {
   }

   public void windowIconified (WindowEvent evt) {
   }

   public void windowActivated (WindowEvent evt) {
   }

   public void windowDeactivated (WindowEvent evt) {
   }

   public void windowDeiconified (WindowEvent evt) {
   }

   public void actionPerformed (WindowEvent evt) {
   }

}