/**
 * UFRGS - II - PPGC - MESTRADO EM CIENCIA DA COMPUTACAO
 * AUTORA MANUELE KIRSCH PINHEIRO
 * CLASSE ST_LOGWRITER
 * PACOTE BW.STORAGE
 * DATA DE CRIACAO 18 / 07 / 2000
 */

package BW.storage;

import java.util.Vector;
import java.util.Calendar;
import java.util.Enumeration;
import java.io.*;

import BW.kernel.*;

public  class ST_LogWriter extends ST_Implementor {

	//////////////////// ATRIBUTOS 	//////////////////
      	/** arquivo de log do servidor (para escrita) */
	FileWriter log;

	/** arquivo de log do servidor (para leitura) */
        //FileReader rlog;
	
     	/** nome do arquivo de log do servidor */
     	String LOGNAME;

     	/** variavel de status do log */
     	boolean status;


	/////////////////// CONSTRUTOR	/////////////////
    	public ST_LogWriter ( ) {
		LOGNAME="logEvents";
		status=this.init();
	}

        /** monta string com informacao de dia, hora e minutos */
	protected String getDayTime () {
               Calendar c = Calendar.getInstance();
	       StringBuffer dhm = new StringBuffer();

	       dhm.append("D");
               dhm.append(Integer.toString(c.get(Calendar.DAY_OF_YEAR)));
	       dhm.append("H");
               dhm.append(Integer.toString(c.get(Calendar.HOUR_OF_DAY)));
	       dhm.append("M");
               dhm.append(Integer.toString(c.get(Calendar.MINUTE)));

	       return (dhm.toString());
	}


	/** inicializa o log.
	 * @return boolean	true - inicializacao feita com sucesso
	 *			false - falha na inicializacao
         */
	protected  boolean init () {

           //abre o log
           try {
               Calendar c = Calendar.getInstance();
	       LOGNAME+= ".";
               LOGNAME+= this.getDayTime();
               LOGNAME+= ".log";
               System.out.println ("Novo arquivo de log: "+LOGNAME+" [ logWriter.init ]");

              log = new FileWriter(new File(LOGNAME));
              //log = new FileWriter(LOGNAME);

              String inicio=new String ("\n========= BEGIN LOGING ===========\n");
	      log.write (inicio,0,inicio.length());
           } catch (IOException ioe) {
               System.out.println ("impossivel abrir log [ logWriter.init ]");
               return (false);
           }
	   return (true);
	 }



	//////////////////// METODOS /////////////////// 	

        /** faz leitura de dados
	 * @param 	String what	o que deve ser lido
	 * @return	Vector elementos BW_Element lidos
	 */
	public  Vector read (String what) {
		return new Vector ();
	}
	
        /** escreve os dados em meio permanente
	 * @param 	String what	o que deve ser escrito
	 * @return 	boolean		true  se foi gravado com exito
	 *				false caso contrario
	 */
	public  boolean write (String what) {
       	  try {
         	String ne = new String ("[ " +this.getDayTime()+ " ] " +what+ "\n");
         	log.write (ne,0,ne.length());
         	log.flush();
		status = true;
          } catch (IOException e) {
         	System.out.println ("Impossivel escrever no log  : [ logWriter.write ]");
         	status = false;
	  }
	  return (status);
	}


	public boolean write (Vector data) {
	       boolean ret = true;		
	       Enumeration e = data.elements();
	       while (e.hasMoreElements()) {
	       	  boolean b = this.write (e.nextElement().toString());
	       	  if (!b) ret = b;
	       }
	
	       return ret;
	}
	
        /** faz a abertura da base de armazenamento
	 * @return	boolean		true se abriu a base corretamente
	 *				false caso contrario
	 */
	public  boolean open () {		
		this.close();
		status = this.init();
		return (status);
	}

        /** fecha e conclui as operacoes sobre a base de dados
	 * @return 	boolean		true  se foi fechado com exito
	 *				false caso contrario
	 */
	public  boolean close () {
	    try {
		log.close();
		status = true;
	     } catch (IOException e) {
         	System.out.println ("Impossivel fechar o log  : [ logWriter.close ]");
         	status = false;
	     }
	     return (status);
	}

 	/** retorna o status da base de dados ou da ultima
	 *  operacao feita sobre ela
	 * @return	boolean		true - se a base esta ok
	 *				false caso contrario
	 */
	public  boolean getStatus () {
		return status;
	}


	///////////////// METODOS NAO IMPLEMENTADOS //////////////////////////
	
	public ST_Setup read (ST_Setup set) {
		return new ST_Setup();
	}
	
	 public Vector read (BW_Element what, BW_TimeInterval when) {
	 	return new Vector();
	 }
		
	 public Vector read (BW_Element what){
		return new Vector();
	 }
	
	 public BW_Element read (BW_Element what, int objId) {
	 	return new BW_Element (what.getTypeId(),objId);
	 }

        public boolean write (BW_Element what) {
        	return this.write (what.toString());
        }

       public boolean write (ST_Setup set) {
       		return this.write (set.toString());
       }

}
