/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Package: COPSE.CLIENT
 * Classe:  CDlgFileOpen
\******************************************************************************/

package COPSE.CLIENT.GUI;


import  java.awt.*;
import  java.awt.event.*;

import  COPSE.CLIENT.*;

/*************************************************************************
 *  Classe DlgFileOpen
 *************************************************************************/
public class    CDlgFileOpen
    extends     Dialog
    implements  ActionListener, WindowListener
{
    protected   CGUIFileControl pControl;

    public      String      mHost;
    public      String      mPort;
    public      String      mUser;

	protected   TextField   textHost;
	protected   TextField   textPort;
	protected   TextField   textUser;
	protected   Button      btnOK;
    protected	Button      btnCancel;


	public CDlgFileOpen(Frame parent, boolean modal, CGUIFileControl control)
	{
	    super(parent, modal);
	    pControl = control;

	    mHost = mPort = mUser = "";


		setLayout(null);
		addNotify();

		Insets inset = getInsets();
		setSize(inset.left + inset.right + 275,inset.top + inset.bottom + 175);
		setFont(new Font("Helvetica", Font.PLAIN, 12));


    	// Labels ...
    	Label label;

		label = new Label("Server Host:");
		label.setBounds(inset.left + 14,inset.top + 15,77,20);
		add(label);

		label = new Label("Server Port:");
		label.setBounds(inset.left + 14,inset.top + 53,70,20);
		add(label);

		label = new Label("User Name:");
		label.setBounds(inset.left + 14,inset.top + 90,77,20);
		add(label);


		// Text Fields ...
		textHost = new TextField();
		textHost.setText("localhost");
		textHost.setBounds(inset.left + 105,inset.top + 15,154,30);
		add(textHost);

		textPort = new TextField();
		textPort.setText("2000");
		textPort.setBounds(inset.left + 105,inset.top + 53,154,30);
		add(textPort);

		textUser = new TextField();
		textUser.setBounds(inset.left + 105,inset.top + 90,154,30);
		add(textUser);


		// Buttons ...
		btnOK = new Button("Ok");
		btnOK.setBounds(inset.left + 77,inset.top + 128,84,23);
		btnOK.addActionListener( this );
		add(btnOK);

		btnCancel = new Button("Cancel");
		btnCancel.setBounds(inset.left + 175,inset.top + 128,84,23);
		btnCancel.addActionListener( this );
		add(btnCancel);


		// Dialog
		addWindowListener( this );
		setTitle("Open Connection");
		setResizable(false);
	}






	private void btnOK_Clicked()
	{
	    ViewToData();
	    setVisible(false);
	    pControl.DlgFileOpenOk();
	}

    protected void DataToView()
    {
        textHost.setText( mHost );
        textPort.setText( mPort );
        textUser.setText( mUser );
    }

    protected void ViewToData()
    {
        mHost = textHost.getText();
        mPort = textPort.getText();
        mUser = textUser.getText();
    }

    public synchronized void setVisible( boolean visible )
    {
        if( visible )
        {
        	Rectangle bounds = getParent().getBounds();
        	Rectangle abounds = getBounds();

        	setLocation(bounds.x + (bounds.width - abounds.width)/ 2,
        	     bounds.y + (bounds.height - abounds.height)/2);

            DataToView();
        }

    	super.setVisible( visible );
    }

    // ActionEvent Listener method
    public void actionPerformed( ActionEvent event )
    {
        Object source = event.getSource();

        if( source == btnOK )
            btnOK_Clicked();
        else
        if( source == btnCancel )       { setVisible(false); }
    }

    // WindowEvent Listener methods
    public void windowOpened(WindowEvent e)         {}
    public void windowClosed(WindowEvent e)         {}
    public void windowClosing(WindowEvent e)        { setVisible(false); }
    public void windowIconified(WindowEvent e)      { setVisible(false); }
    public void windowDeiconified(WindowEvent e)    {}
    public void windowActivated(WindowEvent e)      {}
    public void windowDeactivated(WindowEvent e)    {}


}
