/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Package: COPSE.CLIENT
 * Classe:  CGUIUserListControl
\******************************************************************************/

package COPSE.CLIENT.GUI;


import  java.awt.*;
import  java.awt.event.*;

import  COPSE.CLIENT.*;


public class    CGUIUserListControl
    extends     CGUICheckboxMenuControl
    implements  WindowListener
{
    protected   CDlgAwarenessUserList       pDlgUserList;

    public CGUIUserListControl ( CGUICollaborationManager collabManager, Menu menu )
    {
        super( collabManager, menu, "UserList" );

        pDlgUserList = null;
    }

    protected void ChangeMenuSettings()
    {
        CClientSessionManager session = pCollabManager.GetSessionManager();
        if( session == null )
        {
            SetEnabled( false );
            mnCheckboxMenu.setEnabled( mIsEnabled );
            pDlgUserList = null;
        }
        else
        {
            if( IsEnabled() )   return;

            SetEnabled( true );
            mnCheckboxMenu.setEnabled( mIsEnabled );
            pDlgUserList = CreateUserListDialog();
        }
    }


    protected CDlgAwarenessUserList CreateUserListDialog()
    {
        CDlgAwarenessUserList dlg = new CDlgAwarenessUserList( pGUI, false, this, pCollabManager.GetSessionManager() );
        dlg.addWindowListener( this );
        return dlg;
    }

    public void Activate()
    {
        ChangeMenuSettings();
    }

    public void Update()
    {
        if( pDlgUserList != null )
        {
            pDlgUserList.UpdateUserList();
            //pDlgUserList.SetMessage( modifMessage );

            SetEnabled(true);
        }
    }



    //* ItemListener
    public void itemStateChanged(ItemEvent event)
    {
        if( event.getSource() == mnCheckboxMenu )
        {
            if( pDlgUserList == null )
                pDlgUserList = CreateUserListDialog();

            pDlgUserList.setVisible( mnCheckboxMenu.getState() );
        }
    }



    //* WindowListener
    public void windowOpened(WindowEvent e)         {}
    public void windowClosed(WindowEvent e)         {}

    public void windowClosing(WindowEvent e)
        {
            //pChatDlg.setVisible( false );
            mnCheckboxMenu.setState(false);
        }

    public void windowIconified(WindowEvent e)
        {
            //pChatDlg.setVisible( false );
            mnCheckboxMenu.setState(false);
        }

    public void windowDeiconified(WindowEvent e)    {}
    public void windowActivated(WindowEvent e)      {}
    public void windowDeactivated(WindowEvent e)    {}


/*
    //* Event Handler
    protected   void    ProcessEvent( CEvent event )
    {
        int type = event.GetType();

        switch( type )
        {
            case CEvent.EvCOPSE_:
                {
                    Integer fromId = (Integer) event.GetArgumentAt(0);
                    Integer toId   = (Integer) event.GetArgumentAt(1);
                    String message = (String) event.GetArgumentAt(2);

                    AddMessage( fromId.intValue(), toId.intValue(), message );
                }
                break;

            default:
                super.ProcessEvent(event);
        }
    }

*/





}