/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * package: COPSE.SERVER
 * Classe: CServerCollaborationHandler
\******************************************************************************/

package COPSE.SERVER;

import java.io.*;
import java.net.*;
import java.util.*;


import COPSE.*;
import COPSE.CONTROL.*;
import FILE.*;


public class CServerCollaborationHandler
    extends  CEventHandler
{

    protected CServerCollaborationManager pCollabManager;
    protected CServerSessionManager       pSessionManager;

    public CServerCollaborationHandler( CServerCollaborationManager manager )
    {
        super();
        pCollabManager  = manager;
        pSessionManager = manager.GetServer().GetSessionManager();
    }

    protected CServerToolSession    GetToolSession( CConnectionHandler handler )
    {
        CUserConnectionHandler userHandler = (CUserConnectionHandler) handler;
        return (CServerToolSession) (userHandler.GetUserSession().GetToolSession());
    }

    protected void ProcessEvent( CEvent event, CConnectionHandler handler )
    {
        //System.err.println( "[DEBUG] CServerCollaborationManager: Event ["+event.GetType()+"]" );

/*
        if( !(handler instanceof CUserConnectionHandler) )
            return;

        CUserConnectionHandler userHandler = null;
*/

        // By default, it just send the event to all clients in the same tool
        CServerToolSession toolSession = GetToolSession( handler );
        toolSession.NotifyAll( event );

        /*
        switch( event.GetType() )
        {
        }
        */
    }


    public void Exit()
    {
        this.stop();
    }

}







