/*

\**/


import java.io.*;
import java.util.*;

import COPSE.*;
import COPSE.SERVER.*;


public class ServerTestApp
{
    protected CServer   pServer;


    public static void main( String[] args )
    {
        new ServerTestApp().run( args );
    }

    public ServerTestApp()
    {
    }

    protected void run (String[] args)
    {
        System.out.println( "ServerTestApp 1.0.0" );

        String filename = null;
        if( args.length < 1 )
        {
            System.out.println( "Parameters: <port> [<fileName>]" );
            System.exit(0);
        }
        if( args.length > 1 )
            filename = args[1];


        System.out.println( "DEBUG: Creating the Server object" );
        try {

            pServer = new CServer( Integer.parseInt(args[0]), filename );
        }
        catch( Exception e )
        {
            e.printStackTrace( System.out );
            System.exit( 0 );
        }

        System.out.println( "DEBUG: Starting the Server object" );
        pServer.start();



        BufferedReader reader = new BufferedReader( new InputStreamReader( System.in ) );
        StringTokenizer tokenizer;

        boolean mExit = false;
        while( !mExit )
        {
            try{
                tokenizer = new StringTokenizer( reader.readLine() );
                if( !tokenizer.hasMoreTokens() ) continue;
            } catch ( IOException e )
            {   continue; }


            String command = tokenizer.nextToken();
            if( command.equals( "DEBUG" ) )
            {
                //pServer.DEBUG_write( System.out );
            }
            else
            if( command.equals( "EXIT" ) )
            {
                pServer.Exit();
                try{
                    pServer.join();
                }
                catch( Exception e) {};
                mExit = true;
            }
        }

    }


}