/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Package: FILE
 * Classe:  CFolderEntry
\******************************************************************************/

package FILE;

import java.io.*;
import java.util.*;


public class CFSEntry
    extends CElement
{
    //** Attributes
    protected String        mName;

    protected CFolderEntry  pParentFolder;

    //** Constructor
    public CFSEntry()
    {
        super();
        mName = "";
        pParentFolder = null;
    }

    //** Methods to handle Attributes
    public void     SetName( String name )  { mName = name; }
    public String   GetName()               { return mName; }


    public CFolderEntry GetParentFolder()   { return pParentFolder; }
    public void SetParentFolder(CFolderEntry folder)  { pParentFolder = folder; }


    public String   GetPath()
    {
        String path = GetName();
        String separator = File.separator;

        CFolderEntry folder = GetParentFolder();
        while( folder != null )
        {
            path = folder.GetName() + separator + path;
            folder = folder.GetParentFolder();
        }

        return path;
    }


    public String   GetParentPath()
    {
        CFolderEntry folder = GetParentFolder();
        if( folder == null )
            return new String(".");

        String path = folder.GetName();
        String separator = File.separator;

        folder = folder.GetParentFolder();
        while( folder != null )
        {
            path = folder.GetName() + separator + path;
            folder = folder.GetParentFolder();
        }

        return path;
    }

    //** DEBUG
    public void DEBUG_write( PrintStream pStr )
    {
        pStr.println( "DEBUG: CFSEntry");
        pStr.println( "       Name:         " + mName );
        super.DEBUG_write(pStr);
    }

}
