/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Package: FILE
 * Classe:  CFolderEntry
\******************************************************************************/

package FILE;

import java.io.*;
import java.util.*;


public class CFolderEntry
    extends CFSEntry
{
    //** Attributes
    protected CFolderEntry  pParentFolder;
    protected Vector        pEntries;

    //** Constructor
    public CFolderEntry()
    {
        super();
        mName = "Folder";
        pParentFolder = null;
        pEntries = new Vector();
    }


    //** Methods to handle Attributes
    public void     AddEntry (CFSEntry entry)
    {
        pEntries.addElement( entry );
        entry.SetParentFolder( this );
    }

    public void     RemoveEntry (CFSEntry entry)
    {
        pEntries.removeElement( entry );
        entry.SetParentFolder( null );
    }

    public Enumeration  GetEntries()
    {
        return pEntries.elements();
    }


    public void     Create( String projectDir )
    {
        String path = projectDir + File.pathSeparator + GetPath();
        File file = new File( path );
        if( !file.exists() )
            file.mkdirs();
    }


    //** DEBUG
    public void DEBUG_write( PrintStream pStr )
    {
        pStr.println( "DEBUG: CFolderEntry");
        super.DEBUG_write(pStr);

        pStr.println( " --- Entries ---" );
        Enumeration e = pEntries.elements();
        while( e.hasMoreElements() )
        {
            CElement elem = (CElement) e.nextElement();
            elem.DEBUG_write( pStr );
        }
        pStr.println( " --------------- [" + GetName() + "]" );
    }

}
