/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Package: FILE
 * Classe:  CLink
\******************************************************************************/

package FILE;

import java.io.*;
import java.util.*;


public class CLink
    implements Serializable
{
    //** Attributes
    protected int           mId;
    protected CLocator      pElemTo;
    protected CElement      pElemFrom;

    //** Constructor
    public CLink()
    {
        mId = 0;
        pElemTo     = new CLocator();
        pElemFrom   = null;
    }

    //** Methods to handle Attributes
    public void     SetId( int id )                 { mId = id; }
    public int      GetId()                         { return mId; }

    public void     SetElemFrom ( CElement elem )   { pElemFrom = elem; }
    public CElement GetElemFrom ()                  { return pElemFrom; }

    public void     SetElemTo ( CLocator elem )     { pElemTo = elem; }
    public CLocator GetElemTo ()                    { return pElemTo; }

    //** DEBUG
    public void DEBUG_write( PrintStream pStr )
    {
        pStr.println( "DEBUG: CLink");
        pStr.println( "       Id:           " + mId );
        if( pElemFrom != null )
             pStr.println( "       Elem From:    " + pElemFrom.GetId() );
        else pStr.println( "       Elem From:    null" );

        pStr.println( "       Elem To:      ["
                + pElemTo.GetDocId() + "|" +
                + pElemTo.GetVersionId() + "|" +
                + pElemTo.GetElementId() + "]" );
    }

}
