/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Package: FILE
 * Classe:  CNoteElement
\******************************************************************************/

package FILE;

import java.io.*;
import java.util.*;


public class    CNoteElement
    extends     CElement
{
    //** Attributes
    //protected int      mType;
    protected CElement pElem;
    protected String   mNote;

    protected int      mAuthorId;
    protected String   mAuthor;
    protected Date     mDate;


    //** Constructor
    public CNoteElement()
    {
        super();
        pElem           = null;
        mAuthorId       = 0;
        mAuthor         = "";
        mDate           = new Date();
        //mType           = 0;
        mNote           = "";
    }


    //** Methods to Attributes
    public String   GetAuthorName( )                { return mAuthor; }
    public int      GetAuthorId( )                  { return mAuthorId; }
    public void     SetAuthor( int id, String name )
    {
        mAuthorId = id;
        mAuthor = name;
    }

    public Date     GetDate()                       { return mDate; }
    public void     SetDate( Date date )            { mDate = date; }

    public String   GetDescription( )               { return mNote; }
    public void     SetDescription( String desc )   { mNote = desc; }

    public CElement GetElement()                    { return pElem; }
    public void     SetElement( CElement elem )     { pElem = elem; }

/*
    public int      GetType()                       { return mType; }
    public void     SetType( int type )             { mType = type; }
*/


    //** DEBUG
    public void DEBUG_write( PrintStream pStr )
    {
        pStr.println( "DEBUG: CNoteElement");
        pStr.println( "       ElemId:         " + pElem.GetId() );
        //pStr.println( "       Type:           " + mType );
        pStr.println( "       Description:    " + mNote );
        pStr.println( "       AuthorId  :     " + mAuthorId );
        pStr.println( "       AuthorName:     " + mAuthor );
        pStr.println( "       Date:           " + mDate );

        super.DEBUG_write( pStr );
    }

}
