/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Package: FILE.OBJ
 * Classe:  CObjCardinality
\******************************************************************************/

package FILE.OBJ;

import  java.io.*;
import  java.awt.Point;

/*************************************************************************
 *  Class CObjCardinality
 *************************************************************************/
public class    CObjCardinality
    implements  Serializable, Cloneable
{
    protected   String          mText;
    protected   Point           mPoint;
    protected   int             mAlign;

    public static final int     AlignLeft        = 0;
    public static final int     AlignCenter      = 1;
    public static final int     AlignRight       = 2;

    public CObjCardinality ( String text )
    {
        this( text, new Point(0,0), AlignLeft );
    }

    public CObjCardinality ( String text, Point point, int align )
    {
	    SetText( text );
	    SetPoint( point );
	    SetAlign( align );
    }

    // Attributes
    public String   GetText ()                  { return mText; }
    public void     SetText ( String text )     { mText = text; }

    public Point    GetPoint ()                 { return mPoint; }
    public void     SetPoint ( Point point )    { mPoint = point; }

    public int      GetAlign ()                 { return mAlign; }
    public void     SetAlign ( int align )      { mAlign = align; }

    public Object Clone()
    {
        try {
            return clone();
        } catch (Exception e) {};
        return null;
    }

}