/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Package: GRAPH
 * Classe:  CGrpArrow
\******************************************************************************/

package GRAPH;

import java.awt.*;
//import java.io.*;


public class    CGrpArrow
    extends     CGrpTriangle
{
    public CGrpArrow ( Rectangle rect, int direction )
    {
        super( rect, direction );
    }


    public void           Draw        (CGraphics g)
    {
        Point p0, p1, p2, p3;

        p1 = pPoly.GetPointAt(0);
        p2 = pPoly.GetPointAt(1);
        p3 = pPoly.GetPointAt(2);

        if( mDirection == UP || mDirection == DOWN )
            p0 = new Point( p3.x, p1.y );
        else
            p0 = new Point( p1.x, p3.y );


        Color oldColor = null;
        if( pColor != null )
        {
            oldColor = g.getColor();
            g.setColor( pColor );
        }

        if( IsDashed() ) g.SetDashedPen();

        g.drawLine( p0.x, p0.y, p3.x, p3.y );
        g.drawLine( p1.x, p1.y, p3.x, p3.y );
        g.drawLine( p2.x, p2.y, p3.x, p3.y );

        if( IsDashed() ) g.SetSolidPen();

        if( oldColor != null )
            g.setColor( oldColor );
    }

}