/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Package: GRAPH
 * Classe:  CGrpRectangle
\******************************************************************************/

package GRAPH;

import java.awt.*;
//import java.io.*;


public class    CGrpRectangle
    extends     CGrpObject
{

    public CGrpRectangle ( Rectangle rect, boolean dashed, boolean filled )
    {
        super( dashed, filled );
        SetRegion( rect );
    }

    public CGrpRectangle ( Rectangle rect )
    {
        super();
        SetRegion( rect );
    }


    public void           Draw        (CGraphics g)
    {
        Color oldColor;

        if( IsFilled() )
        {
            oldColor = null;
            if( pFillColor != null )
            {
                oldColor = g.getColor();
                g.setColor( pFillColor );
            }
            g.fillRect( pRegion.x, pRegion.y, pRegion.width, pRegion.height );

            if( oldColor != null )
                g.setColor( oldColor );
        }


        oldColor = null;
        if( pColor != null )
        {
            oldColor = g.getColor();
            g.setColor( pColor );
        }

        if( IsDashed() ) g.SetDashedPen();
        g.drawRect( pRegion.x, pRegion.y, pRegion.width, pRegion.height );
        if( IsDashed() ) g.SetSolidPen();

        if( oldColor != null )
            g.setColor( oldColor );
    }

}