/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Package: PROCESS
 * Classe:  CActivityState
\******************************************************************************/

package PROCESS;

import java.io.*;

public class CActivityState
    implements Serializable
{
    public final static int     AS_INITIATED    = 0;
    public final static int     AS_RUNNING      = 1;
    public final static int     AS_ACTIVE       = 2;
    public final static int     AS_COMPLETE     = 3;
    public final static int     AS_SUSPENDED    = 4;
    public final static int     AS_TERMINATED   = 5;

    public final static boolean AS_Transitions[][] =
    {  //   INI     Run     Act     Comp    Susp    Termi
        {   false,  true,   false,  false,  false,  false   },  // Ini
        {   true,   false,  true,   true,   true,   true    },
        {   false,  true,   false,  false,  false,  true    },
        {   false,  false,  false,  false,  false,  false   },
        {   true,   true,   false,  false,  false,  true    },
        {   false,  false,  false,  false,  false,  false,  }
    };
    // ?? Active -> Complete = false (or true??)

    private int mState;

    public CActivityState()
    {
        mState = AS_INITIATED;
    }

    public int     GetState()       { return mState; }

    public boolean SetState( int state )
    {
        boolean changeOk = AS_Transitions[mState][state];
        if( changeOk )
            mState = state;
        return changeOk;
    }

    public boolean SetInitiated()   { return SetState( AS_INITIATED ); }
    public boolean SetRunning()     { return SetState( AS_RUNNING ); }
    public boolean SetActive()      { return SetState( AS_ACTIVE ); }
    public boolean SetComplete()    { return SetState( AS_COMPLETE ); }
    public boolean SetSuspended()   { return SetState( AS_SUSPENDED ); }
    public boolean SetTerminated()  { return SetState( AS_TERMINATED ); }

    public boolean IsInitiated()    { return ( mState == AS_INITIATED ); }
    public boolean IsRunning()      { return ( mState == AS_RUNNING ); }
    public boolean IsActive()       { return ( mState == AS_ACTIVE ); }
    public boolean IsComplete()     { return ( mState == AS_COMPLETE ); }
    public boolean IsSuspended()    { return ( mState == AS_SUSPENDED ); }
    public boolean IsTerminated()   { return ( mState == AS_TERMINATED ); }
}

