/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Package: PROCESS.MODEL
 * Classe:  CConnector
\******************************************************************************/

package PROCESS.MODEL;


import java.io.*;
import java.util.*;

import java.awt.Point;

public class    CConnector
    extends     CConnectionPoint
{
    protected Point     mPosition;

    protected Vector    pFlows;

    public      CConnector()
    {
        super();
        mPosition = new Point();

        pFlows = new Vector();
    }

    public Point    GetPoint()                  { return mPosition; }
    public void     SetPoint( int x, int y )    { mPosition.setLocation( x, y ); }


    // Flow
    public void AddFlow( CFlow flow )           { pFlows.addElement( flow ); }
    public void RemoveFlow( CFlow flow )        { pFlows.removeElement( flow ); }

    public Enumeration      GetFlows()          { return pFlows.elements(); }


    //** DEBUG
    public void DEBUG_write( PrintStream pStr )
    {
        pStr.println( "DEBUG: CConnector (extends CConnectionPoint)" );
        pStr.println( "       Numb Flows:   " + pFlows.size() );

        super.DEBUG_write( pStr );
    }



}