/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Package: PROCESS
 * Classe:  CActivity
\******************************************************************************/

package PROCESS2;

import java.io.*;
import java.util.*;

import FILE.CElement;

public class    CActivity
    extends     CAbstractActivity
{
    protected   CActivityState    pState;

    //private     int     mFromMetaActivityId;

    public  CActivity()
    {
        super();

        pState = new CActivityState();
        //mFromMetaActivityId = 0;
    }

    // State
    public int      GetState()              { return pState.GetState(); };

    public boolean  SetState( int state )   { return pState.SetState(state); };



    public CActivity    CloneOnlyInfo()
    {
        CActivity act = new CActivity();
        act.UpdateFrom( this );
        return act;
    }


    public void UpdateFrom( CElement elem )
    {
        if( !(elem instanceof CActivity) )
            return;

        super.UpdateFrom( elem );

        SetState( ((CActivity)elem).GetState() );
    }

    public Enumeration GetFromActivities()
    {
        return pParent.GetFromActivities( this );
    }

    public Enumeration GetToActivities()
    {
        return pParent.GetToActivities( this );
    }

    public String GetInfoText()
    {
        String t;

        t =  "ACTIVITY:      " + mName + "\n\n";
        t += "STATE:         " + pState.toString() + "\n\n";
        t += "DESCRIPTION:\n" + mDescription + "\n\n";
        t += "TYPE:          ";
        if( mToolId == 0 )
            t += "Manual (or External)";
        else
            t += "Automated";
        t += "\n\n";

        // INPUTS and OUTPUTS
        if( pParent != null )
        {
            t += "INPUTS (from activities):\n";

            boolean empty = true;
            Enumeration e = GetFromActivities();
            while( e.hasMoreElements() )
            {
                CAbstractActivity a = (CAbstractActivity) e.nextElement();
                t += "    " + a.GetName() + "\n";
                empty = false;
            }
            if( empty )
                    t += "    <no internal inputs for this activity>\n\n";
            else    t += "\n";



            t += "OUTPUTS (to activities):\n";

            empty = true;
            e = GetToActivities();
            while( e.hasMoreElements() )
            {
                CAbstractActivity a = (CAbstractActivity) e.nextElement();
                t += "    " + a.GetName() + "\n";
                empty = false;
            }
            if( empty )
                    t += "    <no internal outputs from this activity>\n\n";
            else    t += "\n";
        }

        // ROLES
        t += "ROLES:\n";
        boolean empty = true;
        Enumeration e = GetRoles();
        while( e.hasMoreElements() )
        {
            CAbstractRole role = (CAbstractRole) e.nextElement();
            t += "   " + role.GetName() + "\n";
            empty = false;
        }
        if( empty )
                t += "    <no internal roles defined to this activity>\n\n";
        else    t += "\n";


        return t;
    }



    //** DEBUG
    public void DEBUG_write( PrintStream pStr )
    {
        pStr.println( "DEBUG: CActivity" );
        pStr.println( "       State:  " + pState.GetState() );
        super.DEBUG_write( pStr );
    }


}


