/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Package: PRODUCT
 * Classe:  CSubProductEntry
\******************************************************************************/

package PRODUCT;

import java.io.*;
import java.util.*;

import FILE.*;


public class CSubProductEntry
    extends CFolderEntry
{
    protected Vector        pSubProducts;
    protected Vector        pDocuments;

    //** Constructor
    public CSubProductEntry()
    {
        super();
        pSubProducts = new Vector();
        pDocuments = new Vector();
    }

    public CSubProductEntry( String name )
    {
        this();
        SetName( name );
    }


    public boolean  IsCompound()
    {
        return pSubProducts.size() != 0;
    }


    // SubProducts
    public void     AddSubProduct (CSubProductEntry subProd)
    {
        super.AddEntry( subProd );
        pSubProducts.addElement( subProd );
    }

    public void     RemoveSubProduct (CSubProductEntry subProd)
    {
        super.RemoveEntry(subProd);
        pSubProducts.removeElement(subProd);
    }

    public Enumeration  GetSubProducts()
    {
        return pSubProducts.elements();
    }


    // Documents
    public void     AddDocEntry (CDocEntry doc)
    {
        super.AddEntry( doc );
        pDocuments.addElement( doc );
    }

    public void     RemoveDocEntry (CDocEntry doc)
    {
        super.RemoveEntry(doc);
        pDocuments.removeElement(doc);
    }

    public Enumeration  GetDocEntries()
    {
        return pDocuments.elements();
    }

    // Entries
    public void     AddEntry (CFSEntry entry)
    {
        super.AddEntry(entry);
        if( entry instanceof CDocEntry )
            pDocuments.addElement( entry );
        else
            pSubProducts.addElement( entry );
    }

    public void     RemoveEntry (CFSEntry entry)
    {
        super.RemoveEntry(entry);
        if( entry instanceof CDocEntry )
            pDocuments.removeElement( entry );
        else
            pSubProducts.removeElement( entry );
    }




    //** DEBUG
    public void DEBUG_write( PrintStream pStr )
    {
        pStr.println( "DEBUG: CSubProduct");
        super.DEBUG_write(pStr);
    }

}
