/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Package: TOOL.PROCESS.CLIENT
 * Classe:  ProcessControlPanel
\******************************************************************************/

package TOOL.PROCESS.CLIENT;


import  java.awt.*;
import  java.util.*;

import  sunw.admin.avm.base.*;
//import  com.sun.java.swing.*;
//import  com.sun.java.swing.event.*;

import  FILE.CElement;
import  PROCESS2.*;

import  COPSE.CLIENT.*;
import  COPSE.CONTROL.*;


import  TOOL.PROCESS.*;







public class ProcessControlPanel
    extends Panel
    implements Observer
{
    protected   ProcessGUIManager       pGUI;
    protected   ProcessGUIToolManager   pToolManager;

    protected   CProcessFileController  pFileController = null;
    protected   CProcess                pProcess = null;

    // Selected Element
    protected   CAbstractActivity       pSelectedElement;

    // GUI Elements
    protected   Browser                 mBrowser;
    protected   ProcBrowserFolder           mTopNode;
    //protected   JTreeModel              pProcessModel;
    //protected   TreeNode                pProcessRoot;


    protected   TextArea                mInformation;

    public      ProcessControlPanel ( ProcessGUIToolManager tool )
    {
        super();
        pToolManager = tool;
        pGUI = (ProcessGUIManager)pToolManager.GetGUIManager();

        pSelectedElement = null;

        createGUIElements();

        //addListener( this );
    }



    protected   void  createGUIElements()
    {
        GridBagLayout layout = new GridBagLayout();
        setLayout( layout );

        //*** BROWSER ***
        mBrowser = new Browser();
        mTopNode = new ProcBrowserFolder( mBrowser, pProcess, pFileController );
        mBrowser.setTopNode( mTopNode );
        mBrowser.addSelectionObserver(this);

        mBrowser.setLineColor         (Color.black);
        mBrowser.setTextColor         (Color.black);
        mBrowser.setViewportBackground(Color.lightGray);
        mBrowser.setViewportInsets    (new Insets(5,5,5,5));
        mBrowser.setFont              (new Font("Dialog", Font.ITALIC, 12));

        ScrollPane scrollPane = new ScrollPane();
        scrollPane.add( mBrowser );
        /**/

        /*** JTree ***
        pProcessRoot = new TreeNode( "Process" );
        //pProcessRoot.insert( new TreeNode( "Activity 1" ), 0 );
        //pProcessRoot.insert( new TreeNode( "Activity 2" ), 1 );
        //pProcessRoot.insert( new TreeNode( "Activity 3" ), 2 );

        pProcessModel    = new JTreeModel( pProcessRoot );

        JTree       processTree         = new JTree( pProcessModel );
        //processTree.

        JScrollPane scrollPane = new JScrollPane();
        scrollPane.getViewport().add( processTree );
        /**/



        GridBagConstraints constraints = new GridBagConstraints();
		constraints.gridx = 0;
		constraints.gridy = 0;
		constraints.gridwidth = 1;
		constraints.gridheight = 3;
		constraints.weightx = 100;
		constraints.weighty = 300;
		constraints.fill = GridBagConstraints.BOTH;
		constraints.insets = new Insets(10,10,10,10);

		layout.setConstraints(scrollPane, constraints);
        add(scrollPane);


        // *** INFO PANEL ***
        Panel activityPanel = new Panel();
        activityPanel.setLayout( new BorderLayout() ); // CardLayout ???


        Panel centerPanel = new Panel();
        centerPanel.setLayout( new BorderLayout() );

        centerPanel.add( "North", new Label("Information:") );

        mInformation = new TextArea();
        mInformation.setEditable( false );
        centerPanel.add( "Center", mInformation );

        activityPanel.add( "Center", centerPanel );



/*
        Panel southPanel = new Panel();
        southPanel.setLayout( new FlowLayout(FlowLayout.CENTER) );

        Label lockedMessageLabel = new Label("Label in the south of Activity Panel - Not locked");
        southPanel.add( lockedMessageLabel );
        southPanel.add( new Button("  Lock  ") );
        southPanel.add( new Button(" Unlock ") );

        activityPanel.add( "South", southPanel );
*/
        //constraints = new GridBagConstraints();
		constraints.gridx = 1;
		constraints.gridy = 0;
		constraints.gridwidth = 3;
		constraints.gridheight = 3;
		constraints.weightx = 100;
		constraints.weighty = 300;
		constraints.fill = GridBagConstraints.BOTH;
		constraints.insets = new Insets(0,0,10,10);
		layout.setConstraints(activityPanel, constraints);
		add(activityPanel);

    }

    public void update(Observable observable, Object what)
    {
        if(what instanceof ProcBrowserNode)
        {
            ProcBrowserNode node = (ProcBrowserNode) what;

            System.out.print(node.getString());
            if(node.isSelected()) System.out.println(" Selected");
            else                  System.out.println(" Deselected");

            CAbstractActivity act = node.GetActivity();
            if( act != null )
            {
                mInformation.setText( act.GetInfoText() );
                pSelectedElement = act;
            }
            pToolManager.SetSelectedElement( act );
        }
    }


    public void SetFileController( CFileController fileController )
    {
        pFileController = (CProcessFileController) fileController;
        if( pFileController != null )
        {
            pProcess = (CProcess) pFileController.GetFile().GetElement( 1 );
            mTopNode = new ProcBrowserFolder( mBrowser, pProcess, pFileController );
            mBrowser.setTopNode( mTopNode );
        }
        else
        {
            pProcess = null;
            mInformation.setText("");

            mTopNode = new ProcBrowserFolder( mBrowser, pProcess, pFileController );
            mBrowser.setTopNode( mTopNode );
        }

        repaint();
    }


    public void UpdateElement( int elemId )     //ElementStateChanged( CElementController elemCtrl )
    {
        if( pFileController == null )   return;

        CElementController elemCtrl = pFileController.FindElementController( elemId );
        if( elemCtrl == null )  return;

        ProcBrowserNode node = FindNode( elemCtrl.GetElement() );

        if( node == null )  return;

        if( elemCtrl.IsLocked() )
        {
            if( elemCtrl.GetLockerConnectionId() == pToolManager.GetClient().GetConnectionId() )
                node.setTextColor( Color.blue );
            else
                node.setTextColor( Color.red );
        }
        else
            node.setTextColor( Color.black );

        node.Refresh();
        mInformation.setText( node.GetActivity().GetInfoText() );

//        mBrowser.dataChanged();
    }

    protected ProcBrowserNode FindNode( CElement element )
    {
        if( element == null )   return null;

        if( !(element instanceof CAbstractActivity) )    return null;

        CAbstractActivity []actPath = new CAbstractActivity[15];
        int i=0;

        actPath[0] = (CAbstractActivity) element;
        while( (actPath[i+1] = actPath[i].GetParent()) != null )
            i++;


        boolean found;
        ProcBrowserNode node = mTopNode;
        ProcBrowserFolder folder;
        while( i > 0 )
        {
            folder = (ProcBrowserFolder) node;
            found = false;

            Enumeration e = folder.elements();
            while( e.hasMoreElements() && !found )
            {
                ProcBrowserNode n = (ProcBrowserNode) e.nextElement();
                if( n.GetActivity().GetId() == actPath[i-1].GetId() )
                {
                    System.out.println( "[DEBUG] - Found: " + actPath[i-1].GetName() );
                    node = n;
                    found = true;
                }
            }

            i--;

            if( !found )
                return null;
        }

        return node;
    }

}





interface ProcBrowserNode   extends BrowserNode
{
    public CAbstractActivity GetActivity();
    public void Refresh();
}



class ProcBrowserFolder extends BrowserFolder
    implements ProcBrowserNode
{
    CElementController      pElemCtrl = null;
    CAbstractActivity       pActivity;

    public ProcBrowserFolder ( Browser browser, CAbstractActivity act, CFileController fileController )
    {
        super( browser, (act == null) ? "Process" : act.GetName() );

        pActivity = act;
	if( pActivity == null )  return;

        pElemCtrl = fileController.FindElementController( pActivity.GetId() );
        if( pElemCtrl.IsLocked() )
            setTextColor( Color.red );
        appendActivities(browser, fileController);
    }

    public CAbstractActivity  GetActivity()     { return pActivity; }

    protected void appendActivities( Browser browser, CFileController fileController )
    {
        if( pActivity == null )     return;

        Enumeration e = pActivity.GetActivities();
        while( e.hasMoreElements() )
        {
            CAbstractActivity elem = (CAbstractActivity)e.nextElement();
            append( new ProcBrowserFolder( browser, elem, fileController ) );
/*
            if( elem.HasActivities() || !elem.IsDefinedByTool() )
                append( new ProcBrowserFolder( browser, elem ) );
            else
//                append( new ProcBrowserItem( browser, elem ) );
                append( new ProcBrowserFolder( browser, elem, true ) );
*/
        }

        expand();
    }

    public void Refresh()
    {
        if( pActivity == null )     return;

        setString( pActivity.GetName() );

        getBrowser().dataChanged();
    }

}







/*
class ProcBrowserItem extends BrowserItem
    implements ProcBrowserNode
{
    CAbstractActivity       pActivity;

    public ProcBrowserItem ( Browser browser, CAbstractActivity act )
    {
        super( browser, (act == null) ? "NULL Activity" : act.GetName() );
        pActivity = act;
    }

    public CAbstractActivity  GetActivity()     { return pActivity; }

    public void Refresh()
    {
        setString( pActivity.GetName() );
        getBrowser().dataChanged();
    }

}

*/