/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Package: TOOL.PROCESS.CLIENT
 * Classe:  ProcessGUIToolManager
\******************************************************************************/

package TOOL.PROCESS.CLIENT;

import  java.awt.*;

import  com.sun.java.swing.*;
import  com.sun.java.swing.event.*;


import  COPSE.CEvent;
import  COPSE.CLIENT.*;
import  COPSE.CLIENT.GUI.*;
import  COPSE.CONTROL.*;

import  GRAPH.*;

//import  TOOL.PROCESS.*;

//temp - DEBUG
//import FILE.*;
//import FILE.OBJ.*;

public class    ProcessGUIToolManager
    extends     CGUIToolManager
    //implements  WindowListener, CClientFileControllerListener
{
/*
    protected   ProcessClassControl     pClassControl;
    protected   ProcessRelationControl  pRelationControl;

    protected   ProcessCanvas           pProcessCanvas;
    protected   CProcessGraphElement    pSelectedElement;
*/

    public String  GetTitle ()
    {   return "COPE - Cooperative Process Editor";  }

    public ProcessGUIToolManager ( CGUIManager gui )
    {
        super( gui );
    }

    protected CClient   CreateClient( int userId, String userName, String host, int port )
        throws Exception
    {
        return new ProcessClient( userId, userName, host, port );
    }


    public void AddMenu ( MenuBar menuBar )
    {
        super.AddMenu( menuBar );

/*
        // Add specific tool menus and controls...
        pClassControl = new ProcessClassControl(this);
        pClassControl.AddMenu( menuBar );

        pRelationControl = new ProcessRelationControl(this);
        pRelationControl.AddMenu( menuBar );
*/
}



//    public      ProcessCanvas   GetCanvas()             { return pProcessCanvas; }



    public      void        ChangeMenuSettings()
    {
        super.ChangeMenuSettings();

        //pClassControl.ChangeMenuSettings();
        //pRelationControl.ChangeMenuSettings();
    }

/*
    public      void        SetSelectedElement( CProcessGraphElement element )
    {
        if( (pSelectedElement!=null) && (pSelectedElement instanceof CProcessGraphClass) )
            pClassControl.SetSelectedElement( null );
/* * /
        else
        if( pSelectedElement instanceof CProcessGraphRelation )
            pRelationControl.SetSelectedElement( null );
/* * /

        pSelectedElement = element;

        if( (pSelectedElement!=null) && (pSelectedElement instanceof CProcessGraphClass) )
            pClassControl.SetSelectedElement( (CProcessGraphClass)pSelectedElement );
/* * /
        else
        if( pSelectedElement instanceof CProcessGraphRelation )
            pRelationControl.SetSelectedElement( (CProcessGraphRelation)pSelectedElement );
/* * /
    }

/* */


    protected   Panel       CreateClientPanel()
    {
        Panel p;
        p = new Panel();

        GridBagLayout layout = new GridBagLayout();
        p.setLayout( layout );

        // Tree List
        //List processList = new List();
        //processList.add("Activity 1");
        //processList.add("Activity 2");
        //processList.add("Activity 3");
        TreeNode   processTreeRoot     = new TreeNode( "Process" );
        processTreeRoot.insert( new TreeNode( "Activity 1" ), 0 );
        processTreeRoot.insert( new TreeNode( "Activity 2" ), 1 );
        processTreeRoot.insert( new TreeNode( "Activity 3" ), 2 );

        JTreeModel  processTreeModel    = new JTreeModel( processTreeRoot );
        JTree       processTree         = new JTree( processTreeModel );
        //processTree.

        JScrollPane treePanel = new JScrollPane();
        treePanel.getViewport().add( processTree );

        GridBagConstraints constraints = new GridBagConstraints();
		constraints.gridx = 0;
		constraints.gridy = 0;
		constraints.gridwidth = 1;
		constraints.gridheight = 1;
		constraints.weightx = 100;
		constraints.weighty = 300;
		constraints.fill = GridBagConstraints.BOTH;
		constraints.insets = new Insets(10,10,10,10);
		//layout.setConstraints(processList, constraints);
		//p.add(processList);
		//layout.setConstraints(processTree, constraints);
		//p.add(processTree);
		layout.setConstraints(treePanel, constraints);
		p.add(treePanel);


        // Panel: Activity Info
        Panel activityPanel = new Panel();
        activityPanel.setLayout( new BorderLayout() );

        Panel southPanel = new Panel();
        southPanel.setLayout( new FlowLayout(FlowLayout.CENTER) );

        Label lockedMessageLabel = new Label("Label in the south of Activity Panel - Not locked");
        southPanel.add( lockedMessageLabel );
        southPanel.add( new Button("  Lock  ") );
        southPanel.add( new Button(" Unlock ") );

        activityPanel.add( "South", southPanel );

        //constraints = new GridBagConstraints();
		constraints.gridx = 1;
		constraints.gridy = 0;
		constraints.gridwidth = 2;
		constraints.gridheight = 1;
		constraints.weightx = 100;
		constraints.weighty = 300;
		constraints.fill = GridBagConstraints.BOTH;
		constraints.insets = new Insets(0,0,0,0);
		layout.setConstraints(activityPanel, constraints);
		p.add(activityPanel);


        //p.pack();

        return p;
    }


    public void CloseClient( boolean exit )
    {
        //pClassControl.SetEnabled( false );
        //pRelationControl.SetEnabled( false );
        //pProcessCanvas.SetFileController( null );

        super.CloseClient( exit );

        if( pClient == null )
        {
        }
    }



/*
    public void CreateNewClass( Rectangle rect )
    {
        ProcessDlgClassNew dlg = new ProcessDlgClassNew( this, rect );
        dlg.setVisible( true );
    }

    public void CreateNewRelation( CPolyline poly, CObjClass classes[] )
    {
        int classesId[] = new int[2];
        CSidePosition sides[] = new CSidePosition[2];
        Point first, last, aux;

        first = poly.GetFirstPoint();
        last = poly.GetLastPoint();

        poly.RemovePoint( first );
        poly.RemovePoint( last );


        classesId[0] = classes[0].GetId();
        {   try {
                aux = poly.GetFirstPoint();
            } catch (Exception e) { aux = last; }
        }
        sides[0] = CSidePosition.CreateSidePosition( classes[0].GetRegion(), first, aux );


        classesId[1] = classes[1].GetId();
        {   try {
                aux = poly.GetLastPoint();
            } catch (Exception e) { aux = first; }
        }
        sides[1] = CSidePosition.CreateSidePosition( classes[1].GetRegion(), last, aux );


        ProcessDlgRelationNew dlg = new ProcessDlgRelationNew( this, poly, classesId, sides );
        dlg.setVisible( true );
    }

*/

    //* FileController Listener Methods
    public void  FileControllerLoaded()
    {
        super.FileControllerLoaded();

        System.err.println( "{DEBUG} ProcessGUIToolManager - FileController Loaded..." );
//        pProcessCanvas.SetFileController( pClient.GetFileController() );
        //pClientPanel.repaint(); // ?

//        pClassControl.Activate();
//        pRelationControl.Activate();
    }

    public void  ElementStateChanged (int elemId, CEvent event)
    {
        int type = event.GetType();
/*
        //pClientPanel.repaint(); // ?
        switch( type )
        {
            case CEvent.EvCOPSE_FileController_Element_New:
                {
                    pProcessCanvas.AddElement( elemId );
                    int connId = ((Integer) event.GetArgumentAt(0) ).intValue();
                    if( pClient.GetSessionManager().GetClientSession().GetConnectionId() == connId )
                        pProcessCanvas.SelectElement( elemId );
                }
                break;

            case CEvent.EvCOPSE_FileController_Element_Delete:
                pProcessCanvas.RemoveElement( elemId );
                break;


            case CEvent.EvCOPSE_FileController_Element_Lock:
                {
                    if( (pSelectedElement != null) &&
                        (pSelectedElement.GetElementController().GetElement().GetId() == elemId) )
                    {

                        if( (pClassControl.GetSelectedElement() == pSelectedElement) && pClassControl.IsWaitingForLock() )
                        {
                            pClassControl.ReceiveLockConfirmation();
                        }

                        else
                        if( (pRelationControl.GetSelectedElement() == pSelectedElement) && pRelationControl.IsWaitingForLock() )
                        {
                            pRelationControl.ReceiveLockConfirmation();
                        }
                    }

                    pProcessCanvas.UpdateElement( elemId );
                }
                break;

            // TEMP - DEBUG
            case CEvent.EvCOPSE_FileController_Element_Update:
                {
                    CElement elem = pClient.GetFileController().GetFile().GetElement( elemId );
                    if( elem instanceof CObjRelation )
                    {
                        System.err.println( "[DEBUG] ProcessGUIToolManager - Received Event Update Relation: ");
                        elem.DEBUG_write( System.err );
                    }
                }
                //break;

            default:
                pProcessCanvas.UpdateElement( elemId );
        }
        pProcessCanvas.repaint();

*/
    }


}


