/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * package: TOOL.PROCESS.SERVER
 * Classe: ProcessServerEventHandler
\******************************************************************************/

package TOOL.PROCESS.SERVER;

import  COPSE.*;
import  COPSE.CONTROL.*;
import  COPSE.SERVER.*;

import  FILE.*;
import  PROCESS2.*;
/*
import  PROCESS.*;
import  PROCESS.MODEL.*;
*/

//import  TOOL.PROCESS.CProcessFileController;



/* ****************************************************************************
 * class ProcessServerEventHandler
 ******************************************************************************/
public class    ProcessServerEventHandler
    extends     CServerEventHandler
{
    protected   CFileController   pFileController = null;

    public ProcessServerEventHandler( CServer server )
    {   super( server );  }

    protected void ProcessEvent( CEvent event, CConnectionHandler handler )
    {
        CUserConnectionHandler userHandler = null;
        if( handler instanceof CUserConnectionHandler ) // Of course it's true, but ...
            userHandler = (CUserConnectionHandler) handler;

        if( pFileController == null )
            pFileController = pServer.GetFileController();


        int type = event.GetType();

        switch( type )
        {

 /*
            case CEvent.EvCOPSE_FileController_Element_Visual:
                {
                    int elemId = ((Integer)event.GetArgumentAt(0)).intValue();
                    int visual = ((Integer)event.GetArgumentAt(1)).intValue();

                    pFileController.SetElementVisual( elemId, visual );
                    pSessionManager.NotifyAllExcept( (CServerUserSession)userHandler.GetUserSession(), event );
                }
                break;

            case CEvent.EvProcessEditor_Class_Position:
                {
                    int classId = ((Integer) event.GetArgumentAt(0)).intValue();
                    Rectangle r = (Rectangle) event.GetArgumentAt(1);

                    CElement elem = pFileController.GetFile().GetElement( classId );
                    if( elem instanceof CObjClass )
                    {
                        CObjClass aclass = (CObjClass) elem;
                        aclass.SetRegion( r );
                        pSessionManager.NotifyAll( event );
                    }
                }
                break;

            case CEvent.EvProcessEditor_Relation_Position:
                {
                    int relationId = ((Integer) event.GetArgumentAt(0)).intValue();
                    CSidePosition ext0 = (CSidePosition) event.GetArgumentAt(1);
                    CSidePosition ext1 = (CSidePosition) event.GetArgumentAt(2);
                    CPolyline poly = (CPolyline) event.GetArgumentAt(3);

                    CElement elem = pFileController.GetFile().GetElement( relationId );
                    if( elem instanceof CObjRelation )
                    {
                        CObjRelation relation = (CObjRelation) elem;

                        relation.GetExtremity(0).SetSidePosition( ext0 );
                        relation.GetExtremity(1).SetSidePosition( ext1 );
                        relation.SetInternalPoints( poly.GetPoints() );

                        pSessionManager.NotifyAll( event );
                    }
                }
                break;
*/

            case CEvent.EvCOPSE_FileController_Element_New:
                {
                    CElement elem = (CElement) event.GetArgumentAt(1);

                    if( elem instanceof CActivity )
                    {
                        CActivity act = (CActivity) elem;
                        Integer idParent = (Integer) event.GetArgumentAt(2);

                        CActivity parent = (CActivity) pFileController.GetFile().GetElement( idParent.intValue() );

                        parent.AddActivity( act, false );
                    }


                }
                break;

            default:
                break;
        }


        super.ProcessEvent( event, handler );

    }
}
