/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Package: TOOL.UML
 * Classe:  CUMLGraphLabel
\******************************************************************************/

package TOOL.UML;

import  java.awt.*;

import  FILE.*;
import  FILE.OBJ.*;

import  GRAPH.*;


/*************************************************************************
 *  Class CUMLGraphLabel
 *************************************************************************/
public class CUMLGraphLabel
    extends CGrpObject
{
    // Data
    protected   CObjLabel    pLabel;


    // Presentation
    protected CGrpLabel      pgText;
    protected CGrpTriangle   pgArrow;

    public CUMLGraphLabel ( CObjLabel label )
    {
        pLabel = label;
        _CreateGraphicObjects();
    }

    public void _CreateGraphicObjects()
    {
        Point p = pLabel.GetPoint();
        p = new Point( p.x, p.y );
        Rectangle recArrow;
        int align = 0;

        switch( pLabel.GetAlign() )
        {
            case CObjLabel.AlignCenter: // CENTER
                recArrow = new Rectangle( p.x-8, p.y+2, 6, 6 );
                break;
            case CObjLabel.AlignRight: // RIGHT
                p.x -= 10;
                recArrow = new Rectangle( p.x+2, p.y+2, 6, 6 );
                align = CObjLabel.AlignRight; // RIGHT
                break;
            default: // LEFT
                recArrow = new Rectangle( p.x+2, p.y+2, 6, 6 );
                p.x += 10;
        }

        pgArrow = new CGrpTriangle( recArrow, pLabel.GetArrow() );
        pgArrow.SetFilled( true );
        pgArrow.SetFillColor( Color.black );

        pgText = new CGrpLabel( p, pLabel.GetText(), align );
    }

    public void Draw( CGraphics g1 )
    {
        //CGraphics g1 = g.create();

        pgArrow.Draw( g1 );
        pgText.Draw( g1 );
    }

    public boolean Contains( int x, int y )
    {
        return pgText.Contains( x,y );
    }
}


