
import java.util.*;

import BW.typeIdDefault;
import BW.kernel.*;
import BW.storage.*;


public class testJan {

    static ST_DatabaseImplementor db;


    ////////////////////////// WRITE E READ STRING ///////////////////////////////////////////

    public static void writeString () {

         //criando um profile simples
         BW_Profile prof = new BW_Profile(typeIdDefault.BW_PROFILE,typeIdDefault.OBJID);
       	 BW_TimeInterval tmi = new BW_TimeInterval(typeIdDefault.BW_TIMEINTERVAL,
       	 					   typeIdDefault.BW_TIMEINTERVAL,
       	 					   TimeZone.getDefault(),
       	 					   Locale.getDefault());
	 Calendar c = tmi.getBegin();
	 c.roll (Calendar.DATE,false);
         tmi.setBegin (c);
        	
         prof.setInterval (tmi);

         System.out.println (prof);

         //montando o SQL
         //TEMPO ARMAZENADO EM SEGUNDOS
         String SQLtext="INSERT INTO t_profile (typeid, objid, bg, ed, tmz, lcl) VALUES (";
         SQLtext += Integer.toString(prof.getTypeId());				SQLtext += ", ";
         SQLtext += Integer.toString(prof.getObjId());				SQLtext += ", ";				
         SQLtext += Long.toString (prof.getInterval().getBeginMillis()/1000);	SQLtext += ", ";
         SQLtext += Long.toString (prof.getInterval().getEndMillis()/1000);		SQLtext += ", ";
	 SQLtext += "\'"+prof.getInterval().getTimeZone().getID()+"\'";		SQLtext += ", ";
	 SQLtext += "\'"+prof.getInterval().getLocale().toString()+"\'";
	 SQLtext += ")";
	
	 System.out.println ("------------ Executing "+SQLtext+": ");
	 boolean ret = db.write(SQLtext);	
	 System.out.println ("Operation status: "+ret);
	

    }

    public static void readString () {
    	//montando SQL
    	String SQLtext="select * from t_profile";
    	
    	//lendo um profile    	
    	System.out.println ("-------------- Executing "+SQLtext);
    	Vector v = db.read (SQLtext);
    	
    	//System.out.println (v);
    	
    	//remontando objetos    	
    	//TEMPO ARMAZENADO EM SEGUNDOS
    	for (int i=0; i<v.size();i++) {
    	    try {
    		Hashtable ht =(Hashtable) v.elementAt(i);
    		BW_Profile prof = new BW_Profile();
    		
    		Integer type = (Integer) ht.get("typeid");
    		Integer obj = (Integer) ht.get ("objid");
    		Long bg = (Long) ht.get ("bg");
    		Long ed = (Long) ht.get ("ed");
    		String tmz = (String) ht.get ("tmz");
    		String lcl = (String) ht.get ("lcl");
    		
    		prof.setTypeId (type.intValue());
    		prof.setObjId (obj.intValue());
    		
    		BW_TimeInterval ti = new BW_TimeInterval();
    		ti.setLocale (lcl);
    		ti.setTimeZone (tmz);
    		ti.setBegin (bg.longValue()*1000);
    		ti.setEnd (ed.longValue()*1000);
    		
    		prof.setInterval (ti);    		
    		
    		System.out.println ("Element "+i+":"+prof);
    		
    	    } catch (Exception ex) {
    	    	System.out.println ("Erro ao remontar profiles..");
    	        ex.printStackTrace();
    	    }	
    		
    	}
    }


   //////////////////////////// WRITE E READ ST_SETUP ////////////////////////////////////

   public static void writeST_Setup () {
   	ST_Setup setup = new ST_Setup();
   	
        setup.setTimeLife (365);
        setup.setIsServer (true);
        setup.setServer	("localhost");

        System.out.println ("--------- Writing ST_Setup: "+setup.toString());
        boolean ret = db.write (setup);
        System.out.println ("Operation status: "+ret);
   }

   public static void readST_Setup () {
   	ST_Setup set = new ST_Setup ();
   	System.out.println ("---------- Reading ST_Setup");
   	try {
   		set = db.read (set);   	   	
   		System.out.println ("ST_Setup readed: "+set.toString());
   	} catch	(Exception e) {
   		System.out.println ("erro ao ler objeto ST_Setup");
   		e.printStackTrace();
   	}
   }


   ////////////////////////// READ E WRITE BW_GROUP //////////////////////////////////////

   public static void read1BW_Group () {
   	BW_Group grp = new BW_Group (typeIdDefault.BW_GROUP,0);
   	
   	System.out.println ("-------------- Reading A Group");
   	try {
	        grp = (BW_Group) db.read (grp,typeIdDefault.BW_GROUP);
        	System.out.println ("BW_Group readed: "+grp);
        } catch (Exception e) {
   		System.out.println ("erro ao ler objeto BW_Group");
   		e.printStackTrace();
        }
   }
        	
   public static void readNBW_Group () {
        BW_Group grp = new BW_Group (typeIdDefault.BW_GROUP,0);
   	System.out.println ("-------------- Reading Groups");
   	try {
	        Vector v = db.read (grp);
	        for (int i=0;i<v.size();i++) {
	        	BW_Group grp2 = (BW_Group) v.elementAt (i);
        		System.out.println ("BW_Group readed: "+grp2);
        	}	
        } catch (Exception e) {
   		System.out.println ("erro ao ler objeto BW_Group");
   		e.printStackTrace();
        }	

   }

   public static void write1BW_Group () {
   		
	BW_Group grp = new BW_Group (typeIdDefault.BW_GROUP,typeIdDefault.BW_GROUP);
	grp.setName ("COPSE/CUTE Group");	
   	grp.setDescription ("Grupo de usuarios do COPSE / CUTE");   	   	

   	BW_Profile pr = new BW_Profile (typeIdDefault.BW_PAPERPROFILE,typeIdDefault.OBJID);
   	BW_Paper pp = new BW_Paper (typeIdDefault.BW_PAPER,typeIdDefault.OBJID+1);
   	pp.setLevel(BW_Paper.MAXIMUM);
   	pp.setName ("papel");
   	pp.setProfile (pr);
   	grp.insertPaper (pp);
   	
   	pr = new BW_Profile (typeIdDefault.BW_PERSONALPROFILE,typeIdDefault.OBJID+2);
   	BW_Member mb = new BW_Member ("teste1",500);
   	mb.setName ("nome");
   	mb.setTypeId(typeIdDefault.BW_MEMBER);
   	mb.insertPersonalProfile (pr);
   	pr = new BW_Profile (typeIdDefault.BW_PERSONALPAPERPROFILE,typeIdDefault.OBJID+3);
   	mb.insertPaper (pp,pr);
   	grp.insertMember (mb);
   	
   	   	
   	System.out.println ("------------- Writing One Group: "+grp);
   	
   	try {
   	    boolean ret = db.write ((BW_Element)grp);
   	    System.out.println ("Operation status: "+ret);
   	}  catch (Exception e) {
   		System.out.println ("erro ao escrever objeto BW_Group");
   		e.printStackTrace();
        }


  }

  public static void writeNBW_Group () {
        BW_Group grp = new BW_Group (typeIdDefault.BW_GROUP,typeIdDefault.BW_GROUP);
	grp.setName ("COPSE/CUTE Group");	
   	grp.setDescription ("Grupo de usuarios do COPSE/CUTE");   	   	
   	grp.setDescription (grp.getDescription()+" (COPPE/UFRJ) ");
   	
   	BW_Profile pr = new BW_Profile (typeIdDefault.BW_PAPERPROFILE,typeIdDefault.OBJID);
   	BW_Paper pp = new BW_Paper (typeIdDefault.BW_PAPER,typeIdDefault.OBJID+1);
   	pp.setLevel(BW_Paper.MAXIMUM);
   	pp.setName ("papel");
   	pp.setProfile (pr);
   	grp.insertPaper (pp);
   	
   	pr = new BW_Profile (typeIdDefault.BW_PERSONALPROFILE,typeIdDefault.OBJID+2);
   	BW_Member mb = new BW_Member ("teste1",500);
   	mb.setName ("nome");
   	mb.setTypeId(typeIdDefault.BW_MEMBER);
   	mb.insertPersonalProfile (pr);
   	pr = new BW_Profile (typeIdDefault.BW_PERSONALPAPERPROFILE,typeIdDefault.OBJID+3);
   	mb.insertPaper (pp,pr);
   	grp.insertMember (mb);
   	
   	BW_Group grp2 = new BW_Group (typeIdDefault.BW_GROUP,typeIdDefault.UNSET);

        System.out.println ("------------- Writing Groups: "+grp+" \n --------- and "+grp2);
   	try {
   	    Vector v = new Vector();
   	    v.addElement (grp);
   	    v.addElement (grp2);
   	    boolean ret = db.write (v);
   	    System.out.println ("Operation status: "+ret);
   	}  catch (Exception e) {
   		System.out.println ("erro ao escrever objeto BW_Group");
   		e.printStackTrace();
        }


   }


   ////////////////////////// READ E WRITE BW_GROUP //////////////////////////////////////

   public static void writeBW_Register () {
   	BW_Register rg = new BW_Register ();
   	rg.setTypeId(typeIdDefault.BW_REGISTER);
   	rg.setObjId (typeIdDefault.BW_REGISTER);
   	
   	BW_Event evt = new BW_Event (101,typeIdDefault.UNSET);
   	rg.insertEvent (evt);
   	evt = new BW_Event (102,typeIdDefault.UNSET);
   	rg.insertEvent (evt);
   	evt = new BW_Event (103,typeIdDefault.UNSET);
   	rg.insertEvent (evt);

   	System.out.println ("------------- Writing register");
   	boolean b = db.write (rg);
   	System.out.println ("Operation status: "+b);
   }

   public static void readBW_Register() {

   	BW_Register rg = new BW_Register();
   	System.out.println ("------------- Reading register");
   	BW_Register rg2 = null;
   	rg2 = (BW_Register)db.read (rg,typeIdDefault.BW_REGISTER);
        System.out.println ("Register: "+rg2);
   }



   ////////////////////////// READ E WRITE BW_EVENT //////////////////////////////////////

   public static Vector prepareEvents () {
   	Vector v = new Vector();

   	BW_Profile pr = new BW_Profile (typeIdDefault.BW_PAPERPROFILE,typeIdDefault.OBJID);
   	BW_Paper pp = new BW_Paper (typeIdDefault.BW_PAPER,typeIdDefault.OBJID+1);
   	pp.setLevel(BW_Paper.MAXIMUM);
   	pp.setName ("papel");
   	pp.setProfile (pr);   	
   	pr = new BW_Profile (typeIdDefault.BW_PERSONALPROFILE,typeIdDefault.OBJID+2);
   	BW_Member mb = new BW_Member ("teste1",500);
   	mb.setName ("nome");
   	mb.setTypeId(typeIdDefault.BW_MEMBER);
   	mb.insertPersonalProfile (pr);
   	pr = new BW_Profile (typeIdDefault.BW_PERSONALPAPERPROFILE,typeIdDefault.OBJID+3);
   	mb.insertPaper (pp,pr);

   	BW_TimeInterval ti = new BW_TimeInterval ();
   	//Calendar td = ti.getBegin();
   	   	  	
   	BW_Event evt = new BW_Event (101,typeIdDefault.OBJID+4);
   	evt.setName ("teste");
   	evt.setDescription ("evento de teste");   	
   	evt.setResponsible (mb);
   	
   	evt.setInterval (ti);
   	evt.setDetails ("1o evento de teste");
   	v.addElement (evt);
   	
   	evt = new BW_Event (101,typeIdDefault.OBJID+5);
   	evt.setName ("teste");
   	evt.setDescription ("evento de teste");   	
   	evt.setResponsible (mb);
   	ti = new BW_TimeInterval ();  	
   	Calendar c = ti.getBegin ();
   	c.roll (Calendar.DATE, false);
   	ti.setBegin (c);
   	evt.setInterval(ti);
   	evt.setDetails ("3o evento de teste");
   	v.addElement (evt);

   	evt = new BW_Event (101,typeIdDefault.OBJID+5);
   	evt.setName ("teste");
   	evt.setDescription ("evento de teste");   	
   	evt.setResponsible (mb);   	
	//ti.setBegin (td);
	ti = new BW_TimeInterval ();
   	c = ti.getBegin ();
   	c.roll (Calendar.DATE, false);
   	c.roll (Calendar.DATE, false);
   	ti.setBegin (c);
   	c = ti.getEnd ();
   	c.roll (Calendar.DATE, false);
   	ti.setEnd (c);   	
   	evt.setInterval(ti);
   	evt.setDetails ("2o evento de teste");
   	v.addElement (evt);
   	   	

   	evt = new BW_Event (102,typeIdDefault.OBJID+6);
   	evt.setName ("teste2");
   	evt.setDescription ("evento de teste 2");   	
   	evt.setResponsible (mb);   	
   	//ti.setBegin (td);
   	//ti.setEnd (td);
   	ti = new BW_TimeInterval ();  	   	
   	c = ti.getBegin ();
   	c.roll (Calendar.DATE, false);
   	ti.setEnd (c);
   	c.roll (Calendar.DATE, false);
   	ti.setBegin (c);
   	evt.setInterval(ti);
   	evt.setDetails ("4o evento de teste");
   	v.addElement (evt);
   	
        return v;
   }


   public static void writeBW_Event () {
        Vector v = prepareEvents();
        System.out.println ("-------------------- Writing 1 event ");
        boolean b = db.write ((BW_Element)v.firstElement());
   	System.out.println ("Operation status: "+b);
   	
        System.out.println ("\n-------------------- Writing N events ");
        //System.out.println (v);
        b = db.write (v);
   	System.out.println ("Operation status: "+b);
   }


   public static void readBW_Event () {
   	System.out.println ("-------------------- Readind 1 event ");
   	BW_Event e1 = (BW_Event) db.read ((BW_Element)new BW_Event(101,typeIdDefault.OBJID+5),typeIdDefault.OBJID+5);
  	System.out.println ("Event Readed: "+e1);
   	
  	System.out.println ("-------------------- Readind N event 102 ");
   	Vector v = db.read ((BW_Element)new BW_Event(102,typeIdDefault.UNSET));
  	System.out.println ("Events Readed: "+v);

  	BW_TimeInterval ti = new BW_TimeInterval();
  	Calendar c = ti.getBegin();
  	c.roll (Calendar.MONTH,false);
  	c.roll (Calendar.YEAR,false);  	
  	ti.setBegin(c);
  	c = ti.getEnd();
  	c.roll (Calendar.DATE,false);
  	ti.setEnd (c);
  	
  	System.out.println ("-------------------- Readind N event in "+ti+" ("+ti.getBeginMillis()/1000+" - "+ti.getEndMillis()/1000+") ");
   	Vector v2 = db.read ((BW_Element)new BW_Event(101,typeIdDefault.UNSET),ti);
  	System.out.println ("Events Readed: "+v2);
  	
  	ti = new BW_TimeInterval ();
  	c = ti.getBegin();
  	c.roll (Calendar.MONTH,false);
  	c.roll (Calendar.YEAR,false);  	
  	ti.setBegin(c);
  	c = ti.getEnd ();
  	c.roll (Calendar.MONTH,true); 	
  	ti.setEnd(c);
  	
  	System.out.println ("-------------------- Readind N event in "+ti+" ("+ti.getBeginMillis()/1000+" - "+ti.getEndMillis()/1000+") ");
   	Vector v3 = db.read ((BW_Element)new BW_Event(101,typeIdDefault.UNSET),ti);
  	System.out.println ("Events Readed: "+v3);

   }



   ////////////////////////// READ E WRITE BW_PROFILE //////////////////////////////////////

   public static void writeBW_Profile () {
   	BW_Profile pr = new BW_Profile (typeIdDefault.BW_PROFILE,typeIdDefault.OBJID);
   	BW_Event evt = new BW_Event (101,typeIdDefault.UNSET);
   	pr.insertEvent (evt);
   	evt = new BW_Event (103,typeIdDefault.UNSET);
   	pr.insertEvent (evt);
        BW_TimeInterval ti = pr.getInterval();
        Calendar c = ti.getBegin();
        c.roll (Calendar.DATE,false);
        ti.setBegin(c);
        pr.setInterval(ti);
   	
   	System.out.println ("--------------- writing 1 Profile");
   	boolean b = db.write (pr);
   	System.out.println ("Operation status: "+b);
   	
   	
   	System.out.println ("--------------- writing N Profiles");
   	Vector v = new Vector();
   	v.addElement (pr);

   	pr = new BW_Profile (typeIdDefault.BW_PROFILE,typeIdDefault.OBJID+1);
   	evt = new BW_Event (102,typeIdDefault.UNSET);
   	pr.insertEvent (evt);
   	ti = pr.getInterval();
        c = ti.getBegin();
        c.roll (Calendar.DATE,false);
        ti.setBegin(c);
        c = ti.getEnd();
        c.roll (Calendar.DATE,true);
        ti.setEnd(c);
        pr.setInterval(ti);
   	v.addElement (pr);
   	
   	pr = new BW_Profile (typeIdDefault.BW_PERSONALPROFILE,typeIdDefault.OBJID+2);
   	evt = new BW_Event (102,typeIdDefault.UNSET);
   	pr.insertEvent (evt);
   	evt = new BW_Event (103,typeIdDefault.UNSET);
   	pr.insertEvent (evt);
   	ti = pr.getInterval();
        c = ti.getBegin();
        c.roll (Calendar.DATE,false);
        c.roll (Calendar.DATE,false);
        ti.setBegin(c);
        pr.setInterval(ti);
   	v.addElement (pr);

   	pr = new BW_Profile (typeIdDefault.BW_PROFILE,typeIdDefault.OBJID+3);
   	evt = new BW_Event (101,typeIdDefault.UNSET);
   	pr.insertEvent (evt);
   	ti = pr.getInterval();
        c = ti.getBegin();
        c.roll (Calendar.DATE,false);
        c.roll (Calendar.DATE,false);
        ti.setBegin(c);
        c = ti.getEnd();
        c.roll (Calendar.DATE,false);
        ti.setEnd(c);
        pr.setInterval(ti);   	
   	v.addElement (pr);
   	   	   	
   	b = db.write (v);
   	System.out.println ("Operation status: "+b);   	
   	
   }


   public static void readBW_Profile() {
   	System.out.println ("--------------- reading 1 profile");
   	BW_Profile p = (BW_Profile) db.read ( new BW_Profile(typeIdDefault.BW_PERSONALPROFILE,typeIdDefault.UNSET),
   					      typeIdDefault.OBJID+2 );
   	System.out.println ("Profile reade: "+p);	
   	
   	System.out.println ("--------------- reading N profiles");
   	Vector v = db.read ( new BW_Profile(typeIdDefault.BW_PROFILE,typeIdDefault.UNSET) );
   	System.out.println ("Profiles readed ("+v.size()+"): "+v);
   	
   	BW_TimeInterval t = new BW_TimeInterval();
   	Calendar c = t.getBegin();
   	c.roll (Calendar.DATE,false);
   	c.set (Calendar.HOUR_OF_DAY,0);
   	c.set (Calendar.MINUTE,0);
   	c.set (Calendar.SECOND,0);
   	t.setBegin(c);
      	c = t.getEnd();
      	c.roll (Calendar.DATE,true);
      	t.setEnd (c);
      	
      	System.out.println ("--------------- reading N Profiles IN "+t+"("+t.getBeginMillis()+" - "+t.getEndMillis()+")");
   	Vector v2 = db.read ( new BW_Profile(typeIdDefault.BW_PROFILE,typeIdDefault.UNSET), t );
   	System.out.println ("Profiles readed ("+v2.size()+"): "+v2);   				
   }


   /////////////////////////////// READ E WRITE BW_AWARENESSPROFILE ///////////////////////////////

   public static BW_AwarenessProfile getProfile () {
   	BW_Profile p1 = new BW_Profile (typeIdDefault.BW_PERSONALPROFILE,typeIdDefault.OBJID+1);   	
        BW_Event e1 = new BW_Event (101,typeIdDefault.UNSET);
        BW_TimeInterval ti = new BW_TimeInterval ();
        Calendar c1 = Calendar.getInstance (ti.getTimeZone(),ti.getLocale());
        c1.set ( 2001,0,18,0,0,0 );
        ti.setBegin (c1);
        c1.clear ();
        c1.set ( 2001,0,23,0,0,0 );
        ti.setEnd (c1);
        p1.setInterval (ti);
        p1.insertEvent (e1);
	
	BW_Profile p2 = new BW_Profile (typeIdDefault.BW_PERSONALPROFILE,typeIdDefault.OBJID+2);   	
        e1 = new BW_Event (102,typeIdDefault.UNSET);
        ti = new BW_TimeInterval ();
        c1 = Calendar.getInstance (ti.getTimeZone(),ti.getLocale());
        c1.set ( 2001,0,18,0,0,0 );
        ti.setBegin (c1);
        c1.clear ();
        c1.set ( 2001,0,23,23,59,59 );
        ti.setEnd (c1);
        p2.setInterval (ti);
        p2.insertEvent (e1);


        BW_Profile p3 = new BW_Profile (typeIdDefault.BW_PERSONALPAPERPROFILE,typeIdDefault.OBJID+3);
        e1 = new BW_Event (103,typeIdDefault.UNSET);
        ti = new BW_TimeInterval ();
        c1 = Calendar.getInstance (ti.getTimeZone(),ti.getLocale());
        c1.set (2001,0,17,0,0,0);
        ti.setBegin (c1);
        c1.clear ();
        c1.set (2001,0,20,23,59,59);
        ti.setEnd (c1);
        p3.setInterval (ti);
        p3.insertEvent (e1);
        BW_Paper pp1 = new BW_Paper (typeIdDefault.BW_PAPER,typeIdDefault.OBJID+6);
        pp1.setLevel (BW_Paper.MAXIMUM);
        pp1.setName ("Max");
        BW_Profile prof = new BW_Profile (typeIdDefault.BW_PAPERPROFILE,typeIdDefault.OBJID+8);
        BW_Event evt = new BW_Event (108,typeIdDefault.UNSET);
        pp1.setProfile (prof);

        BW_Profile p4 = new BW_Profile (typeIdDefault.BW_PERSONALPAPERPROFILE,typeIdDefault.OBJID+4);
        e1 = new BW_Event (104,typeIdDefault.UNSET);
        ti = new BW_TimeInterval ();
        c1 = Calendar.getInstance (ti.getTimeZone(),ti.getLocale());
        c1.set (2001,0,17,0,0,0);
        ti.setBegin (c1);
        c1.clear ();
        c1.set (2001,0,22,23,59,59);
        ti.setEnd (c1);
        p4.setInterval (ti);
        p4.insertEvent (e1);
        BW_Paper pp2 = new BW_Paper (typeIdDefault.BW_PAPER,typeIdDefault.OBJID+7);
        pp2.setLevel (BW_Paper.MINIMUM);
        pp2.setName ("Min");
        prof = new BW_Profile (typeIdDefault.BW_PAPERPROFILE,typeIdDefault.OBJID+9);
        evt = new BW_Event (109,typeIdDefault.UNSET);
        pp2.setProfile (prof);

        BW_AwarenessProfile p5 = new BW_AwarenessProfile (typeIdDefault.BW_AWARENESSPROFILE,typeIdDefault.OBJID+5);
        p5.insertPersonalProfile (p1);
        p5.insertPersonalProfile (p2);
        p5.insertPersonalPaperProfile (p3,pp1);
        p5.insertPersonalPaperProfile (p4,pp2);
        p5.setInterval (p5.getGlobalInterval());

        return p5;
   }

   public static void writeBW_AwarenessProfile () {   	

        BW_AwarenessProfile p5 = getProfile();
    	System.out.println ("--------------- writing 1 Awareness Profile");
    	//System.out.println (p5);
   	boolean b = db.write (p5);
   	System.out.println ("Operation status: "+b);

   	BW_AwarenessProfile p6 = getProfile();
   	p6.setObjId (typeIdDefault.OBJID+10);
   	Vector v = new Vector();
   	v.addElement (p5);
   	v.addElement (p6);
   	
   	System.out.println ("--------------- writing N Awareness Profile");
   	b = db.write (v);
	System.out.println ("Operation status: "+b);   	
   }


   public static void readBW_AwarenessProfile () {
	System.out.println ("--------------- reading 1 Awareness Profile");
   	BW_AwarenessProfile p = (BW_AwarenessProfile) db.read (new BW_AwarenessProfile (typeIdDefault.BW_AWARENESSPROFILE,typeIdDefault.OBJID+5),typeIdDefault.OBJID+5);
        System.out.println ("Readed: "+p);

        System.out.println ("--------------- reading N Awareness Profile");
	Vector v = db.read (new BW_AwarenessProfile (typeIdDefault.BW_AWARENESSPROFILE,typeIdDefault.UNSET));
	System.out.println ("Readed ("+v.size()+"): "+v);
	
	Calendar c1 = Calendar.getInstance();
	c1.set ( 2001 , 0 , 17 , 0 , 0 , 0 );
	Calendar c2 = Calendar.getInstance();
	c2.set ( 2001 , 0 , 20 , 0 , 0 , 0 );
	BW_TimeInterval ti = new BW_TimeInterval (0,0,c1,c2);
	
	System.out.println ("--------------- reading N Awareness Profile in "+ti+"("+ti.getBeginMillis()+"-"+ti.getEndMillis()+")");	
	v = db.read (new BW_AwarenessProfile (typeIdDefault.BW_AWARENESSPROFILE,typeIdDefault.UNSET), ti);
	if (v!=null)
		System.out.println ("Readed ("+v.size()+"): "+v);
	else
		System.out.println ("Nothing readed");
	
	c2.set ( 2001, 0, 24, 0, 0, 0 );
	ti.setEnd (c2);
	System.out.println ("--------------- reading N Awareness Profile in "+ti+"("+ti.getBeginMillis()+"-"+ti.getEndMillis()+")");	
	v = db.read (new BW_AwarenessProfile (typeIdDefault.BW_AWARENESSPROFILE,typeIdDefault.UNSET), ti);
	if (v!=null)
		System.out.println ("Readed ("+v.size()+"): "+v);
	else
		System.out.println ("Nothing readed");
	
   }



   //////////////////////////////////// READ E WRITE PAPER /////////////////////////////////

   public static void writeBW_Paper () {
   	Vector v = new Vector();
   	
   	BW_Profile prof = new BW_Profile (typeIdDefault.BW_PAPERPROFILE,typeIdDefault.OBJID+20);
   	prof.insertEvent (new BW_Event (200,typeIdDefault.UNSET));   	
   	BW_Paper pa1 = new BW_Paper (typeIdDefault.BW_PAPER,typeIdDefault.OBJID+30);
   	pa1.setLevel (BW_Paper.MINIMUM);
   	pa1.setName ("leitor");
   	pa1.setDescription ("leitor - teste de papel");
   	pa1.setProfile (prof);
   	v.addElement(pa1);
   	
   	prof = new BW_Profile (typeIdDefault.BW_PAPERPROFILE,typeIdDefault.OBJID+21);
   	prof.insertEvent (new BW_Event (201,typeIdDefault.UNSET));   	
   	pa1 = new BW_Paper (typeIdDefault.BW_PAPER,typeIdDefault.OBJID+31);
   	pa1.setLevel (BW_Paper.MAXIMUM);
   	pa1.setName ("coordenator");
   	pa1.setDescription ("coordenador - teste de papel");
   	pa1.setProfile (prof);
   	v.addElement(pa1);
   	
   	prof = new BW_Profile (typeIdDefault.BW_PAPERPROFILE,typeIdDefault.OBJID+22);
   	prof.insertEvent (new BW_Event (202,typeIdDefault.UNSET));   	
   	pa1 = new BW_Paper (typeIdDefault.BW_PAPER,typeIdDefault.OBJID+32);
   	pa1.setLevel (BW_Paper.MINIMUM/2);
   	pa1.setName ("member");
   	pa1.setDescription ("participante comum - teste de papel");
   	pa1.setProfile (prof);
   	v.addElement(pa1);
   	
   	System.out.println ("--------------- writing 1 Paper ");
   	boolean b = db.write ((BW_Paper)v.firstElement());
   	System.out.println ("Operation Status: "+b);
   	
   	System.out.println ("--------------- writing N Papers ");
   	b = db.write (v);
   	System.out.println ("Operation Status: "+b);
   	
   }


   public static void readBW_Paper () {
      	System.out.println ("--------------- reading 1 Paper ");
   	BW_Paper pap = (BW_Paper)db.read (new BW_Paper(typeIdDefault.BW_PAPER,typeIdDefault.OBJID+30),typeIdDefault.OBJID+30);
        System.out.println ("Readed: "+pap);

      	System.out.println ("--------------- reading N Papers ");
   	Vector v = db.read (new BW_Paper(typeIdDefault.BW_PAPER,typeIdDefault.UNSET));
        System.out.println ("Readed ("+v.size()+"): "+v);

   }



   //////////////////////////////////// READ E WRITE PAPER /////////////////////////////////

   public static Vector makeMembers () {
   	Vector v = new Vector();
   	
   	/////////////////////////////////////////////////
   	
   	BW_Member teste1 = new BW_Member ("teste1",500);
   	teste1.setName ("Usuario de teste 1");
   	teste1.setMail ("teste1@localhost");
   	teste1.setHomePage ("http://localhost/~teste1/");
   	teste1.setMachine ("localhost");   	
   	
   	Calendar c1teste1 = Calendar.getInstance ();
   	Calendar c2teste1 = Calendar.getInstance ();
   	c1teste1.set ( 2001, 0, 10, 9, 0, 0 );
   	c2teste1.set ( 2001, 0, 15, 15, 0, 0);
   	BW_TimeInterval titeste1 =  new BW_TimeInterval (0,0,c1teste1,c2teste1);
   	teste1.setLastLogin (titeste1);
   	
   	BW_AwarenessProfile apteste1 = teste1.getAwarenessProfile();
   	apteste1.setTypeId (typeIdDefault.BW_AWARENESSPROFILE);
   	apteste1.setObjId (3000);
   	BW_Profile PPteste1 = new BW_Profile (typeIdDefault.BW_PERSONALPROFILE,3001);
        BW_Event e101 = new BW_Event (101,typeIdDefault.UNSET);
        PPteste1.insertEvent (e101);
        apteste1.insertPersonalProfile (PPteste1);
        teste1.setAwarenessProfile(apteste1);

        BW_Paper max = new BW_Paper (typeIdDefault.BW_PAPER,3004);
        max.setLevel (BW_Paper.MAXIMUM);
        max.setName ("MAX");
        max.setDescription ("Max paper");
        BW_Profile PPmax = new BW_Profile (typeIdDefault.BW_PAPERPROFILE,3006);
        BW_Event e104 = new BW_Event (104,typeIdDefault.UNSET);
        PPmax.insertEvent (e104);
        max.setProfile (PPmax);

        BW_Profile PPmaxteste1 = new BW_Profile (typeIdDefault.BW_PERSONALPAPERPROFILE, 3002);
        BW_Event e102 = new BW_Event (102,typeIdDefault.UNSET);
        PPmaxteste1.insertEvent (e102);

        teste1.insertPaper (max,PPmaxteste1);

        BW_Paper min = new BW_Paper (typeIdDefault.BW_PAPER,3005);
        min.setLevel (BW_Paper.MINIMUM);
        min.setName ("MIN");
        min.setDescription ("Min paper");
        BW_Profile PPmin = new BW_Profile (typeIdDefault.BW_PAPERPROFILE,3007);
        min.setProfile (PPmin);

        BW_Profile PPminteste1 = new BW_Profile (typeIdDefault.BW_PERSONALPAPERPROFILE, 3003);
        BW_Event e103 = new BW_Event (103,typeIdDefault.UNSET);
        PPminteste1.insertEvent (e103);

        teste1.insertPaper (min,PPminteste1);

        teste1.setActivePaper (max);

        v.addElement (teste1);

        ///////////////////////////////////////////////////////////////////////////

        BW_Member teste2 = new BW_Member ("teste2",510);
   	teste2.setName ("Usuario de teste 2");
   	   	
   	BW_AwarenessProfile apteste2 = teste2.getAwarenessProfile();
   	apteste2.setTypeId (typeIdDefault.BW_AWARENESSPROFILE);
   	apteste2.setObjId (3010);
        teste2.setAwarenessProfile(apteste2);

        BW_Profile PPminteste2 = new BW_Profile (typeIdDefault.BW_PERSONALPAPERPROFILE, 3011);
        //BW_Event e103 = new BW_Event (103,typeIdDefault.UNSET);
        PPminteste2.insertEvent (e103);

        teste2.insertPaper (min,PPminteste2);

        v.addElement (teste2);

        /////////////////////////////////////////////////////////////////////////

        return v;
   }


   public static void writeBW_Member () {
   	Vector v = makeMembers ();
   	System.out.println ("--------------- Writing 1 member");
   	System.out.println (v.firstElement());
   	boolean b = db.write ((BW_Member)v.firstElement());
   	System.out.println ("Operation status: "+b);

   }

   public static void readBW_Member ()  {
   	System.out.println ("--------------- Reading 1 member");
   	BW_Member lixo = new BW_Member ();
   	lixo.setTypeId (typeIdDefault.BW_MEMBER);
   	lixo.setObjId (500);
	BW_Member m = (BW_Member) db.read (lixo,500);
        System.out.println ("Readed: "+m);

   	System.out.println ("--------------- Reading 1 non-existant member");
   	lixo = new BW_Member ();
   	lixo.setTypeId (typeIdDefault.BW_MEMBER);
   	lixo.setObjId (100);
	BW_Member mnull = (BW_Member) db.read (lixo,100);
        System.out.println ("Readed: "+mnull);

	BW_Paper pap = m.getPaper("MAX");		
        System.out.println ("Paper: "+pap);
	m.setActivePaper (pap);
	
	BW_AwarenessProfile ap = m.getAwarenessProfile();
	BW_Profile pp = ap.getPersonalPaperProfile (pap);

        System.out.println ("Readed: "+pp);

	BW_Event evt = new BW_Event (201,typeIdDefault.UNSET);
	pp.insertEvent (evt);
	m.setPersonalPaperProfile (pap,pp);
	
	
	BW_AwarenessProfile ap2 = m.getAwarenessProfile();
	BW_Paper pap2 = m.getActivePaper();	
	BW_Paper pap3 = m.getPaper (pap2.getName());
        System.out.println ("ActivePaper: "+pap3);
	BW_Profile pp2 = ap2.getPersonalPaperProfile (pap3);
        System.out.println ("Readed: "+pp2);

   }









    ////////////////////////////////////////////////////////////////////////////////////////
    public static void main (String args[]) {
    	
	    TimeZone tmz = TimeZone.getTimeZone ("BET");
	    Locale lcl = new Locale ("pt","BR");
	    TimeZone.setDefault (tmz);
	    Locale.setDefault (lcl);
	    db = new ST_DatabaseImplementor("localhost");
            boolean done = false;
	
	    for (int i=0;i<args.length;i++) {
	    	done = true;
	        int j = Integer.parseInt (args[i]);
		switch (j) {	
		  case 1:
			System.out.println ("******************** write (String) and read (String) ... ");
			writeString();
                        readString();
                        break;
		  case 2:
			System.out.println ("******************** write (ST_Setup) and read (ST_Setup) ... ");
			writeST_Setup();
                        readST_Setup();
                        break;

		  case 3:
			System.out.println ("******************** write (BW_Group) and read (BW_Group) ... ");
			write1BW_Group();
                        read1BW_Group();
                        System.out.println ("\n");
			writeNBW_Group();
                        readNBW_Group();
                        break;

		  case 4:
			System.out.println ("******************** write (BW_Register) and read (BW_Register) ... ");
			writeBW_Register();
                        readBW_Register();
                        break;
		
		  case 5:
			System.out.println ("******************** write (BW_Event) and read (BW_Event) ... ");
			writeBW_Event();
                        readBW_Event();
                        break;

		  case 6:
			System.out.println ("******************** write (BW_Profile) and read (BW_Profile) ... ");
			writeBW_Profile();
                        readBW_Profile();
                        break;

		  case 7:
			System.out.println ("******************** write (BW_AwarenessProfile) and read (BW_AwarenessProfile) ... ");
			writeBW_AwarenessProfile();
                        readBW_AwarenessProfile();
                        break;

		  case 8:
			System.out.println ("******************** write (BW_Paper) and read (BW_Paper) ... ");
			writeBW_Paper();
                        readBW_Paper();
                        break;

		  case 9:
			System.out.println ("******************** write (BW_Member) and read (BW_Member) ... ");
			writeBW_Member();
                        readBW_Member();
                        break;

                   default:
                   	System.out.println ("********************** OPCOES *********************");
                   	System.out.println ("1 - read/write (String)");
                   	System.out.println ("2 - read/write (ST_Setup)");
                   	System.out.println ("3 - read/write (BW_Group)");
                   	System.out.println ("4 - read/write (BW_Register)");
                   	System.out.println ("5 - read/write (BW_Event)");
                   	System.out.println ("6 - read/write (BW_Profile)");
                   	System.out.println ("7 - read/write (BW_AwarenessProfile)");
                   	System.out.println ("8 - read/write (BW_Paper)");
                   	System.out.println ("9 - read/write (BW_Member)");                   	
                }

            }

            if (!done) {
                   	System.out.println ("********************** OPCOES *********************");
                   	System.out.println ("1 - read/write (String)");
                   	System.out.println ("2 - read/write (ST_Setup)");
                   	System.out.println ("3 - read/write (BW_Group)");
                   	System.out.println ("4 - read/write (BW_Register)");
                   	System.out.println ("5 - read/write (BW_Event)");
                   	System.out.println ("6 - read/write (BW_Profile)");
                   	System.out.println ("7 - read/write (BW_AwarenessProfile)");                   	                   	
                   	System.out.println ("8 - read/write (BW_Paper)");
                   	System.out.println ("9 - read/write (BW_Member)");                   	
            }

            if (db.getStatus()) {
            	System.out.println ("closing: "+db.close());            	
            }
    }


}
