import BW.*;
import BW.UML.*;
import BW.kernel.*;
import BW.control.*;
import BW.storage.*;
import java.util.*;
import java.io.*;


class testJan3 {

	public static void main (String args[]) {
		testUMLMediator();		
	}
	
	public static void testEventOccurence () {
		BW_Event evt_usersession = new BW_Event (UML_BW_Mediator.USERSESSION,typeIdDefault.UNSET);
		evt_usersession.setDetails ("Sessao do usuario CUTE");
		System.out.println ("user session begin "+evt_usersession);		
		GW_BW_Mediator.BeginEvent (UML_BW_Mediator.USERSESSION,evt_usersession);
		
		

                BW_Event evt_savediagram = new BW_Event (UML_BW_Mediator.SAVEDIAGRAM,typeIdDefault.UNSET);
		evt_savediagram.setDetails ("Diagrama salvo junto ao servidor");
		System.out.println ("save diagram begin "+evt_savediagram);				
		GW_BW_Mediator.BeginEvent (UML_BW_Mediator.SAVEDIAGRAM,evt_savediagram);		
		boolean esavediagram = GW_BW_Mediator.EndEvent (UML_BW_Mediator.SAVEDIAGRAM);
		System.out.println ("save diagram end "+esavediagram);		
		
		System.out.println ("new class begin");		
                BW_Event evt_newclass = new BW_Event (UML_BW_Mediator.NEWCLASS,typeIdDefault.UNSET);
                evt_newclass.setDescription ("Nova classe \"CLASSE1\" criada");
		evt_newclass.setDetails ("Classe CLASSE1 introduzida no diagrama");
		GW_BW_Mediator.BeginEvent (UML_BW_Mediator.NEWCLASS,evt_newclass);
		
		System.out.println ("sleeping 10s");	
		try {
 			Thread.sleep(10000);
 		} catch (InterruptedException ie) {
 		}
 		
                System.out.println ("new class end");
		GW_BW_Mediator.EndEvent (UML_BW_Mediator.NEWCLASS); 		
		
		
		System.out.println ("new class begin");			
                BW_Event evt_newclass2 = new BW_Event (UML_BW_Mediator.NEWCLASS,typeIdDefault.UNSET);
		GW_BW_Mediator.BeginEvent (UML_BW_Mediator.NEWCLASS,evt_newclass2);

		System.out.println ("sleeping 10s");	
		try {
 			Thread.sleep(10000);
 		} catch (InterruptedException ie) {
 		}
			
 		evt_newclass2.setDescription ("Nova classe \"CLASSE2\" criada");
		evt_newclass2.setDetails ("Classe CLASSE2 introduzida no diagrama");
		System.out.println ("new class end");			
		GW_BW_Mediator.EndEvent (UML_BW_Mediator.NEWCLASS,evt_newclass2);

		
		GW_BW_Mediator.EndEvent (UML_BW_Mediator.USERSESSION);
		
	}
	
	
	public static void testUMLMediator () {
		UML_BW_Mediator mediator = new UML_BW_Mediator();
		GW_BW_Mediator.SetConcreteMediator (mediator);		
		boolean b = GW_BW_Mediator.Start();
		
		AwarenessMainWindow window = (AwarenessMainWindow) GW_BW_Mediator.GetMainUIElement ();		
		System.out.println ("------------- Starting "+b+"--------------------" );		
		
		System.out.println ("------------- Log in --------------------" );
		BW_Member mb = new BW_Member (typeIdDefault.BW_MEMBER,2000);
		mb.setLogin ("CUTE");
		mb = GW_BW_Mediator.UserLogin (mb);
		System.out.println ("=============="+ mb);
		
		
		System.out.println ("------------- Event Occurence --------------------" );
		testEventOccurence();
		
		if (window!=null) {
			window.Show();
			//while (window.IsVisible());
		}
		else 	
			System.out.println ("window null");
			
		System.out.println ("sleeping 150s");	
		try {
 			Thread.sleep(150000);
 		} catch (InterruptedException ie) {
 		}
		
 		System.out.println ("------------- Log out --------------------" );
 		GW_BW_Mediator.UserLogout (mb);
 		
 		
		System.out.println ("------------- Log in new user --------------------" );
		BW_Member mb2 = new BW_Member (typeIdDefault.BW_MEMBER,2000);
		mb2.setLogin ("MANU");
		mb2 = GW_BW_Mediator.UserLogin (mb2);
		System.out.println ("=============="+ mb2);

		System.out.println ("sleeping 150s");	
		try {
 			Thread.sleep(150000);
 		} catch (InterruptedException ie) {
 		}
		
 		System.out.println ("------------- Log out --------------------" );
 		GW_BW_Mediator.UserLogout (mb);
 		
		 		
 		
		b = GW_BW_Mediator.Stop();
		System.out.println ("------------- Stopping "+b+"--------------------" );
	        System.exit(0);
	}


}