/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Project Server Application
 * Classe: COPSEServerEventDispatcher
\******************************************************************************/


import java.io.*;
import java.net.*;
import java.util.*;


import COPSE.*;
import COPSE.SERVER.*;

public class COPSEServerEventDispatcher
    extends CEventDispatcher
{
    protected   COPSEServer                 pServer;
    protected   COPSEServerEventHandler     pServerEventHandler;
    protected   COPSEServerProjectManager   pProjectManager;

    public COPSEServerEventDispatcher ( COPSEServer server, COPSEServerEventHandler handler )
    {
        super();
        pServer = server;
        pServerEventHandler = handler;
    }

    protected void ProcessEvent( CEvent event, CConnectionHandler sender )
    {
        System.err.println( "[DEBUG] COPSEDispatcher - Event: ["+ event.GetType()
            + "|port:" + event.GetSocketPort() + "|conn:" + event.GetConnectionId() + "]" );

        // For while, it queries the ProjectManager to find who has to receive the event
        pProjectManager = pServer.GetProjectManager();

        if( event.GetSocketPort() == 0 )//pProjectManager.GetProjectSocketPort() )
        {
            System.err.println( "[DEBUG] COPSEDispatcher - Sending to COPSEServerEventHandler..." );
            pServerEventHandler.AddEvent( event, sender );
        }
        else
            try {
                CQueuedServerManager server = (CQueuedServerManager) pProjectManager.FindServerByPort( event.GetSocketPort() );
                if( server != null )
                {
                    if( event.GetConnectionId() == 0 )
                    {
                        System.err.println( "[DEBUG] COPSEDispatcher - Sending to a QueuedServer..." );
                        server.AddEvent( event, sender );
                    }
                    else
                    {
                        CEventQueueConnector conn = server.FindQueueConnector( event.GetConnectionId() );
                        if( conn != null )
                        {
                            System.err.println( "[DEBUG] COPSEDispatcher - Sending to a QueueConnector..." );
                            conn.AddEvent( event );
                        }
                    }
                }
            } catch (Exception e) {}
    }


}