/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Project Server Application
 * Classe: COPSEServerProductManager
\******************************************************************************/


import java.io.*;
import java.util.*;


import FILE.*;
import PRODUCT.*;
import COPSE.*;
import COPSE.CONTROL.*;

//import AGENT.*;
//import PROCESS.MODEL.*;
//import PROCESS.*;

/*
class _DocControl
{
    public int                  docId;
    public CDocument            doc;
    public CFileController      docController;

    public _DocControl ( CDocEntry entry, String productDir )
    {
        docId = entry.GetId();
        try{
            doc = entry.Load( productDir );
            docController = new CFileController( doc );
        }catch(Exception e){}
    }
}
*/



public class COPSEServerProductManager
{
    protected   COPSEServerProjectManager   pProjectManager;

    protected   CProduct                    pProduct;

    protected   CFileController             pProductController;
    protected   Vector                      pDocumentControllers;


    protected   String                      mProductDir;


    public COPSEServerProductManager( COPSEServerProjectManager manager )
        //throws Exception
    {
        pProjectManager = manager;

        String projectDir = pProjectManager.GetProjectDir();
        mProductDir = new String( projectDir + "/product");


        // Open/Create Product
        try {
            pProduct = (CProduct) CFile.Load( "product.copse", projectDir );
        } catch( Exception e ) {
            pProduct = _CreateDefaultProduct( projectDir );
        }


        // Create Product Controller
        pProductController = new CFileController( pProduct );


        // Create Document Controllers
        pDocumentControllers = new Vector();
        Enumeration e = pProduct.GetElements();
        while( e.hasMoreElements() )
        {
            CElement elem = (CElement) e.nextElement();
            if( elem instanceof CDocEntry )
            {
                CDocEntry entry = (CDocEntry) elem;
                try{
                    CDocument doc = entry.Load( mProductDir );
                    pDocumentControllers.addElement( new CDocumentController( entry.GetId(), doc ) );
                } catch(Exception exc){}
            }
        }
    }


    public String           GetProductDir()   { return mProductDir; }


    public CFileController  GetProductController()      { return pProductController; }

    public Vector           GetDocumentControllers()    { return pDocumentControllers; }


    private CProduct _CreateDefaultProduct( String projectDir )
    {
        CProduct prod = new CProduct( "product.copse", projectDir );

        try {
            prod.Save();
            File file = new File( GetProductDir() );
            file.mkdirs();
        } catch (IOException e) {};
        return prod;
    }



    public CDocEntry    FindDocEntry ( int docId )
    {
        return pProduct.FindDocEntry( docId );
    }



    /*

    public CFile    LoadFile( CLocator locator )
    {
        CDocEntry entry = (CDocEntry) pProduct.FindDocEntry( locator.GetDocId() );
        if( entry == null )
            return null;

        // Load Document
        CDocument doc;
        try {
            doc = entry.Load( GetProductDir() );
        } catch ( Exception e1 )




    }

    */


    public void Close()
    {
        // TODO: Verify any changes and save them
        //if( pProductController.IsChanged() )

    }

}