/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Project Server Application
 * Classe: T_CriaIndiceProjetos
\******************************************************************************/


import java.io.*;
import java.util.*;

public class T_CriaIndiceProjetos
{

    public static void main( String[] args )
    {
        new T_CriaIndiceProjetos().run( args );
    }


    public T_CriaIndiceProjetos()
    {}


    public void run( String[] args )
    {
        try {
            System.out.println( "Creating Index...");
            CreateProjectsIndex();

            System.out.println( "Loading Index...");
            LoadProjectsIndex();
        }
        catch( Exception e ) {};

    }

    protected void CreateProjectsIndex()
        throws Exception
    {
        //
        CProjectsIndex pIndex;
        CProjectEntry prj;

        pIndex = new CProjectsIndex();

        prj = pIndex.NewProject();
        prj.SetName( "copse" );
        prj.SetDescription( "COPSE Development Project" );
        prj.SetPath( "../prj/copse" );

        prj = pIndex.NewProject();
        prj.SetName( "cute" );
        prj.SetDescription( "CUTE Development Project" );
        prj.SetPath( "../prj/cute" );


        pIndex.SaveTo( "projects.index" );
    }


    protected void LoadProjectsIndex()
        throws Exception
    {
        CProjectsIndex pIndex;

        pIndex = CProjectsIndex.LoadFrom( "projects.index" );

        pIndex.DEBUG_write( System.out );
    }

}