/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Project Server Application
 * Classe: COPSEManager
\******************************************************************************/


import java.io.*;
import java.net.*;
import java.util.*;

/*
class InterfaceControl
{
    public InterfaceControl()
    {}

    public ReceiveEvent(

}
*/


public class COPSEManager
{
    private     String              mProjectName;

    private     String              mServerSocketPort;
    private     int                 mLastUsedSocketPort;




    private     UserManager         pUserManager;
    private     ProcessManager      pProcessManager;

    private     ProjectManager      pProjectManager;

/*
    private     GUIManager          pGuiManager;

    private     FileSystemManager   pFSManager;

    private     ProductManager      pProductManager;
//    private     DocServerManager    pDocManager;
    private     AgentManager        pAgentManager;
*/

    // Temporary Costructor
    public COPSEManager( String project, String port )
    {
        mProjectName = project;
        mServerSocketPort = port;
    }

    public int GetServerSocketPort( )
    {   return new Integer(mServerSocketPort).intValue(); }

    public synchronized int GetLastUsedSocketPort( )
    {   return mLastUsedSocketPort; }

    public synchronized int GetNewSocketPort()
    {
        mLastUsedSocketPort++;
        return mLastUsedSocketPort;
    }

/*
    public void SetProject( String project )
    {   mProjectName = project;   }

*/

    public void Start()
        throws Exception
    {
        // Create All Managers
        //try {

            // Create User Manager
            pUserManager = new UserManager( this, mServerSocketPort );

            // Adjust Sockets Port
            mServerSocketPort   = String.valueOf( pUserManager.GetSocketPort() );
            mLastUsedSocketPort = pUserManager.GetSocketPort();

            // Create Project Manager
            pProjectManager = new ProjectManager( this, mProjectName,
                    pUserManager.GetHostName(), pUserManager.GetSocketPort() );

            // Create Process Manager
            pProcessManager = new ProcessManager( this );

        //} catch (IOException e


        // Setup Managers before starting them
        pUserManager.SetProjectUsers( pProjectManager.GetProjectUsers() );
        pProcessManager.SetProjectProcess( pProjectManager.GetProjectProcess() );

        // Start All Managers
        pUserManager.start();
        pProcessManager.start();

    }

    public void Exit()
    {
        System.out.println( "DEBUG: Exiting User Manager..." );
        pUserManager.Exit();
        pProcessManager.Exit();

        pProjectManager.Exit();

        //try {
            System.out.println( "DEBUG: Stoping User Manager Thread..." );
            pUserManager.stop();

            pProcessManager.stop();
        //} catch( InterruptedException e ){};
    }

}

