/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Project Server Application
 * Classe: COPSETest
\******************************************************************************/


import java.io.*;
import java.util.*;



public class COPSETest
{

    public static void main( String[] args )
    {
        new COPSETest().run( args );
    }


    COPSEManager    pManager;

    public COPSETest() {}

    private void run (String[] args)
    {
        System.out.println( "COPSE Server - Test" );

        if( args.length < 2 )
        {
            System.out.println( "Parameters:\n   <project_name> <port_number>" );
            return;
        }

        try {
            pManager = new COPSEManager( args[0], args[1] );
            pManager.Start();
        } catch( Exception e )
        {
            System.out.println( "Error on starting COPSE Manager" );
            System.exit(0);
        }


        System.out.println("Server On");
        System.out.print(":");

        BufferedReader in = new BufferedReader(new InputStreamReader(System.in));

        String command;
        do {
            command = "";
            try {
                StringTokenizer st = new StringTokenizer(in.readLine());
                if( st.hasMoreTokens() )
                {
                    command = st.nextToken();

                    if( command.equals( "exit" ) )
                    {
                        pManager.Exit();
                    }
                    else
                        System.out.print(":");
                }
            } catch (IOException ioe )
            {
                System.out.println( "DEBUG: Error os String Tokenizer ...");
            }

        } while( !command.equals("exit") );

    }
}