/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Project Server Application
 * Classe: CServerManager
\******************************************************************************/


import java.io.*;
import java.util.*;

import COPSE.*;
import FILE.*;


// CProjectManager

public class CServerManager
//    extends Thread
{
    CProjectManager             pProjectManager;

    CLocator                    pFileLocator;
    CFile                       pFile;

    int                         mServerSocketPort;
    CConnectionHandler          pConnection;
    CServerManagerEventHandler  pEventHandler;

    boolean                     mExit;


    public CServerManager( CProjectManager projectManager, int serverPort,
        CLocator locator, CFile file )
        throws IOException
    {
        super();

        pProjectManager = projectManager;
        mServerSocketPort = serverPort;

        pFileLocator = locator;
        pFile = file;

        ActivateServer();
    }


    protected CServerManagerEventHandler   CreateEventHandler()
    {
        return new CServerManagerEventHandler ( this );
    }


    protected void ActivateServer()
        throws IOException
    {
        String serverName = pProjectManager.GetServerNameFor( pLocator );

        Process process = Runtime.getRuntime().exec(
                "java " + serverName + " " + mServerSocketPort );

        CProcessStreamConnector connector = new CProcessStreamConnector( process );

        pEventHandler = CreateEventHandler();

        pConnection = new CConnectionHandler( connector, pEventHandler );
        pConnection.start();


        // Send Init Event
        CEvent event = new CEvent( CEvent.EvServer_Init );
        event.AddArgument( pFile );
        pConnection.Send( event );


/*
        // ??? Send pPrjProcess
        CEvent event = new CEvent( CEvent.EvServer_Init );
        event.AddArgument( pPrjProcess );
        pConnector.Send( event );

        event = pConnector.Receive();
        Boolean bool = (Boolean) event.GetArgumentAt(0);
        if( bool.booleanValue() )
        {
            this.resume();
        }
        else
        {
            pConnector.SetServerProcess( null );
            throw new IOException( "Error on starting ProcessServer up!" );
        }
        //}
*/

    }


    public void Exit()
    {
        /*
        if( pConnector.IsServerActive() )
        {
            try {
                CEvent event = new CEvent( CEvent.EvServer_Exit );
                pConnector.Send( event );
            } catch ( IOException ioe )
            {
                mExit = true;
                resume();
                // ...

            }
        }
        else
        {
            mExit = true;
            resume();
            // ...
        }
        */
    }



    public CLocator GetLocator()        { return pLocator; }


}