/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Project Server Application
 * Classe: ProcessServer
\******************************************************************************/


import java.io.*;
import java.util.*;


import COPSE.*;
import COPSE.SERVER.*;

//import FILE.*;
import PROCESS.MODEL.*;
import PROCESS.*;

//import AGENT.*;


public class ProcessServer
    extends CServer
{

    CProcess    pPrjProcess;

    CProcessUsersSession    pPrjUsersSession;

    public static void main( String[] args )
    {
        try {
            new ProcessServer().run( args );
        } catch (Exception e)
        { System.exit(1);}
    }

    public ProcessServer()
        throws Exception
    {
        super();

        pPrjUsersSession = new CProcessUsersSession();
    }

    protected void SetFileType()
    {
        pPrjProcess = (CProcess) pFile;
    }


    protected CUserServer CreateUserServer ( CServer server, int userId, int connId, CObjectStreamConnector conn )
    {
        return new ProcessUserServer( server, userId, connId, conn );
    }




//***********************************************************************

    public CProcess GetProcess()
    {
        return pPrjProcess;
    }



    public void AddUserToActivity( int actId, int userId )
    {
        pPrjUsersSession.AddEntry( actId, userId );
    }

    public void RemoveUserFromActivity( int actId, int userId )
    {
        pPrjUsersSession.RemoveEntry( actId, userId );
    }

    public Enumeration GetUsersInActivity( int actId )
    {
        return pPrjUsersSession.GetUsersInActivity( actId );
    }

    public CProcessUsersSession GetProcessUsersSession()
    {
        return pPrjUsersSession;
    }

}
