/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Project Server Application
 * Classe: ProjectEntry
\******************************************************************************/


import java.io.*;
import java.util.*;

public class ProjectEntry
    implements Serializable
{
    int         mId;
    String      mName;
    String      mDesc;
    String      mPath;
    boolean     mIsOpen;
    String      mHost;
    int         mPort;

    public ProjectEntry ( int id )
    {
        mId = id;
        mIsOpen = false;
    }

    public int      GetId()                 { return mId; }

    public String   GetName()               { return mName; }
    public void     SetName(String name)    { mName = name; }

    public String   GetPath()               { return mPath; }
    public void     SetPath (String path)   { mPath = path; }

    public String   GetDescription()               { return mDesc; }
    public void     SetDescription(String desc)    { mDesc = desc; }


    public String   GetHost()               { return mHost; }
    public int      GetPort()               { return mPort; }
    public boolean  IsOpen()                { return mIsOpen; }

    public void     Open (String host, int port)
        throws IOException
    {
        if( mIsOpen )
            throw new IOException( "Project is already open at ["+mHost+":"+mPort+"]" );

        mIsOpen = true;
        mHost = host;
        mPort = port;
    }

    public void     Close ()
    {
        mIsOpen = false;
    }

    public void DEBUG_write( PrintStream out )
    {
        out.print  ( "  " + mId + ". " + mName + " at '"+mPath+"' [" );
        if( mIsOpen )
            out.println( "Open: "+mHost+":"+mPort+"]" );
        else
            out.println( "Closed]" );
    }

}


