/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Project Server Application
 * Classe: ServerStreamConnector
\******************************************************************************/

import java.io.*;
import COPSE.*;


public class ServerStreamConnector
{
    int                     mServerSocketPort;

    CProcessStreamConnector pConnector;


    public ServerStreamConnector( int port )
    {
        pConnector = null;
        mServerSocketPort = port;
    }

    public boolean IsServerActive()     { return pConnector != null; }

    public void SetServerProcess( Process server )
        throws IOException
    {
        if( server == null )
        {
            pConnector.Close();
            pConnector = null;
        }
        else
        {
            pConnector = CProcessStreamConnector.New( server, false );
        }
    }

    public void  SetServerSocketPort(int port)  { mServerSocketPort = port; }
    public int   GetServerSocketPort()          { return mServerSocketPort; }

    public CEvent Receive()
        throws IOException
    {
        if( pConnector == null )
            throw new IOException( "DEBUG: Server Process isn't active!" );

        return( pConnector.Receive() );
    }

    public void Send( CEvent event )
        throws IOException
    {
        if( pConnector == null )
            throw new IOException( "DEBUG: Server Process isn't active!" );

        pConnector.Send( event );
    }

}

