/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Project Server Application
 * Classe: CProductManager
\******************************************************************************/


import java.io.*;
import java.util.*;


import FILE.*;
import PRODUCT.*;
import COPSE.*;

//import AGENT.*;
//import PROCESS.MODEL.*;
//import PROCESS.*;


class _DocControl
{
    public int                  docId;
    public CDocument            doc;
    public CFileController      docController;

    public _DocControl ( CDocEntry entry, String productDir )
    {
        docId = entry.GetId();
        try{
            doc = entry.Load( productDir );
            docController = new CFileController( doc );
        }catch(Exception e){}
    }
}




public class CProductManager
{
    protected   COPSEServerProjectManager   pProjectManager;

    protected   CProduct                    pProduct;

    protected   CFileController             pProductController;
    protected   Vector                      pDocControls;


    protected   String                      mProductDir;


    public CProductManager( COPSEServerProjectManager manager )
        //throws Exception
    {
        pProjectManager = manager;

        String projectDir = pProjectManager.GetProjectDir();
        mProductDir = new String( projectDir + "/product");

        try
        {
            pProduct = (CProduct) CFile.Load( "product.copse", projectDir );
        } catch( Exception e )
        {
            pProduct = _CreateDefaultProduct( projectDir );
        }

        pProductController = new CFileController( pProduct );

        pDocControls = new Vector();
        Enumeration e = pProduct.GetElements();
        while( e.hasMoreElements() )
        {
            CElement elem = (CElement) e.nextElement();
            if( elem instanceof CDocEntry )
                pDocControls.addElement( new _DocControl( (CDocEntry)elem, mProductDir ) );
        }
    }


    public String GetProductDir()   { return mProductDir; }




    private CProduct _CreateDefaultProduct( String projectDir )
    {
        CProduct prod = new CProduct( "product.copse", projectDir );

        try {
            prod.Save();
            File file = new File( GetProductDir() );
            file.mkdirs();
        } catch (IOException e) {};
        return prod;
    }



    public CDocEntry    FindDocEntry ( int docId )
    {
        return pProduct.FindDocEntry( docId );
    }



    /*

    public CFile    LoadFile( CLocator locator )
    {
        CDocEntry entry = (CDocEntry) pProduct.FindDocEntry( locator.GetDocId() );
        if( entry == null )
            return null;

        // Load Document
        CDocument doc;
        try {
            doc = entry.Load( GetProductDir() );
        } catch ( Exception e1 )




    }

    */


    public void Close()
    {
        // TODO: Verify any changes and save them
        //if( pProductController.IsChanged() )

    }

}