/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Project Server Application
 * Classe: CProjectsIndex
\******************************************************************************/


import java.io.*;
import java.util.*;


public class CProjectsIndex
    implements Serializable
{
    int         mLastId;
    Vector      pProjects;

    public CProjectsIndex ()
    {
        mLastId = 0;
        pProjects = new Vector();
    }




    public CProjectEntry NewProject()
    {
        mLastId++;
        CProjectEntry prj = new CProjectEntry( mLastId );
        pProjects.addElement( prj );
        return prj;
    }

    public CProjectEntry FindProject( int projectId )
    {
        Enumeration e = pProjects.elements();
        while( e.hasMoreElements() )
        {
            CProjectEntry entry = (CProjectEntry) e.nextElement();
            if( entry.GetId() == projectId )
                return entry;
        }
        return null;
    }

    public CProjectEntry FindProject( String projectId )
    {
        try {
            int id = (new Integer(projectId)).intValue();
            return FindProject( id );
        } catch( Exception e ) {};

        Enumeration e = pProjects.elements();
        while( e.hasMoreElements() )
        {
            CProjectEntry entry = (CProjectEntry) e.nextElement();
            if( entry.GetName().equals(projectId) )
                return entry;
        }
        return null;
    }




    public void RemoveProject( CProjectEntry prj )
    {
        pProjects.removeElement( prj );
    }



    public static CProjectsIndex LoadFrom( String fileName )
        throws IOException
    {
        CProjectsIndex index = null;
        FileInputStream file = new FileInputStream( fileName );
        ObjectInputStream input = new ObjectInputStream( file );
        try {
            index = (CProjectsIndex) input.readObject();
        } catch( ClassNotFoundException e ) {};
        file.close();
        return index;
    }


    public void SaveTo( String fileName )
    {
        try {
            // Writes to a temporary file
            FileOutputStream outputFile = new FileOutputStream( "projects.temp" );
            ObjectOutputStream output = new ObjectOutputStream( outputFile );
            output.writeObject( this );
            outputFile.close();

            // Rename Temporary file
            File file1 = new File( fileName );
            if( file1.exists() )
                file1.delete();

            File file2 = new File( "projects.temp" );
            file2.renameTo( file1 );
        } catch( Exception e ) {}
    }





    public void DEBUG_write( PrintStream out )
    {
        out.println( "** Projects Index **\n" );
        out.println( "LastId:     " + mLastId );
        out.println( "Projects:   " + pProjects.size() );

        Enumeration e = pProjects.elements();
        while( e.hasMoreElements() )
        {
            CProjectEntry prj = (CProjectEntry) e.nextElement();
            prj.DEBUG_write( out );
        }

        out.println( "*********************" );
    }
}

