/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Project Server Application
 * Classe: ProcessServer
\******************************************************************************/


import java.io.*;
import java.util.*;


import COPSE.*;
import COPSE.SERVER.*;

//import FILE.*;
import PROCESS.MODEL.*;
import PROCESS.*;

//import AGENT.*;


public class ProcessServer
    extends CManagedServer
{
    CProcess                pPrjProcess;
    CProcessUsersSession    pPrjUsersSession;

    public static void main( String[] args )
    {
        if( args.length < 1 )
        {
            System.err.println( "It requires 'port' parameter" );
            System.exit(1);
        }

        ProcessServer server;
        try {
            server = new ProcessServer( args[0] );
            server.start();
            server.join();
        } catch (Exception e)
        {
            e.printStackTrace( System.err );
            System.exit(1);
        }
    }


    public ProcessServer( String port )
        throws Exception
    {
        super( port );

        pPrjUsersSession = new CProcessUsersSession();
    }

    protected void SetFileType()
    {
        pPrjProcess = (CProcess) pFile;
    }



    // Override to CServer
    protected CServerEventHandler CreateServerEventHandler()
    {
        System.err.println( "[DEBUG] ProcessServer: Creating ProcessServerEventHandler..." );
        return new ProcessServerEventHandler( this );
    }



/*  // Override to CManagedServer
    protected CManagedServerEventHandler CreateManagedServerEventHandler()
    {
        return new ManagedProcessServerEventHandler( this, pEventHandler );
    }

    protected CFileController CreateFileController()
    {
        // Create the default FileController
        return new CProcessController( pFile );
    }
*/



//***********************************************************************

    public CProcess GetProcess()
    {
        return pPrjProcess;
    }



    public void AddUserToActivity( int actId, int userId )
    {
        pPrjUsersSession.AddEntry( actId, userId );
    }

    public void RemoveUserFromActivity( int actId, int userId )
    {
        pPrjUsersSession.RemoveEntry( actId, userId );
    }

    public Enumeration GetUsersInActivity( int actId )
    {
        return pPrjUsersSession.GetUsersInActivity( actId );
    }

    public CProcessUsersSession GetProcessUsersSession()
    {
        return pPrjUsersSession;
    }

}
