/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Package: TOOL.UML.CLIENT
 * Classe:  UMLDlgClass
 ******************************************************************************/

package TOOL.UML.CLIENT;


import  java.awt.*;
import  java.awt.event.*;
import  java.util.*;

import  COPSE.CLIENT.GUI.*;
import  FILE.OBJ.*;


/*************************************************************************
 *  Class UMLDlgFeature
 *************************************************************************/
public class    UMLDlgFeature
    extends     Dialog
    implements  ActionListener, WindowListener
{
    protected   UMLDlgClass     pDlgClass;
    protected   CObjFeature     pFeature = null;

    protected   Label       labelType;
    protected   Label       labelValue;
    protected   TextField   textName;
    protected   TextField   textType;
    protected   TextField   textValue;
    protected   Button      btnOk;
    protected   Button      btnCancel;


	public      UMLDlgFeature ( Frame parent, UMLDlgClass classDlg )
	{
	    super( parent, false);
	    pDlgClass = classDlg;

		//{{INIT_CONTROLS
		setLayout(null);
		addNotify();

		Insets insets = getInsets();
		setSize(insets.left + insets.right + 302,insets.top + insets.bottom + 184);
		setFont(new Font("Helvetica", Font.PLAIN, 12));

		Label label = new Label("Name:");
		label.setBounds(insets.left + 14,insets.top + 15,70,15);
		add(label);

		textName = new TextField();
		//textName.setBounds(insets.left + 105,insets.top + 15,168,24);
		textName.setBounds(insets.left + 105,insets.top + 15,168,31);
		add(textName);

		labelType = new Label("Type:");
		labelType.setBounds(insets.left + 14,insets.top + 53,70,15);
		add(labelType);

		textType = new TextField();
		//textType.setBounds(insets.left + 105,insets.top + 53,168,23);
		textType.setBounds(insets.left + 105,insets.top + 53,168,31);
		add(textType);

		labelValue = new Label("Default Value:");
		labelValue.setBounds(insets.left + 14,insets.top + 90,84,15);
		add(labelValue);

		textValue = new TextField();
		//textValue.setBounds(insets.left + 105,insets.top + 90,168,22);
		textValue.setBounds(insets.left + 105,insets.top + 90,168,31);
		add(textValue);

		btnOk = new Button("Ok");
		btnOk.setBounds(insets.left + 98,insets.top + 128,77,23);
		btnOk.addActionListener( this );
		add(btnOk);

		btnCancel = new Button("Cancel");
		btnCancel.setBounds(insets.left + 189,insets.top + 128,84,23);
		btnCancel.addActionListener( this );
		add(btnCancel);

		setTitle("Attribute:");
		setResizable(false);
		//}}
	}


    public CObjFeature  GetFeature()
    {
        return pFeature;
    }

    public void SetFeature( CObjFeature feature )
    {
        pFeature = feature;
        DataToView();
    }

    protected void DataToView()
    {
        if( pFeature == null )  return;

        textName.setText( pFeature.GetName() );
        textType.setText( pFeature.GetType() );

        if( pFeature instanceof CObjAttribute )
        {
            CObjAttribute a = (CObjAttribute) pFeature;
            textValue.setText( a.GetInitialValue() );

            labelType.setText( "Type:" );
            labelValue.setText( "Default Value:" );
        }
        else
        {
            CObjMethod m = (CObjMethod) pFeature;
            textValue.setText( m.GetParameters() );

            labelType.setText( "Result Type:" );
            labelValue.setText( "Parameters:" );
        }
    }


    protected void ViewToData()
    {
        if( pFeature == null )  return;

        pFeature.SetName( textName.getText() );
        pFeature.SetType( textType.getText() );

        if( pFeature instanceof CObjAttribute )
        {
            CObjAttribute a = (CObjAttribute) pFeature;
            a.SetInitialValue( textValue.getText() );
        }
        else
        {
            CObjMethod m = (CObjMethod) pFeature;
            m.SetParameters( textValue.getText() );
        }
    }

    public synchronized void setVisible( boolean visible )
    {
        if( visible )
        {
        	Rectangle bounds = getParent().getBounds();
        	Rectangle abounds = getBounds();

        	setLocation(bounds.x + (bounds.width - abounds.width)/ 2,
        	     bounds.y + (bounds.height - abounds.height)/2);

            DataToView();
        }

    	super.setVisible( visible );
    }


    // WindowEvent Listener methods
    public void windowOpened(WindowEvent e)         {}
    public void windowClosed(WindowEvent e)         {}
    public void windowClosing(WindowEvent e)        { _Close(false); }
    public void windowIconified(WindowEvent e)      { _Close(false); }
    public void windowDeiconified(WindowEvent e)    {}
    public void windowActivated(WindowEvent e)      {}
    public void windowDeactivated(WindowEvent e)    {}

    // ActionEvent Listener method
    public void actionPerformed( ActionEvent event )
    {
        Object source = event.getSource();

        if( source == btnCancel )
            _Close( false );
        else
        if( source == btnOk )
            _Close( true );

    }

    private void _Close( boolean ok )
    {
        if( ok )
            ViewToData();

        pDlgClass.CloseDlgFeature( ok );
    }
}

