/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Package: TOOL.UML.CLIENT
 * Classe:  UMLDlgRelation
 ******************************************************************************/

package TOOL.UML.CLIENT;


import  java.awt.*;
import  java.awt.event.*;
import  java.util.*;

import  COPSE.CLIENT.GUI.*;
import  FILE.OBJ.*;


/* ****************************************** BW *********************************************************** */
import  BW.*;
import  BW.kernel.*;
import  COPSE.CEvent;
/* ****************************************** BW *********************************************************** */



/*************************************************************************
 *  Class UMLDlgRelation
 *************************************************************************/

public class    UMLDlgRelation
    extends     Dialog
    implements  ActionListener, WindowListener, TextListener, ItemListener
{
    protected CGUIManager           pGUI;
    protected UMLRelationControl    pControl;


    protected CObjRelation          pOldRelation = null;
    protected CObjRelation          pNewRelation = null;
    protected boolean               mChanged = false;

    protected CObjRelationExtremity pRelExtremity = null;

	List            listClasses;
	TextField       textCard;
	TextField       textLabel;
	TextField       textName;

	Checkbox        radioInhe;
	Checkbox        radioAggregVal;
	Checkbox        radioAggregRef;
	Checkbox        radioAsso;
	Checkbox        radioInst;

	Button          btnOk;
	Button          btnCancel;


/* ************************************************ BW **************************************************** */
	BW_Event	BWEvent=null;
/* ************************************************ BW **************************************************** */
	
	

	public UMLDlgRelation(CGUIManager gui, boolean modal, UMLRelationControl control)
	{
	    super(gui.GetMainWindow(), modal);
	    pGUI = gui;
	    pControl = control;


        pOldRelation = pControl.GetSelectedRelation();
        pNewRelation = (CObjRelation) pOldRelation.Clone();
        mChanged = false;


        addWindowListener( this );



		//{{INIT_CONTROLS
		setLayout(null);
		addNotify();

		Insets insets = getInsets();
		setSize(insets.left + insets.right + 373,insets.top + insets.bottom + 365);
		setFont(new Font("Helvetica", Font.PLAIN, 12));


		Panel           panel;
		Label           label;
		CheckboxGroup   group;


		panel = new Panel();
		panel.setLayout(null);
		panel.setBounds(insets.left + 14,insets.top + 180,343,114);
		add(panel);

    		label = new Label("Classes:");
    		label.setBounds(insets.left + 14,insets.top + 165,70,15);
    		add(label);

    		listClasses = new List(0,false);
    		listClasses.setBounds(14,23,168,75);
    		listClasses.addItemListener( this );
    		panel.add(listClasses);

    		label = new Label("Cardinality:");
    		label.setBounds(196,30,70,15);
    		panel.add(label);

    		textCard = new TextField();
    		//textCard.setBounds(266,30,63,24);
    		textCard.setBounds(266,30,63,31);
    		textCard.addTextListener( this );
    		panel.add(textCard);

    		label = new Label("Label:");
    		label.setBounds(196,68,63,15);
    		panel.add(label);

    		textLabel = new TextField();
    		//textLabel.setBounds(266,68,63,23);
    		textLabel.setBounds(266,68,63,31);
    		textLabel.addTextListener( this );
    		panel.add(textLabel);

    		label = new Label("Relation Name:");
    		label.setBounds(insets.left + 14,insets.top + 15,119,15);
    		add(label);

    		textName = new TextField();
    		textName.setBounds(insets.left + 147,insets.top + 15,210,23);
    		textName.setBounds(insets.left + 147,insets.top + 15,210,31);
    		add(textName);



		panel = new Panel();
		panel.setLayout(null);
		panel.setBounds(insets.left + 14,insets.top + 60,343,90);
		add(panel);

    		label = new Label("Type:");
    		label.setBounds(insets.left + 14,insets.top + 45,70,15);
    		add(label);

    		group = new CheckboxGroup();
    		radioAsso = new Checkbox("Association", group, false);
    		radioAsso.setBounds(14,15,105,19);
    		panel.add(radioAsso);

    		radioAggregRef = new Checkbox("Aggregation (reference)", group, false);
    		radioAggregRef.setBounds(14,38,154,19);
    		panel.add(radioAggregRef);

    		radioAggregVal = new Checkbox("Aggregation (value)", group, false);
    		radioAggregVal.setBounds(14,60,140,19);
    		panel.add(radioAggregVal);

    		radioInhe = new Checkbox("Inheritance", group, false);
    		radioInhe.setBounds(189,15,105,19);
    		panel.add(radioInhe);

    		radioInst = new Checkbox("Instanciation", group, false);
    		radioInst.setBounds(189,38,112,19);
    		panel.add(radioInst);



		btnOk = new Button("Ok");
		btnOk.setBounds(insets.left + 168,insets.top + 308,84,26);
		btnOk.addActionListener( this );
		add(btnOk);

		btnCancel = new Button("Cancel");
		btnCancel.setBounds(insets.left + 266,insets.top + 308,88,26);
		btnCancel.addActionListener( this );
		add(btnCancel);



		setTitle("Relation Edit");
		setResizable(false);
		//}}
	}



    public synchronized void setVisible( boolean visible )
    {
        if( visible )
        {
        	Rectangle bounds = getParent().getBounds();
        	Rectangle abounds = getBounds();

        	setLocation(bounds.x + (bounds.width - abounds.width)/ 2,
        	     bounds.y + (bounds.height - abounds.height)/2);

        	DataToView();
        	
/* ****************************************** BW *************************************** */        	
		GW_BW_Mediator.BeginEvent (CEvent.EvCOPSE_FileController_Element_Update+1000);        	
		BWEvent = new BW_Event(CEvent.EvCOPSE_FileController_Element_Update+1000,typeIdDefault.UNSET);
/* ****************************************** BW *************************************** */

        }

    	super.setVisible( visible );
    }


    // WindowEvent Listener methods
    public void windowOpened(WindowEvent e)         {}
    public void windowClosed(WindowEvent e)         {}
    public void windowClosing(WindowEvent e)        { _Close(false); }
    public void windowIconified(WindowEvent e)      { _Close(false); }
    public void windowDeiconified(WindowEvent e)    {}
    public void windowActivated(WindowEvent e)      {}
    public void windowDeactivated(WindowEvent e)    {}

    // ActionEvent Listener method
    public void actionPerformed( ActionEvent event )
    {
        Object source = event.getSource();

        if( source == btnCancel )
            _Close( false );
        else
        if( source == btnOk )
            _Close( true );
    }

    // ItemEventListener Method
    public void itemStateChanged(ItemEvent e)
    {
        Object source = e.getSource();

        if( source == listClasses )
        {
            _UpdateSelectedExtremity();
        }
    }

    // TextEvent Listener method
    public void textValueChanged(TextEvent e)
    {
        Object source = e.getSource();

        if( source == textCard )
        {
    		if( pRelExtremity == null )
    		    textCard.setText( "" );
            else
                pRelExtremity.GetCardinality().SetText( textCard.getText() );
        }
        else
        if( source == textLabel )
        {
    		if( pRelExtremity == null )
    		    textLabel.setText( "" );
            else
                pRelExtremity.GetLabel().SetText( textLabel.getText() );
        }
    }




    public boolean          HasChanged()        { return mChanged; }

    public CObjRelation     GetNewRelation()    { return pNewRelation; }


    public void DataToView()
    {
        textName.setText( pNewRelation.GetName() );

        switch( pNewRelation.GetType() )
        {
            case CObjRelation.Association:
                radioAsso.setState(true); break;

            case CObjRelation.Inheritance: // HERANCA
                radioInhe.setState(true); break;

            case CObjRelation.AggregationByRef: // AGREGACAO (REFER)
                radioAggregRef.setState(true); break;

            case CObjRelation.AggregationByValue: // AGREGACAO (VALOR)
                radioAggregVal.setState(true); break;

            case CObjRelation.Instanciation: // INSTANCIACAO
                radioInst.setState(true); break;
        }

        listClasses.removeAll();
        Enumeration e = pNewRelation.GetExtremities();
        while( e.hasMoreElements() )
        {
            CObjRelationExtremity extr = (CObjRelationExtremity) e.nextElement();
            listClasses.addItem( extr.GetClass().GetName() );
        }

        _UpdateSelectedExtremity();
    }


    private void _UpdateSelectedExtremity()
    {
	    int index = listClasses.getSelectedIndex();

	    if( index >= 0 )
	    {
    		pRelExtremity = pNewRelation.GetExtremity( index );
    		textCard.setText( pRelExtremity.GetCardinality().GetText() );
    		textLabel.setText( pRelExtremity.GetLabel().GetText() );
    	}
    	else
    	{
    	    pRelExtremity = null;
            textCard.setText( "" );
            textLabel.setText( "" );
    	}
    }


    public void ViewToData()
    {
        String text;

        text = textName.getText();
        if( !text.equals( pNewRelation.GetName() ) )
        {    pNewRelation.SetName( text ); mChanged = true; }

        int type = CObjRelation.Association;

        if( radioAsso.getState() )          type = CObjRelation.Association;
        else
        if( radioAggregRef.getState() )     type = CObjRelation.AggregationByRef;
        else
        if( radioAggregVal.getState() )     type = CObjRelation.AggregationByValue;
        else
        if( radioInhe.getState() )          type = CObjRelation.Inheritance;
        else
        if( radioInst.getState() )          type = CObjRelation.Instanciation;

        if( type != pNewRelation.GetType() )
        {   pNewRelation.SetType( type );  mChanged = true;  }

        // PS: Cardinalities (and labels) are updated on-the-fly...
/* ************************************************ BW **************************************************** */
		try {
			String BWRelationType = "";			
			String BWRelationName = new String (textName.getText());
			BWEvent.setDescription ("Relation Edited - "+BWRelationName);			
                	if( radioAsso.getState() )		BWRelationType = "Association";
                	else if( radioAggregRef.getState() )	BWRelationType = "Aggregation By Ref.";
                	else if( radioAggregVal.getState() )	BWRelationType = "Aggregation By Value";
                	else if( radioInhe.getState() )		BWRelationType = "Inheritance";
                	else if( radioInst.getState() )		BWRelationType = "Instanciation";		
			String BWDetails = new String ("Relacionamento "+BWRelationName+" editado: \n");
			BWDetails += ("TIpo "+BWRelationType+"\n ");
			BWEvent.setDetails (BWDetails);
		        BWDetails += "Entre as classes: "+pNewRelation.GetExtremity(0).GetClass().GetName();
       		        BWDetails += (" e ");
       		        BWDetails += pNewRelation.GetExtremity(1).GetClass().GetName();
       		        BWDetails += ("\n");
       			BWEvent.setDetails (BWDetails);
		        BWDetails += ("Labels "+pNewRelation.GetExtremity(0).GetLabel().GetText());
		        BWDetails += (" e ");
		        BWDetails += pNewRelation.GetExtremity(1).GetLabel().GetText();
		        BWDetails += " respectivamente";
		        BWEvent.setDetails (BWDetails);
		} catch (Exception ex) {
		}
/* ************************************************ BW **************************************************** */

    }


    protected void _Close( boolean ok )
    {
        if( ok ) {
            ViewToData();
/* ************************************************ BW **************************************************** */
	    GW_BW_Mediator.EndEvent (CEvent.EvCOPSE_FileController_Element_Update+1000,BWEvent);
/* ************************************************ BW **************************************************** */
        }
/* ************************************************ BW **************************************************** */
	else {
	    GW_BW_Mediator.CancelEvent (CEvent.EvCOPSE_FileController_Element_Update+1000);
	}
/* ************************************************ BW **************************************************** */

        pControl.CloseDlgEdit(ok);
    }




/*
	public DlgRelation(Frame parent, String title, boolean modal)
	{
	    this(parent, modal);
	    setTitle(title);
	}

    public synchronized void show()
    {
    	Rectangle bounds = getParent().bounds();
    	Rectangle abounds = bounds();

    	move(bounds.x + (bounds.width - abounds.width)/ 2,
    	     bounds.y + (bounds.height - abounds.height)/2);

    	super.show();
    }

	void btnOk_Clicked(Event event)
	{
	    Container pai = getParent();

	    ViewToData();
	    p_relac = newRelac;
	    pai.handleEvent( new Event(pai, MainFrame.EVENTO_DLG_OK, this) );
	    hide();
	}

	void btnCancel_Clicked(Event event)
	{
	    Container pai = getParent();
	    pai.handleEvent( new Event(pai, MainFrame.EVENTO_DLG_CANCEL, this) );
	    hide();
	}


    protected OBJRelacionamento oldRelac = null;
    protected OBJRelacionamento newRelac = null;

    protected OBJRelacionamento p_relac = null;

    protected OBJLadoRelacion   p_lado = null;

	void textRotulo_KeyRelease(Event event)
	{
		if( p_lado == null )
		    textRotulo.setText( "" );
        else
            p_lado.GetRotulo().SetTexto( textRotulo.getText() );
	}

	void textCard_KeyRelease(Event event)
	{
		if( p_lado == null )
		    textCard.setText( "" );
        else
            p_lado.GetCardinalidade().SetTexto( textCard.getText() );
	}

	void listClasses_ListSelect(Event event)
	{
	    int index = listClasses.getSelectedIndex();

	    if( index >= 0 )
	    {
    		p_lado = newRelac.GetLadoRelacion( index+1 );
    		textCard.setText( p_lado.GetCardinalidade().GetTexto() );
    		textRotulo.setText( p_lado.GetRotulo().GetTexto() );
    	}
    	else
    	{
    	    p_lado = null;
            textCard.setText( "" );
            textRotulo.setText( "" );
    	}
	}


	public boolean handleEvent(Event event)
	{
	    if(event.id == Event.WINDOW_DESTROY)
	    {
	        hide();
	        return true;
	    }

		if (event.target == listClasses && event.id == Event.LIST_SELECT)
		{
			listClasses_ListSelect(event);
		}

		if (event.target == textCard && event.id == Event.KEY_RELEASE)
		{
			    textCard_KeyRelease(event);
		}
		if (event.target == textRotulo && event.id == Event.KEY_RELEASE)
		{
			textRotulo_KeyRelease(event);
		}

		if (event.target == btnOk && event.id == Event.ACTION_EVENT) {
			btnOk_Clicked(event);
		}
		if (event.target == btnCancel && event.id == Event.ACTION_EVENT) {
			btnCancel_Clicked(event);
		}
		return super.handleEvent(event);
	}

    public void SetRelacionamento( OBJRelacionamento rel )
    {
        p_relac = oldRelac = rel;
        if( rel == null ) return;

        newRelac = rel.Clone();
        DataToView();
    }


    public OBJRelacionamento GetRelacionamento()
    {
        return p_relac;
    }

    protected void DataToView()
    {
        textName.setText( newRelac.GetNome() );

        switch( newRelac.GetTipo() )
        {
            case 0: // ASSOCIAO
                radioAsso.setState(true); break;
            case 1: // AGREGACAO (REFER)
                radioAgregRef.setState(true); break;
            case 2: // INSTANCIACAO
                radioInst.setState(true); break;
            case 3: // HERANCA
                radioInhe.setState(true); break;
            case 4: // AGREGACAO (VALOR)
                radioAgregVal.setState(true);
        }

        listClasses.clear();
        int i, n = newRelac.GetNumClasses();
        for( i = 0; i<n; i++ )
        {
            OBJLadoRelacion lado = newRelac.GetLadoRelacion( i+1 );
            listClasses.addItem( lado.GetClasse().GetNome() );
        }

        p_lado = null;
        textCard.setText( "" );
        textRotulo.setText( "" );

    }

    protected void ViewToData()
    {
        newRelac.SetNome( textName.getText() );

        if( radioAsso.getState() )
            newRelac.SetTipo( OBJRelacionamento.OBJ_ASSOCIACAO );
        else
        if( radioAgregRef.getState() )
            newRelac.SetTipo( OBJRelacionamento.OBJ_AGREGACAO );
        else
        if( radioAgregVal.getState() )
            newRelac.SetTipo( OBJRelacionamento.OBJ_AGREG_VALOR );
        else
        if( radioInst.getState() )
            newRelac.SetTipo( OBJRelacionamento.OBJ_INSTANCIACAO );
        else
        if( radioInhe.getState() )
            newRelac.SetTipo( OBJRelacionamento.OBJ_HERANCA );
        else
            newRelac.SetTipo( 0 );

        // PS: As Cardinalidades (e Rotulos) sao atualizadas conforme atualizacao
    }



*/
}

