/* ****************************************************************************
 * Universidade Federal do Rio de Janeiro
 * COPPE - PESC
 * Mrcio de Sousa Dias
 ******************************************************************************
 * COPSE - Cooperative Project Support Environment
 * Package: TOOL.UML.CLIENT
 * Classe:  UMLDlgRelationNew
 ******************************************************************************/

package TOOL.UML.CLIENT;


import  java.awt.*;
import  java.awt.event.*;
//import  java.util.*;

import  COPSE.*;
import  COPSE.CLIENT.*;
import  COPSE.CLIENT.GUI.*;
import  FILE.OBJ.*;
import  GRAPH.*;


/* ****************************************** BW *********************************************************** */
import  BW.*;
import  BW.kernel.*;
/* ****************************************** BW *********************************************************** */



/*************************************************************************
 *  Class UMLDlgRelationNew
 *************************************************************************/
public class    UMLDlgRelationNew
    extends     Dialog
    implements  ActionListener, WindowListener, TextListener
{
    protected   CGUIToolManager pToolManager;

    protected   CPolyline       pPolyline;
    protected   int             pClassesId[];
    protected   CSidePosition   pSidePositions[];


	protected   TextField       textName;

	protected   Checkbox        radioInhe;
	protected   Checkbox        radioAggregVal;
	protected   Checkbox        radioAggregRef;
	protected   Checkbox        radioAsso;
	protected   Checkbox        radioInst;

	protected   Button          btnOk;
	protected   Button          btnCancel;


	public UMLDlgRelationNew( CGUIToolManager tool, CPolyline poly, int classesId[], CSidePosition sides[])
	{
	    super( tool.GetGUIManager().GetMainWindow(), false );
	    pToolManager = tool;
	    pPolyline = poly;
	    pClassesId = classesId;
	    pSidePositions = sides;

		//{{INIT_CONTROLS
		setLayout(null);
		addNotify();

		Insets insets = getInsets();

		setSize(insets.left + insets.right + 300,insets.top + insets.bottom + 210);
		setFont(new Font("Helvetica", Font.PLAIN, 12));

		Label label = new Label("Name:");
		label.setBounds(insets.left + 14,insets.top + 15,56,15);
		add(label);

		textName = new TextField();
		//textName.setBounds(insets.left + 84,insets.top + 15,189,24);
		textName.setBounds(insets.left + 84,insets.top + 15,189,31);
		textName.addTextListener( this );
		add(textName);

		Panel panel = new Panel();
		panel.setLayout(null);
		panel.setBounds(insets.left + 14,insets.top + 60,343,90);
		add(panel);
    		label = new Label("Type:");
    		label.setBounds(insets.left + 14,insets.top + 45,70,15);
    		add(label);

    		CheckboxGroup group = new CheckboxGroup();
    		radioAsso = new Checkbox("Association", group, false);
    		radioAsso.setBounds(14,15,105,19);
    		panel.add(radioAsso);

    		radioAggregRef = new Checkbox("Aggregation (reference)", group, false);
    		radioAggregRef.setBounds(14,38,154,19);
    		panel.add(radioAggregRef);

    		radioAggregVal = new Checkbox("Aggregation (value)", group, false);
    		radioAggregVal.setBounds(14,60,140,19);
    		panel.add(radioAggregVal);

    		radioInhe = new Checkbox("Inheritance", group, false);
    		radioInhe.setBounds(189,15,105,19);
    		panel.add(radioInhe);

    		radioInst = new Checkbox("Instanciation", group, false);
    		radioInst.setBounds(189,38,112,19);
    		panel.add(radioInst);



		btnOk = new Button("Ok");
		btnOk.setBounds(insets.left + 84,insets.top + 180,87,26);
		btnOk.addActionListener( this );
		btnOk.setEnabled( false );
		add(btnOk);

		btnCancel = new Button("Cancel");
		btnCancel.setBounds(insets.left + 182,insets.top + 180,88,26);
		btnCancel.addActionListener( this );
		add(btnCancel);

		setTitle("New Relation");
		setResizable(false);
		//}}
	}

    public synchronized void setVisible( boolean visible )
    {
        if( visible )
        {
        	Rectangle bounds = getParent().getBounds();
        	Rectangle abounds = getBounds();

        	setLocation(bounds.x + (bounds.width - abounds.width)/ 2,
        	     bounds.y + (bounds.height - abounds.height)/2);
        	
/* ****************************************** BW *************************************** */        	
		GW_BW_Mediator.BeginEvent (CEvent.EvCOPSE_FileController_Element_New+1000);        	
/* ****************************************** BW *************************************** */

        }

    	super.setVisible(visible);
    }


    public void textValueChanged( TextEvent e )
    {
        if( e.getSource() == textName )
        {
            btnOk.setEnabled( !textName.getName().equals("") );
        }
    }


    // WindowEvent Listener methods
    public void windowOpened(WindowEvent e)         {}
    public void windowClosed(WindowEvent e)         {}
    public void windowClosing(WindowEvent e)        { _Close(false); }
    public void windowIconified(WindowEvent e)      { _Close(false); }
    public void windowDeiconified(WindowEvent e)    {}
    public void windowActivated(WindowEvent e)      {}
    public void windowDeactivated(WindowEvent e)    {}

    // ActionEvent Listener method
    public void actionPerformed( ActionEvent event )
    {
        Object source = event.getSource();

        if( source == btnCancel )
            _Close( false );
        else
        if( source == btnOk )
            _Close( true );

    }

    private void _Close( boolean ok )
    {
        if( ok )
        {
            try {
                int type = CObjRelation.Association;

                if( radioAsso.getState() )          type = CObjRelation.Association;
                else
                if( radioAggregRef.getState() )     type = CObjRelation.AggregationByRef;
                else
                if( radioAggregVal.getState() )     type = CObjRelation.AggregationByValue;
                else
                if( radioInhe.getState() )          type = CObjRelation.Inheritance;
                else
                if( radioInst.getState() )          type = CObjRelation.Instanciation;

                CObjRelation relation = new CObjRelation( type );
                relation.SetName( textName.getText() );
                relation.SetInternalPoints( pPolyline.GetPoints() );


                CEvent event = new CEvent( CEvent.EvCOPSE_FileController_Element_New );
                event.AddArgument( new Integer(pToolManager.GetClient().GetSessionManager().GetClientSession().GetConnectionId()) );
                event.AddArgument( relation );

                event.AddArgument( new Integer(pClassesId[0]) );
                event.AddArgument( new Integer(pClassesId[1]) );
                event.AddArgument( pSidePositions[0] );
                event.AddArgument( pSidePositions[1] );


                pToolManager.GetClient().Send( event );

/* ************************************************ BW **************************************************** */
		BW_Event BWEvent = new BW_Event (CEvent.EvCOPSE_FileController_Element_New+1000, typeIdDefault.UNSET);
		try {
			String BWRelationType = "";			
			String BWRelationName = new String (textName.getText());
			BWEvent.setDescription ("New Relation - "+BWRelationName);			
                	if( radioAsso.getState() )		BWRelationType = "Association";
                	else if( radioAggregRef.getState() )	BWRelationType = "Aggregation By Ref.";
                	else if( radioAggregVal.getState() )	BWRelationType = "Aggregation By Value";
                	else if( radioInhe.getState() )		BWRelationType = "Inheritance";
                	else if( radioInst.getState() )		BWRelationType = "Instanciation";		
			String BWDetails = new String ("Relacionamento "+BWRelationName+" do tipo "+BWRelationType+" adicionado ");
			BWEvent.setDetails (BWDetails);
		        BWDetails += " entre "+relation.GetExtremity(0).GetClass().GetName();
		        BWDetails += " e "+relation.GetExtremity(1).GetClass().GetName();
		        BWEvent.setDetails (BWDetails);
		} catch (Exception ex) {
		}
		GW_BW_Mediator.EndEvent (CEvent.EvCOPSE_FileController_Element_New+1000,BWEvent);		
/* ************************************************ BW **************************************************** */

            } catch( Exception e ) {}
        }
/* ************************************************ BW **************************************************** */
        else {
		GW_BW_Mediator.CancelEvent (CEvent.EvCOPSE_FileController_Element_New+1000);
        }
/* ************************************************ BW **************************************************** */

        setVisible( false );
        dispose();
    }


}