import BW.*;
import BW.kernel.*;
import java.util.*;

//@autor Manu
public class testNov2 {

        ///////////////////////// TESTES BW_TIMEINTERVAL /////////////////////////

	/*   TESTE  DE BW_TimeInetval QTO AS OPERACOES DE ALLEN
	 *   intervalo T	TTTTT
	 *   intervalo S      SSSSSSSSSS	
	 */
	public static void testTIAO () {
		BW_TimeInterval t = new BW_TimeInterval (Calendar.getInstance(), Calendar.getInstance());
		BW_TimeInterval s = new BW_TimeInterval (Calendar.getInstance(), Calendar.getInstance());		
		s.setBegin(t.getBegin());
		s.setEnd (t.getEnd());

                System.out.println ("--------- t (=s):  "+t.toString());
		System.out.println ("--------- t: rolling up t- 1 hour and t+ 1 day");	
		Calendar c2 = t.getEnd();
		c2.roll(Calendar.DATE,true);	
		t.setEnd ( c2 );
                Calendar c1 = t.getBegin();
                c1.roll (Calendar.HOUR,true);
	 	t.setBegin ( c1 );	 		
		System.out.println ("--------- t: "+t.toString());

		System.out.println ("--------- s: rolling s+ 1 days");		
		Calendar c3 = s.getEnd();
		c3.roll(Calendar.DATE,true);
		s.setEnd ( c3 );
		System.out.println ("--------- s: "+s);

		System.out.println ("--------- Comparing t and s");
		System.out.println ("t = s "+t.allanOperations ("=",s));
		System.out.println ("t < s "+t.allanOperations ("<",s));
		System.out.println ("t > s "+t.allanOperations (">",s));
		System.out.println ("t o s "+t.allanOperations ("o",s));
		System.out.println ("t oi s "+t.allanOperations ("oi",s));
		System.out.println ("t m s "+t.allanOperations ("m",s));
		System.out.println ("t mi s "+t.allanOperations ("mi",s));
		System.out.println ("t d s "+t.allanOperations ("d",s));
		System.out.println ("t di s "+t.allanOperations ("di",s));
		System.out.println ("t s s "+t.allanOperations ("s",s));
		System.out.println ("t si s "+t.allanOperations ("si",s));
		System.out.println ("t f s "+t.allanOperations ("f",s));
		System.out.println ("t fi s "+t.allanOperations ("fi",s));
	}

	/*
	 * TESTE DE BW_TimeInterval QTO AO METODO SETFIELDS
	 */
	public static void testTIFields () {
		Calendar c = Calendar.getInstance();
		c.roll(Calendar.DATE,true);
		BW_TimeInterval t = new BW_TimeInterval (Calendar.getInstance(),c);
		System.out.println ("--------- before: "+t);
		Hashtable h = t.getFields();
		BW_TimeInterval s = new BW_TimeInterval (0,0);		
		s.setFields (h);
		System.out.println ("--------- after: "+s);
	
	}
	
	/*
	 * teste merge de intervalos
	 */
	public static void testTIMerge () {
		Calendar c = Calendar.getInstance();
		c.roll (Calendar.DATE,true);
		BW_TimeInterval ti1 = new BW_TimeInterval (10,10,TimeZone.getTimeZone ("GMT"),Locale.getDefault());
		ti1.setEnd (c);

		c.roll (Calendar.DATE,true);
		BW_TimeInterval ti2 = new BW_TimeInterval (11,11,TimeZone.getTimeZone ("GMT"),Locale.getDefault());
		ti2.setEnd (c);	
		BW_TimeInterval ti3 = ti1.merge (ti2);
		System.out.println ("ti1: "+ti1);
		//ti1.setTimeZone ("GMT");
		//System.out.println ("ti1 (GMT): "+ti1);
		System.out.println ("ti2: "+ti2);
		//ti2.setTimeZone ("GMT");
		//System.out.println ("ti2 (GMT): "+ti2);
		System.out.println ("ti3: "+ti3);		
	
	}

	/** invertendo os intervalos 
	 */
	public static void  testTIinv () {
		System.out.println ("=--------------------------=");
		Calendar c1 = Calendar.getInstance ();
		c1.set ( 2001 , 2 , 27 , 16 , 51 , 16 );
		Calendar c2 = Calendar.getInstance ();
		c2.set ( 2001 , 11 , 28 , 16 , 50 , 16 );
		System.out.println ("c1: "+c1.get(Calendar.DAY_OF_MONTH)+"/"+
				           c1.get(Calendar.MONTH)+"/"+
					   c1.get(Calendar.YEAR) +" - "+
					   c1.get(Calendar.HOUR_OF_DAY) + ":" +
					   c1.get(Calendar.MINUTE) + ":" +
					   c1.get(Calendar.SECOND));

		System.out.println ("c2: "+c2.get(Calendar.DATE)+"/"+
				           c2.get(Calendar.MONTH)+"/"+
					   c2.get(Calendar.YEAR) +" - "+
					   c2.get(Calendar.HOUR_OF_DAY) + ":" +
					   c2.get(Calendar.MINUTE) + ":" +
					   c2.get(Calendar.SECOND));
		
		BW_TimeInterval ti1 = new BW_TimeInterval();
		ti1.setBegin (c1);
		ti1.setEnd (c2);
		System.out.println (ti1);
		
		BW_TimeInterval ti2 = new BW_TimeInterval();
		ti2.setBegin (c2);
		ti2.setEnd (c1);
		System.out.println (ti2);
		
		BW_TimeInterval ti3 = new BW_TimeInterval();
		ti3.setBegin (c2.getTime().getTime());
		ti3.setEnd (c1.getTime().getTime());
		System.out.println (ti3);
		
		ti3 = new BW_TimeInterval();
		ti3.setInterval (c1,c2);
		System.out.println (ti3);
		ti3 = new BW_TimeInterval();
		ti3.setInterval (c2,c1);
		System.out.println (ti3);


	}
	
	/////////////////////// TESTES BWEVENT ///////////////////////////////////
	public static BW_Event evtTest () {
        	String login = System.getProperty ("user.name");
		int uid = 150;
        	BW_Member mb = new BW_Member (login, uid);
	        BW_TimeInterval tmi = new BW_TimeInterval(typeIdDefault.BW_TIMEINTERVAL,typeIdDefault.BW_TIMEINTERVAL*10+3);
	        Calendar c = tmi.getBegin();
	        c.roll (Calendar.DATE,false);
                tmi.setBegin (c);

        	mb.setName ((mb.getLogin()).toUpperCase()+" ETC");
		mb.setMail ((login+"@localhost"));
		mb.setHomePage (("http://localhost/~"+login));
		mb.setMachine ("localhost");
		mb.setLastLogin (tmi);

	        tmi = new BW_TimeInterval(typeIdDefault.BW_TIMEINTERVAL,typeIdDefault.BW_TIMEINTERVAL*10+4);
	        c = tmi.getBegin();
	        c.roll (Calendar.HOUR,false);
                tmi.setBegin (c);		
		BW_Event evt = new BW_Event (0,11,mb);
		evt.setName ("Teste");
	        evt.setDescription ("evento de teste");
		evt.setDetails ("evento para testar funcionamento da classe");
		evt.setInterval (tmi);
        	
                return evt;		
	}
	
        public static void testEVT () {
                BW_Event evt = evtTest();
                System.out.println ("--------- Before: "+evt);
                Hashtable ht = evt.getFields();
                BW_Event evt2 = new BW_Event();
                evt2.setFields (ht);
                System.out.println ("--------- After: "+evt2);
        }
	
        /////////////////////// TESTES EM BW_PROFILE ////////////////////////////
        public static void testPROF () {
        	BW_Profile prof = new BW_Profile();

        	System.out.println ("--------- original profile: "+prof);
        		
	        BW_TimeInterval tmi = new BW_TimeInterval(typeIdDefault.BW_TIMEINTERVAL,typeIdDefault.BW_TIMEINTERVAL+typeIdDefault.OBJID+3);
	        Calendar c = tmi.getEnd();
	        c.roll (Calendar.DATE,true);
                tmi.setEnd (c);
        	
                prof.setInterval (tmi);

                BW_Event evt = evtTest();
                prof.insertEvent (evt);

                System.out.println ("--------- new profile: "+prof);

                Hashtable ht = prof.getFields();
                BW_Profile prof2 = new BW_Profile();
                if (prof2.setFields (ht))
	                System.out.println ("--------- profile after setFields: "+prof2);
	        else	System.out.println ("--------- error in get/set fields: "+ht);


                if (prof.verifyEvent(evt)) {
                	System.out.println ("--------- removing...");
                	prof.removeEvent (evt);
                } else System.out.println ("--------- error not found");

                System.out.println ("--------- profile after removing: "+prof);

        }	

        /////////////////////// TESTES SOBRE BW_REGISTER ////////////////////////

        public static void testREG () {
        	BW_Register reg = new BW_Register();
        	BW_Event evt = evtTest();
        	reg.insertEvent (evt);
        	System.out.println ("--------- Before: "+reg);
        	Hashtable ht = reg.getFields();
        	BW_Register reg2 = new BW_Register();
        	reg2.setFields (ht);
        	System.out.println ("--------- After: "+reg2);

        }	

        //////////////////////// TESTES SOBRE PAPER ////////////////////////////

        public static void testPAP () {
         	BW_Paper papel = new BW_Paper (BW_Paper.MAXIMUM, "autor");
         	papel.setDescription ("participante do grupo");
         	System.out.println ("--------- Original: "+papel);
         	
         	BW_Event evt = evtTest();
         	BW_Profile prof = papel.getProfile();
         	prof.insertEvent (evt);
         	System.out.println ("profile: "+prof);
         	papel.setProfile (prof);
         	System.out.println ("--------- Before: "+papel);
         	
         	Hashtable ht = papel.getFields();
         	BW_Paper papel2 = new BW_Paper();
         	papel2.setFields (ht);
         	System.out.println ("--------- After: "+papel2);         	         	
        }


        /////////////////////// TESTES BW_AWARENESSPROFILE ///////////////////////
        public static void testAWP (){
		BW_Profile pers1 = new BW_Profile (typeIdDefault.BW_PERSONALPROFILE,typeIdDefault.BW_PERSONALPROFILE + typeIdDefault.OBJID + 1) ;
		BW_Profile pers2 = new BW_Profile (typeIdDefault.BW_PERSONALPROFILE,typeIdDefault.BW_PERSONALPROFILE + typeIdDefault.OBJID + 2) ;
		BW_Profile papp1 = new BW_Profile (typeIdDefault.BW_PERSONALPAPERPROFILE,typeIdDefault.BW_PERSONALPAPERPROFILE + typeIdDefault.OBJID + 1);
		BW_Profile papp2 = new BW_Profile (typeIdDefault.BW_PERSONALPAPERPROFILE,typeIdDefault.BW_PERSONALPAPERPROFILE + typeIdDefault.OBJID + 2);

		BW_Event evt1 = evtTest();
		evt1.setTypeId (1001);
		evt1.setName ("Evento tipo 1");		
		pers1.insertEvent (evt1);
		pers2.insertEvent (evt1);

		evt1 = evtTest();
		evt1.setTypeId (1002);
		evt1.setName ("Evento tipo 2");
		pers1.insertEvent (evt1);

		evt1 = evtTest();
		evt1.setTypeId (1003);
		evt1.setName ("Evento tipo 3");
		papp1.insertEvent (evt1);

		evt1 = evtTest();
		evt1.setTypeId (1004);
		evt1.setName ("Evento tipo 4");
		papp2.insertEvent (evt1);
		
		evt1 = evtTest();
		evt1.setTypeId (1005);
		evt1.setName ("Evento tipo 5");
		papp2.insertEvent (evt1);
		
                BW_TimeInterval itv = new BW_TimeInterval (0,0);
                Calendar cal = itv.getEnd();
                cal.roll (Calendar.DATE,true);
                itv.setEnd (cal);
                pers1.setInterval (itv);

                cal = itv.getEnd();
                cal.roll (Calendar.DATE,false);
                itv.setEnd(cal);
                cal = itv.getBegin();
                cal.roll (Calendar.DATE,false);
                itv.setBegin(cal);
                pers2.setInterval (itv);

                cal.roll (Calendar.DATE,false);
                itv.setBegin (cal);
                papp1.setInterval (itv);

                cal.roll (Calendar.DATE,false);
                itv.setBegin (cal);
                papp2.setInterval (itv);

		BW_Paper paper1 = new BW_Paper(typeIdDefault.BW_PAPER,typeIdDefault.BW_PAPER + typeIdDefault.OBJID + 1);
		paper1.setDescription ("papel 1");
		paper1.setLevel (BW_Paper.MAXIMUM);
		paper1.setName ("PAP1");

		BW_Paper paper2 = new BW_Paper(typeIdDefault.BW_PAPER,typeIdDefault.BW_PAPER + typeIdDefault.OBJID + 2);
		paper2.setDescription ("papel 2");
		paper1.setLevel (BW_Paper.MINIMUM);
		paper1.setName ("PAP2");
				
		
		BW_AwarenessProfile prof = new BW_AwarenessProfile ();
		System.out.println ("Inserindo Profiles pessoais...");
		prof.insertPersonalProfile (pers1);
		prof.insertPersonalProfile (pers2);
		System.out.println ("Inserindo Profiles pessoais por papel...");
		prof.insertPersonalPaperProfile (papp1,paper1);
		prof.insertPersonalPaperProfile (papp2,paper2);

		System.out.println (prof);

		System.out.println ("Profile pers1 esta presente? "+prof.verifyPersonalProfile (pers1));
		BW_Profile p = prof.getPersonalProfile (1);
		evt1 = evtTest();
		evt1.setTypeId (1003);
		evt1.setName ("Evento tipo 3");
		System.out.println ("Evento tipo 3 esta presente no 1o profile pessoal? "+p.verifyEvent (evt1));

		System.out.println ("Profile para o papel1 esta presente? "+prof.verifyPersonalPaperProfile (paper1));
		p = prof.getPersonalPaperProfile (paper1);
		evt1 = evtTest();
		evt1.setTypeId (1003);
		evt1.setName ("Evento tipo 3");
		System.out.println ("Evento tipo 3 esta presente no profile pessoal para paper1? "+p.verifyEvent (evt1));

		System.out.println ("resgatando campos");
		Hashtable ht = prof.getFields();
		/*System.out.println ("campos resgatados: ");
		Enumeration fields = ht.keys();
		while (fields.hasMoreElements ()) System.out.println ("-- element: "+fields.nextElement().toString());	
		System.out.println ("Olhando personal...");
		Vector v = (Vector) ht.get ("personal");
		fields = v.elements();
		while (fields.hasMoreElements ()) System.out.println ("-- element: "+fields.nextElement().toString());	
		System.out.println ("olhando personal paper");
		Hashtable h = (Hashtable) ht.get ("personalpaper");
		fields = h.keys();
		while (fields.hasMoreElements ()) System.out.println ("-- element: "+fields.nextElement().toString());	
		*/

		System.out.println ("clonando objeto");
		BW_AwarenessProfile prof2 = (BW_AwarenessProfile)prof.clone();

		System.out.println ("removendo profiles....");
		prof.removePersonalProfile (pers1);
		prof.removePersonalPaperProfile (paper1);
		System.out.println ("Profile pers1 esta presente? "+prof.verifyPersonalProfile (pers1));
		System.out.println ("Profile para o papel1 esta presente? "+prof.verifyPersonalPaperProfile (paper1));
		System.out.println ("profile atual: "+prof);

		System.out.println ("verificando clone...");
		System.out.println ("Profile pers1 esta presente? "+prof2.verifyPersonalProfile (pers1));
		System.out.println ("Profile para o papel1 esta presente? "+prof2.verifyPersonalPaperProfile (paper1));
		
		System.out.println ("clone: "+prof2);
		Hashtable htevt = prof2.getAllPersonalEvents();
		/*System.out.println ("todos eventos pessoais do clone: ");
		Enumeration en = htevt.keys();
		while (en.hasMoreElements ()) System.out.println ("-- element: "+en.nextElement().toString());	
		*/
		System.out.println ("remontando original");
		prof = new BW_AwarenessProfile(0,0);
		prof.setFields (ht);
		//System.out.println ("profile: "+prof);
		System.out.println ("Profile pers1 esta presente? "+prof.verifyPersonalProfile (pers1));
		System.out.println ("Profile para o papel1 esta presente? "+prof.verifyPersonalPaperProfile (paper1));
		
		htevt = prof.getAllPersonalEvents();
		System.out.println ("todos eventos pessoais: ");
		Enumeration en = htevt.keys();
		while (en.hasMoreElements ()) System.out.println ("-- "+en.nextElement().toString());	
		htevt = prof.getAllPaperEvents();
		System.out.println ("todos eventos dos papeis: ");
		en = htevt.keys();
		while (en.hasMoreElements ()) System.out.println ("-- "+en.nextElement().toString());	
		
		System.out.println ("Intervalo Pessoal Global: "+prof.getGlobalInterval().toString());
		
		//System.out.println (prof);
        }


        //////////////////////// TESTES BW_MEMBER ///////////////////////////////
        public static void testMemb () {
                BW_Member memb = new BW_Member ("teste",500);

                memb.setName ("usuario de teste");
                memb.setMachine ("localhost");

                BW_TimeInterval tiv = new BW_TimeInterval ();
                Calendar c = tiv.getBegin();
                c.roll (Calendar.MONTH,false);
                tiv.setBegin(c);
                c = tiv.getEnd();
                c.roll (Calendar.DATE,false);
                c.roll (Calendar.DATE,false);
                tiv.setEnd (c);
                memb.setLastLogin (tiv);

                BW_Profile prof = new BW_Profile (typeIdDefault.BW_PERSONALPROFILE,typeIdDefault.BW_PERSONALPROFILE+typeIdDefault.OBJID);
                tiv.setBegin (c);
                c = Calendar.getInstance();
                tiv.setEnd (c);
                prof.setInterval (tiv);
                BW_Event evt = evtTest ();
                prof.insertEvent (evt);
                BW_AwarenessProfile awp = memb.getAwarenessProfile();
                awp.insertPersonalProfile (prof);
                System.out.println ("awareness profile:" +awp);
                memb.setAwarenessProfile (awp);

                BW_Paper pap = new BW_Paper(typeIdDefault.BW_PERSONALPAPERPROFILE,typeIdDefault.BW_PERSONALPAPERPROFILE+typeIdDefault.OBJID);
                pap.setLevel (pap.getMAXIMUM());
                pap.setName ("coordenator");
                pap.setDescription ("coordenador do projeto");
                pap.setProfile (prof);

                evt = evtTest();
                evt.setTypeId (101); evt.setObjId (101);
                BW_Profile prof2 = new BW_Profile (typeIdDefault.BW_PERSONALPAPERPROFILE,typeIdDefault.BW_PERSONALPAPERPROFILE+typeIdDefault.OBJID+1);
                prof2.setInterval (evt.getInterval());
                prof2.insertEvent (evt);

                memb.insertPaper (pap,prof2);

                pap = new BW_Paper(typeIdDefault.BW_PERSONALPAPERPROFILE,typeIdDefault.BW_PERSONALPAPERPROFILE+typeIdDefault.OBJID+1);
                pap.setLevel (pap.getMINIMUM());
                pap.setName ("participante");
                pap.setDescription ("participante do projeto");
                pap.setProfile (prof);

                evt = evtTest();
                tiv = evt.getInterval();
                c = tiv.getBegin();
                c.roll (Calendar.DATE,false);
                tiv.setBegin (c);
                evt.setInterval (tiv);
                evt.setTypeId (102); evt.setObjId (102);
                prof2 = new BW_Profile (typeIdDefault.BW_PERSONALPAPERPROFILE,typeIdDefault.BW_PERSONALPAPERPROFILE+typeIdDefault.OBJID+2);
                prof2.setInterval (evt.getInterval());
                prof2.insertEvent (evt);

                memb.insertPaper (pap,prof2);

                System.out.println ("-- Member: "+memb);
                Hashtable ht2 =  memb.getFields();

                memb.removePersonalProfile (prof);
                memb.removePaper ("participante");
                BW_Member m2 = (BW_Member)memb.clone();
                System.out.println ("--- Member apos remove: "+m2);

                memb.setFields(ht2);
                System.out.println ("---- Member restaurado: "+memb);

        }

        //////////////////////// TESTES BW_GROUP ////////////////////////////////////////
        public static void testGRP () {
        	BW_Group grp = new BW_Group("teste",typeIdDefault.BW_GROUP);
        	grp.setDescription ("grupo de teste");
        	
		//criar profile exemplo
        	BW_Event evt = evtTest();
        	evt.setTypeId (1001);	evt.setObjId (1001);
		evt.setName ("exemplo");		
        	BW_Profile prof = new BW_Profile ();
        	prof.insertEvent (evt);
		

        	//incluir papel 
         	BW_Paper papel = new BW_Paper (BW_Paper.MAXIMUM, "autor");
         	papel.setDescription ("participante do grupo");
        	papel.setProfile (prof);

		grp.insertPaper (papel);
        	        	
        	//incluir membro
		BW_Member mb = new BW_Member ("user",500);
		mb.insertPaper (papel,prof);
		mb.insertPersonalProfile(prof);
        	
		grp.insertMember (mb);

        	//toString
		System.out.println ("----- Grupo: "+grp.toString());

		//clone e getFields
		System.out.println ("----- clonando e capturando campos...");
		BW_Group grp2 = (BW_Group) grp.clone();
		Hashtable fields = grp.getFields();
 
		//aplica verify Member e Paper
		System.out.println ("----- No clone: papel? "+grp2.verifyPaper (papel));
		System.out.println ("----- No clone: membro? "+grp2.verifyMember (mb));
        	
        	//get e remove 1 papel e 1 membro
		BW_Member mb2 = grp.getAMember (mb.getObjId());
		BW_Paper pap2 = grp.getAPaper (papel.getName());
		grp.removeMember (mb2);
		grp.removePaper (pap2);		
        	
        	//verify papel e membro removidos
		System.out.println ("----- No clone: papel? "+grp2.verifyPaper (papel));
		System.out.println ("----- No clone: membro? "+grp2.verifyMember (mb));
		System.out.println ("----- No original: papel? "+grp.verifyPaper (papel));
		System.out.println ("----- No original: membro? "+grp.verifyMember (mb));

		//setFields
		System.out.println ("----- remontando .... ");
		grp.setFields (fields);

		//verify de novo
		System.out.println ("----- No clone: papel? "+grp2.verifyPaper (papel));
		System.out.println ("----- No clone: membro? "+grp2.verifyMember (mb));
		System.out.println ("----- No original: papel? "+grp.verifyPaper (papel));
		System.out.println ("----- No original: membro? "+grp.verifyMember (mb));

		//forcando um erro - erro corrigido!
		/* System.out.println ("... forcando um erro: Member.setFields (Group.getFields()) ... ");
		System.out.println ("... membro: "+mb);
		System.out.println ("... criando o erro: "+mb.setFields(grp.getFields()));
		System.out.println ("... membro: "+mb);
		 System.out.println ("... fields: homepage " +fields.containsKey("homepage")+", mail "+fields.containsKey("mail")
								+",login "+fields.containsKey("login")+", name "+fields.containsKey("name")
								+",machine "+fields.containsKey("machine")+",profiles "+fields.containsKey("profiles"));
		*/
		
		System.out.println ("--- Testando alteracoes nos membros...");
		BW_Member mb3 = (BW_Member) grp.getAMember(500).clone();
		mb3.setName ("Meu Nome");
		mb3.setMail ("nome@host");
		grp.setAMember (mb3.getObjId(),mb3);
		System.out.println ("--- grupo: "+grp);
		//Usando o getAMember().clone() em conjunto com o setAMember
		//o grupo clone nao eh afetado, so o original
		//System.out.println ("--- grupo: "+grp2);
        }


	/////////////////////// MAIN ////////////////////////////////////////////
	public static void main (String args[]) {
	
	    for (int i=0;i<args.length;i++) {
	        int j = Integer.parseInt (args[i]);
		switch (j) {	
		case 1:
			System.out.println ("******************** testing allan operations...");
			testTIAO();
                	testTIFields();
                	testTIMerge();
			testTIinv();
                        break;
                case 2:
	                System.out.println ("\n");
        	        System.out.println ("******************** testing events...");
                	testEVT();
                	break;
                	
                case 3:	
	                System.out.println ("\n");
        	        System.out.println ("******************** testing register...");
                	testREG();
                	break;

                case 4:
	                System.out.println ("\n");
        	        System.out.println ("******************** testing profiles...");
                	testPROF();
                        break;

                case 5:
	                System.out.println ("\n");
        	        System.out.println ("******************** testing papers...");
                	testPAP();
                	break;
                	
                case 6:
                	System.out.println ("\n");
                	System.out.println ("********************* testing awareness profile...");
                	testAWP();
                	break;
                	
                case 7:
                	System.out.println ("\n");
                	System.out.println ("******************** testing members...");
                	testMemb();
                	break;
                	
                case 8:
                	System.out.println ("\n");
                	System.out.println ("******************* testing group...");
                	testGRP();
                	break;
              }
           }
	}
}
